/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_mmxmem_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern16 (x1); /* [-1, 1] */
}

int
pattern21 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern6 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern6 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern25 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern25 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern25 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern25 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern25 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern25 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern25 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern25 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern25 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V32QImode:
      if (pattern5 (x3, 
E_V32QImode) != 0)
        return -1;
      return 9;

    case E_V16HImode:
      if (pattern5 (x3, 
E_V16HImode) != 0)
        return -1;
      return 10;

    case E_V8SImode:
      if (pattern5 (x3, 
E_V8SImode) != 0)
        return -1;
      return 11;

    case E_V16SImode:
      if (pattern5 (x3, 
E_V16SImode) != 0)
        return -1;
      return 12;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 13;

    case E_V8DImode:
      if (pattern5 (x3, 
E_V8DImode) != 0)
        return -1;
      return 14;

    case E_V4DImode:
      if (pattern5 (x3, 
E_V4DImode) != 0)
        return -1;
      return 15;

    case E_V2DImode:
      if (pattern5 (x3, 
E_V2DImode) != 0)
        return -1;
      return 16;

    case E_V64QImode:
      if (pattern5 (x3, 
E_V64QImode) != 0)
        return -1;
      return 17;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 18;

    case E_V32HImode:
      if (pattern5 (x3, 
E_V32HImode) != 0)
        return -1;
      return 19;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern14 (x3, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern14 (x3, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern14 (x3, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern25 (x1, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern25 (x1, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern25 (x1, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern25 (x1, 
E_V32HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern25 (x1, 
E_V16HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern25 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i2))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!nonimmediate_operand (operands[4], i2))
    return -1;
  x9 = XEXP (x1, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], i1))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x9) != i1)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern104 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern104 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern122 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern127 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern127 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern127 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern127 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern127 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern127 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern152 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern152 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern152 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern152 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern152 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern152 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern152 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern152 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern152 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      return pattern168 (x3, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SFmode:
      if (pattern168 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SFmode:
      if (pattern168 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern182 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern182 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern182 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern182 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern182 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern182 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern182 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern182 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern182 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V64QImode:
      if (pattern182 (x1, 
E_V64QImode) != 0)
        return -1;
      return 9;

    case E_V32QImode:
      if (pattern182 (x1, 
E_V32QImode) != 0)
        return -1;
      return 10;

    case E_V16QImode:
      if (pattern182 (x1, 
E_V16QImode) != 0)
        return -1;
      return 11;

    case E_V32HImode:
      if (pattern182 (x1, 
E_V32HImode) != 0)
        return -1;
      return 12;

    case E_V16HImode:
      if (pattern182 (x1, 
E_V16HImode) != 0)
        return -1;
      return 13;

    case E_V8HImode:
      if (pattern182 (x1, 
E_V8HImode) != 0)
        return -1;
      return 14;

    case E_V16SImode:
      if (pattern182 (x1, 
E_V16SImode) != 0)
        return -1;
      return 15;

    case E_V8SImode:
      if (pattern182 (x1, 
E_V8SImode) != 0)
        return -1;
      return 16;

    case E_V4SImode:
      if (pattern182 (x1, 
E_V4SImode) != 0)
        return -1;
      return 17;

    case E_V8DImode:
      if (pattern182 (x1, 
E_V8DImode) != 0)
        return -1;
      return 18;

    case E_V4DImode:
      if (pattern182 (x1, 
E_V4DImode) != 0)
        return -1;
      return 19;

    case E_V2DImode:
      if (pattern182 (x1, 
E_V2DImode) != 0)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern14 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern14 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern14 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern205 (x1); /* [-1, 3] */
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern206 (x1); /* [-1, 3] */
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonimmediate_operand (operands[2], E_QImode))
    return -1;
  return pattern205 (x1); /* [-1, 3] */
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern211 (x6, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern211 (x6, 
E_TImode) != 0)
        return -1;
      return 1;

    case E_QImode:
      if (pattern211 (x6, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_HImode:
      if (pattern211 (x6, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_SImode:
      if (pattern211 (x6, 
E_SImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 8L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x4, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x4, 0);
  operands[0] = x7;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern271 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 0;

        case E_HImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 2;

        case E_HImode:
          return 3;

        case E_SImode:
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern292 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern163 (x1, 
E_DImode, 
E_V64QImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern314 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_SELECT)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL)
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x7, 0);
  operands[2] = x10;
  x11 = XEXP (x1, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[4] = x12;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 8:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XVECEXP (x5, 0, 2);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x16 = XVECEXP (x5, 0, 3);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x5, 0, 4);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x18 = XVECEXP (x5, 0, 5);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x19 = XVECEXP (x5, 0, 6);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x20 = XVECEXP (x5, 0, 7);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x8, 0) != 8)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x23 = XVECEXP (x8, 0, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x24 = XVECEXP (x8, 0, 3);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x25 = XVECEXP (x8, 0, 4);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x26 = XVECEXP (x8, 0, 5);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x27 = XVECEXP (x8, 0, 6);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x28 = XVECEXP (x8, 0, 7);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern313 (x1, 
E_V8DImode, 
E_V16SImode, 
E_V8SImode) != 0)
        return -1;
      return 0;

    case 4:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XVECEXP (x5, 0, 2);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x16 = XVECEXP (x5, 0, 3);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x8, 0) != 4)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x23 = XVECEXP (x8, 0, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x24 = XVECEXP (x8, 0, 3);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern313 (x1, 
E_V4DImode, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case 2:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x8, 0) != 2)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || GET_MODE (x3) != E_V2DImode
          || GET_MODE (x4) != E_V2SImode
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x6) != E_V2DImode
          || GET_MODE (x7) != E_V2SImode
          || !vector_operand (operands[2], E_V4SImode)
          || !nonimm_or_0_operand (operands[3], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern348 (x1, 
E_QImode, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern363 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !memory_operand (operands[0], i1)
      || !nonmemory_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !ix86_comparison_operator (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !ix86_comparison_operator (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern380 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern385 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern384 (x6, 
37); /* [-1, 0] */
}

int
pattern395 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 21
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != CONST
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x4, 0, 0);
  operands[1] = x13;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x14 = XVECEXP (x4, 0, 1);
  operands[2] = x14;
  if (!constant_call_address_operand (operands[2], E_VOIDmode))
    return -1;
  x15 = XVECEXP (x7, 0, 0);
  operands[3] = x15;
  if (!tls_symbolic_operand (operands[3], E_VOIDmode))
    return -1;
  x16 = XEXP (x8, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x17 = XEXP (x9, 0);
  operands[5] = x17;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern417 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LTU)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode
      || !nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || GET_MODE (x2) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern259 (x5, 
E_DImode, 
E_TImode); /* [-1, 1] */
}

int
pattern434 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern442 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      operands[3] = x3;
      x4 = XEXP (x1, 0);
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      return pattern440 (x1); /* [-1, 1] */

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_QImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      x6 = XEXP (x4, 1);
      if (!nonmemory_operand (x6, E_QImode))
        return -1;
      switch (XWINT (x8, 0))
        {
        case 64L:
          if (pattern441 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case 32L:
          if (pattern441 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern478 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern486 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  x7 = XEXP (x1, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          return pattern480 (x1, 
E_V16SImode, 
E_HImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern480 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern480 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[5] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern485 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SImode:
          if (pattern485 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern485 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern498 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V2HFmode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_MODE (x7) != E_V2HFmode
          || !vector_operand (operands[1], i1)
          || GET_MODE (x3) != E_V2HFmode
          || !nonimm_or_0_operand (operands[2], E_V8HFmode)
          || !const0_operand (operands[4], E_V6HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (pattern497 (x1, 
E_V2SFmode, 
E_V4SFmode, 
i1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern506 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern511 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!nonimmediate_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !permvar_truncate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1)
      || !regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern533 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern532 (x1); /* [-1, 11] */

    case IOR:
      res = pattern532 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    case XOR:
      res = pattern532 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern528 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 36;

        case E_V16HFmode:
          if (pattern528 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 37;

        case E_V8HFmode:
          if (pattern528 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 38;

        case E_V32BFmode:
          if (pattern528 (x1, 
E_V32BFmode) != 0)
            return -1;
          return 39;

        case E_V16BFmode:
          if (pattern528 (x1, 
E_V16BFmode) != 0)
            return -1;
          return 40;

        case E_V8BFmode:
          if (pattern528 (x1, 
E_V8BFmode) != 0)
            return -1;
          return 41;

        case E_V16SFmode:
          if (pattern528 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 42;

        case E_V8SFmode:
          if (pattern528 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 43;

        case E_V4SFmode:
          if (pattern528 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 44;

        case E_V8DFmode:
          if (pattern528 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 45;

        case E_V4DFmode:
          if (pattern528 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 46;

        case E_V2DFmode:
          if (pattern528 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern552 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern551 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern551 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern562 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode)
      || !x86_64_general_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern573 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const123_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern430 (x1); /* [-1, 1] */
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x2), 0))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          return pattern575 (x1); /* [-1, 3] */

        case PLUS:
          res = pattern575 (x1);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        case MINUS:
          x4 = XEXP (x3, 0);
          operands[3] = x4;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern574 (x1);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        default:
          return -1;
        }

    case AND:
      res = pattern576 (x1);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    case PLUS:
      res = pattern576 (x1);
      if (res >= 0)
        return res + 16; /* [16, 19] */
      return -1;

    case MINUS:
      x3 = XEXP (x2, 0);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      res = pattern574 (x1);
      if (res >= 0)
        return res + 20; /* [20, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (!commutative_operator (x2, E_VOIDmode))
    return -1;
  operands[3] = x2;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XEXP (x1, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern599 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_CCZmode
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !vector_operand (operands[1], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !vector_operand (operands[1], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !vector_operand (operands[1], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !vector_operand (operands[1], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode)
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !vector_operand (operands[1], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 5;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !vector_operand (operands[1], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      return 6;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !vector_operand (operands[1], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode)
        return -1;
      return 7;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !vector_operand (operands[1], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      return 8;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !vector_operand (operands[1], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      return 9;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !vector_operand (operands[1], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      return 10;

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || !vector_operand (operands[1], E_V2TImode)
          || GET_MODE (x3) != E_V2TImode)
        return -1;
      return 11;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !vector_operand (operands[1], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode)
        return -1;
      return 12;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !vector_operand (operands[1], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[4] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern642 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern642 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern642 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern642 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern642 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern642 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern642 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern642 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern642 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern644 (x1);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern665 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern670 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  return pattern669 (x2); /* [-1, 0] */
}

int
pattern673 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  return 0;
}

int
pattern679 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCZmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  return 0;
}

int
pattern686 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern684 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern684 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern685 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern685 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern695 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern245 (x1); /* [-1, 1] */
}

int
pattern702 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_DImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern710 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const_scalar_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern718 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern722 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      return 0;

    case PARALLEL:
      return 1;

    default:
      return -1;
    }
}

int
pattern728 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern731 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern730 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern730 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern739 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern744 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4SImode
          || GET_MODE (x3) != E_V4SImode
          || GET_MODE (x5) != E_V4SImode
          || !register_mmxmem_operand (operands[1], E_V4HImode)
          || GET_MODE (x4) != E_V4SImode
          || !register_mmxmem_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode
          || GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[1], E_V2HImode)
          || GET_MODE (x4) != E_V2SImode
          || !register_operand (operands[2], E_V2HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern768 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern772 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern771 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern771 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern771 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern780 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern788 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern795 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern804 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern813 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  return pattern812 (x9, pnum_clobbers); /* [-1, 1] */
}

int
pattern820 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern830 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern839 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || !nonmemory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || !x86_64_szext_nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      return 3;

    case E_TImode:
      if (GET_MODE (x2) != E_TImode
          || !nonimmediate_operand (operands[0], E_TImode)
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern851 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !binary_fp_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern861 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern867 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern866 (x1, 
E_DImode, 
E_V64QImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      res = pattern863 ();
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern875 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern852 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern852 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern884 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern894 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || GET_MODE (x3) != i2)
    return -1;
  x9 = XEXP (x3, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern137 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern137 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern906 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern908 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern912 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern914 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern918 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  return 0;
}

int
pattern926 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern812 (x6, pnum_clobbers); /* [-1, 1] */
}

int
pattern934 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern941 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern203 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern203 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern948 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 4)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x3 = XEXP (x1, 1);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 2)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != ASHIFTRT
          || GET_MODE (x6) != i1)
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x9 = XEXP (x6, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 0);
      operands[3] = x13;
      if (!memory_operand (operands[3], i1))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      return 0;

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x15 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != ASHIFTRT
          || GET_MODE (x16) != i1)
        return -1;
      x17 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x17) != CLOBBER)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 17
          || GET_MODE (x18) != E_CCmode)
        return -1;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x20 = XEXP (x16, 1);
      operands[4] = x20;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x21 = XEXP (x16, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != SET)
        return -1;
      x22 = XEXP (x4, 0);
      operands[3] = x22;
      if (!memory_operand (operands[3], i1))
        return -1;
      x23 = XEXP (x4, 1);
      if (!rtx_equal_p (x23, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern971 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern977 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[2], E_V32HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !nonimmediate_operand (operands[2], E_V32QImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern988 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern990 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern1001 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case NOT:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!const_0_to_7_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern1000 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 1;

        case E_V16QImode:
          if (pattern1000 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1017 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1024 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1032 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern1031 (x6) != 0)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern1092 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1097 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1110 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i3
      || !vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V32HFmode
      || !register_operand (operands[0], E_V32HFmode)
      || GET_MODE (x1) != E_V32HFmode
      || !register_operand (operands[1], E_V32HFmode)
      || !register_operand (operands[2], E_V32HFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  if (!register_operand (operands[3], E_V32HFmode)
      || !const_4_or_8_to_11_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern1131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !palignr_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 3);
  operands[4] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1136 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1136 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1149 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      return pattern1155 (x1); /* [-1, 3] */

    case PLUS:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern1155 (x1);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern205 (x1);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1173 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !const0_operand (operands[2], i2)
      || !vector_all_ones_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case REG:
      if (peep2_current_count < 4)
        return -1;
      operands[5] = x3;
      if (!general_reg_operand (operands[5], i1))
        return -1;
      x4 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[5]))
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1188 (rtx x1, machine_mode i1, rtx_code i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_unset_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1198 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !vector_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || GET_MODE (x5) != E_V16QImode
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (GET_MODE (x4) != E_V4SImode
              || !vector_all_ones_operand (operands[4], E_V4SImode))
            return -1;
          return 0;

        case E_V2DImode:
          if (GET_MODE (x4) != E_V2DImode
              || !vector_all_ones_operand (operands[4], E_V2DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !vector_operand (operands[1], E_V32QImode)
          || !register_operand (operands[2], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || GET_MODE (x5) != E_V32QImode
          || !register_operand (operands[3], E_V32QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8SImode:
          if (GET_MODE (x4) != E_V8SImode
              || !vector_all_ones_operand (operands[4], E_V8SImode))
            return -1;
          return 2;

        case E_V4DImode:
          if (GET_MODE (x4) != E_V4DImode
              || !vector_all_ones_operand (operands[4], E_V4DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1240 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern1245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          if (!vector_all_ones_operand (operands[0], E_V32QImode)
              || !const0_operand (operands[3], E_V32QImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!vector_all_ones_operand (operands[0], E_V16QImode)
              || !const0_operand (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 59)
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 1);
      operands[4] = x4;
      x6 = XVECEXP (x2, 0, 0);
      operands[0] = x6;
      x7 = XVECEXP (x2, 0, 1);
      operands[1] = x7;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          if (pattern1244 (x2, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern1244 (x2, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1272 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vector_all_ones_operand (operands[1], i2)
      || !const0_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1280 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x4, 0, 4);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XVECEXP (x4, 0, 5);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x11 = XVECEXP (x4, 0, 6);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x12 = XVECEXP (x4, 0, 7);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x13 = XEXP (x1, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 1);
  return pattern1299 (x15, 
8); /* [-1, 0] */
}

int
pattern1313 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1321 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  return 0;
}

int
pattern1338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_255_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1358 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!bcst_vector_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1364 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!bcst_vector_operand (operands[2], i2)
      || GET_MODE (x1) != i2
      || !bcst_vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1384 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V8HFmode)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 223
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 2);
  if (XWINT (x6, 0) != 3L
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || GET_MODE (x3) != E_V8HFmode
      || !register_operand (operands[1], E_V8HFmode)
      || !register_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_V8HFmode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  if (!register_operand (x7, E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x8, E_SImode))
    return -1;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x3, 1);
  switch (GET_CODE (x10))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x10;
      if (!const0_operand (operands[4], E_V8HFmode))
        return -1;
      operands[5] = x7;
      operands[6] = x8;
      return 0;

    case REG:
    case SUBREG:
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      operands[4] = x7;
      operands[5] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern1407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return pattern1139 (x1); /* [-1, 5] */
}

int
pattern1414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_QImode:
          return pattern1409 (x3, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern1409 (x3, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern1410 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern1410 (x3, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      if (GET_MODE (x8) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_zext_immediate_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern1441 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!const_0_to_31_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern1447 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern1447 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern1447 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern1447 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern1447 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern1447 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern1447 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern1447 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern1447 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!const_0_to_7_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1448 (x1, 
E_V8SImode, 
E_V8SFmode) != 0)
            return -1;
          return 9;

        case E_V4SFmode:
          if (pattern1448 (x1, 
E_V4SImode, 
E_V4SFmode) != 0)
            return -1;
          return 10;

        case E_V4DFmode:
          if (pattern1448 (x1, 
E_V4DImode, 
E_V4DFmode) != 0)
            return -1;
          return 11;

        case E_V2DFmode:
          if (pattern1448 (x1, 
E_V2DImode, 
E_V2DFmode) != 0)
            return -1;
          return 12;

        case E_V4SImode:
          if (pattern1449 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern1449 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 14;

        case E_V8SImode:
          if (pattern1449 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 15;

        case E_V4DImode:
          if (pattern1449 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern1449 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 17;

        case E_V16QImode:
          if (pattern1449 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 18;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1511 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

int
pattern1523 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1529 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1539 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8SFmode
      || !nonimmediate_operand (operands[1], E_V4SFmode))
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern1550 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1559 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !general_reg_operand (operands[4], i1)
      || !general_reg_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1575 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x3, 2);
  return pattern1574 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1583 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  return 0;
}

int
pattern1597 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1605 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1613 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1623 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_4_to_7_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode)
      || !nonimm_or_0_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1634 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1646 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_hilo_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 2);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1663 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_63_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1676 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !register_operand (operands[2], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !register_operand (operands[2], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1688 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1687 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1687 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1698 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1706 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1713 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x1, 0);
      switch (GET_MODE (x9))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !extract_operator (operands[3], E_DImode)
              || !extract_operator (operands[4], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1733 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1740 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1749 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1757 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1764 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !general_reg_operand (operands[4], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[2]))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  return 0;
}

int
pattern1771 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  return 0;
}

int
pattern1778 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1777 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1786 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!register_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

int
pattern1794 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern1804 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || pattern1528 (x1, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      return 0;

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || pattern1528 (x1, 
E_V8SImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1811 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i4
      || !vector_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1818 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1825 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 22);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 23);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 24);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 25);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 26);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1835 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_0_to_15_operand (operands[11], E_VOIDmode)
      || !const_0_to_15_operand (operands[12], E_VOIDmode)
      || !const_0_to_15_operand (operands[13], E_VOIDmode)
      || !const_0_to_15_operand (operands[14], E_VOIDmode)
      || !const_0_to_15_operand (operands[15], E_VOIDmode)
      || !const_0_to_15_operand (operands[16], E_VOIDmode)
      || !const_0_to_15_operand (operands[17], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1843 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 28);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 29);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 30);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 31);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1848 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = PATTERN (peep2_next_insn (4));
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  return 0;
}

int
pattern1855 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1853 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1863 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      if (GET_MODE (x6) != E_CCmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 1
          || XINT (x9, 1) != 109
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!flags_reg_operand (operands[0], E_CCmode)
          || GET_MODE (x2) != E_CCmode
          || !comparison_operator (operands[1], E_VOIDmode)
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x11 = XEXP (x7, 0);
      operands[2] = x11;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      x13 = XVECEXP (x9, 0, 0);
      operands[4] = x13;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !general_operand (operands[3], E_QImode)
              || !
#line 1539 "../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 1; /* ccmpqi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !general_operand (operands[3], E_HImode)
              || !
#line 1539 "../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 2; /* ccmphi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !x86_64_general_operand (operands[3], E_SImode)
              || !
#line 1539 "../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 3; /* ccmpsi */

        case E_DImode:
          if (!nonimmediate_operand (operands[2], E_DImode)
              || !x86_64_general_operand (operands[3], E_DImode)
              || !(
#line 1539 "../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4; /* ccmpdi */

        default:
          return -1;
        }

    case LABEL_REF:
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != PC
          || !ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      return 1458; /* *jcc */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x6;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1185 (x2, 
E_HImode) != 0
              || !
#line 26339 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1801; /* *movhicc_noc */

        case E_QImode:
          if (pattern1186 (x2) != 0
              || !
#line 26413 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
            return -1;
          return 1806; /* *movqicc_noc */

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !fcmov_comparison_operator (operands[1], E_VOIDmode)
              || !register_operand (operands[2], E_XFmode)
              || !register_operand (operands[3], E_XFmode)
              || !
#line 26607 "../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
            return -1;
          return 1808; /* *movxfcc_1 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || pattern1243 (x2, 
E_DFmode) != 0
              || !
#line 26622 "../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1809; /* *movdfcc_1 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || pattern1243 (x2, 
E_SFmode) != 0
              || !
#line 26657 "../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1810; /* *movsfcc_1_387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_13 (x1, insn, pnum_clobbers);

    case 2:
      return recog_12 (x1, insn, pnum_clobbers);

    case 3:
      switch (XINT (x2, 1))
        {
        case 39:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_CCGZmode)
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x3) != LTU)
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 17
              || GET_MODE (x4) != E_CCmode)
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCGZmode)
            return -1;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 521; /* subsi3_carry_ccgz */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !x86_64_general_operand (operands[2], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 522; /* subdi3_carry_ccgz */

            default:
              return -1;
            }

        case 59:
          return recog_11 (x1, insn, pnum_clobbers);

        case 48:
          if (GET_MODE (x2) != E_HFmode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          if (!nonimmediate_operand (operands[0], E_HFmode))
            return -1;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          if (!nonimm_or_0_operand (operands[2], E_HFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          operands[3] = x3;
          if (!register_operand (operands[3], E_QImode)
              || !
#line 26573 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1807; /* movhf_mask */

        case 51:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          x3 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x3))
            {
            case LT:
              switch (pattern731 (x2))
                {
                case 0:
                  if (
#line 26806 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()))
                    return 1825; /* *ieee_maxsf3_1 */
                  if (!
#line 26827 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()))
                    return -1;
                  return 1827; /* *ieee_minsf3_1 */

                case 1:
                  if (
#line 26806 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()))
                    return 1826; /* *ieee_maxdf3_1 */
                  if (!
#line 26827 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()))
                    return -1;
                  return 1828; /* *ieee_mindf3_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SFmode:
                  if (pattern957 (x2, 
E_V2SFmode) == 0
                      && 
#line 1317 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                    return 2073; /* mmx_blendvps */
                  break;

                case E_V8QImode:
                  if (pattern957 (x2, 
E_V8QImode) == 0
                      && 
#line 4314 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                    return 2239; /* mmx_pblendvb_v8qi */
                  break;

                case E_V4QImode:
                  if (pattern957 (x2, 
E_V4QImode) == 0
                      && 
#line 4390 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                    return 2243; /* mmx_pblendvb_v4qi */
                  break;

                case E_V2QImode:
                  if (pattern957 (x2, 
E_V2QImode) == 0
                      && 
#line 4390 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                    return 2244; /* mmx_pblendvb_v2qi */
                  break;

                case E_V2HImode:
                  if (pattern957 (x2, 
E_V2HImode) == 0
                      && 
#line 4390 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                    return 2245; /* mmx_pblendvb_v2hi */
                  break;

                case E_SFmode:
                  if (pattern957 (x2, 
E_SFmode) == 0
                      && 
#line 23534 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 8612; /* sse4_1_blendvss */
                  break;

                case E_DFmode:
                  if (pattern957 (x2, 
E_DFmode) == 0
                      && 
#line 23534 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 8613; /* sse4_1_blendvsd */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x3) != SUBREG)
                return -1;
              switch (pattern842 (x2))
                {
                case 0:
                  if (!
#line 4366 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
                    return -1;
                  return 2241; /* *mmx_pblendvb_v8qi_2 */

                case 1:
                  if (!
#line 4366 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
                    return -1;
                  return 2242; /* *mmx_pblendvb_v8qi_2 */

                case 2:
                  if (!
#line 4442 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2249; /* *mmx_pblendvb_v4qi_2 */

                default:
                  return -1;
                }

            case EQ:
              switch (pattern733 (x2))
                {
                case 0:
                  if (!
#line 4338 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
                    return -1;
                  return 2240; /* *mmx_pblendvb_v8qi_1 */

                case 1:
                  if (!
#line 4414 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2246; /* *mmx_pblendvb_v4qi_1 */

                case 2:
                  if (!
#line 4414 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2247; /* *mmx_pblendvb_v2qi_1 */

                case 3:
                  if (!
#line 4414 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2248; /* *mmx_pblendvb_v2hi_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 50:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[1] = x8;
          x3 = XVECEXP (x2, 0, 2);
          operands[3] = x3;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern958 (x2, 
E_V2SFmode) != 0
                  || !
#line 1261 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                return -1;
              return 2070; /* sse4_1_insertps_v2sf */

            case E_V2SImode:
              if (pattern958 (x2, 
E_V2SImode) != 0
                  || !
#line 1261 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                return -1;
              return 2071; /* sse4_1_insertps_v2si */

            default:
              return -1;
            }

        case 53:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          x3 = XVECEXP (x2, 0, 2);
          operands[3] = x3;
          if (!nonimmediate_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern959 (x2, 
E_V8QImode) != 0
                  || !
#line 4512 "../../gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
                return -1;
              return 2261; /* mmx_ppermv64 */

            case E_V4QImode:
              if (pattern959 (x2, 
E_V4QImode) != 0
                  || !
#line 4524 "../../gcc/config/i386/mmx.md"
(TARGET_XOP))
                return -1;
              return 2262; /* mmx_ppermv32 */

            default:
              return -1;
            }

        case 47:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_V8QImode)
            return -1;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_V8QImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          switch (pattern1060 (x2, 
E_V8QImode))
            {
            case 0:
              if (!(
#line 6860 "../../gcc/config/i386/mmx.md"
(TARGET_SSE || TARGET_3DNOW_A) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 2383; /* *mmx_maskmovq */

            case 1:
              if (!(
#line 6860 "../../gcc/config/i386/mmx.md"
(TARGET_SSE || TARGET_3DNOW_A) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 2384; /* *mmx_maskmovq */

            default:
              return -1;
            }

        case 157:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x7;
              x3 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x3) != CONST_INT)
                return -1;
              x8 = XVECEXP (x2, 0, 1);
              operands[2] = x8;
              if (XWINT (x3, 0) == 0L)
                {
                  switch (pattern956 (x2))
                    {
                    case 0:
                      if ((
#line 4585 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3460; /* *avx512vl_eqv16qi3_1 */
                      break;

                    case 1:
                      if ((
#line 4585 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3472; /* *avx512vl_eqv16hi3_1 */
                      break;

                    case 2:
                      if ((
#line 4674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 3528; /* *avx512f_eqv16si3_1 */
                      break;

                    case 3:
                      if ((
#line 4585 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3476; /* *avx512vl_eqv8hi3_1 */
                      break;

                    case 4:
                      if ((
#line 4674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3532; /* *avx512vl_eqv8si3_1 */
                      break;

                    case 5:
                      if ((
#line 4674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3536; /* *avx512vl_eqv4si3_1 */
                      break;

                    case 6:
                      if ((
#line 4674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 3540; /* *avx512f_eqv8di3_1 */
                      break;

                    case 7:
                      if ((
#line 4674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3544; /* *avx512vl_eqv4di3_1 */
                      break;

                    case 8:
                      if ((
#line 4674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3548; /* *avx512vl_eqv2di3_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x3;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              switch (pattern67 (x2))
                {
                case 0:
                  if (!(
#line 4600 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3480; /* avx512vl_ucmpv16qi3 */

                case 1:
                  if (!(
#line 4600 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3486; /* avx512vl_ucmpv16hi3 */

                case 2:
                  if (!(
#line 4689 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3550; /* avx512f_ucmpv16si3 */

                case 3:
                  if (!(
#line 4600 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3488; /* avx512vl_ucmpv8hi3 */

                case 4:
                  if (!(
#line 4689 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3552; /* avx512vl_ucmpv8si3 */

                case 5:
                  if (!(
#line 4689 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3554; /* avx512vl_ucmpv4si3 */

                case 6:
                  if (!(
#line 4689 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3556; /* avx512f_ucmpv8di3 */

                case 7:
                  if (!(
#line 4689 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3558; /* avx512vl_ucmpv4di3 */

                case 8:
                  if (!(
#line 4689 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3560; /* avx512vl_ucmpv2di3 */

                default:
                  return -1;
                }

            case US_MINUS:
              switch (pattern420 (x2))
                {
                case 0:
                  if (!(
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3607; /* *avx512vl_ucmpv16qi3_1 */

                case 1:
                  if (!(
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3613; /* *avx512vl_ucmpv16hi3_1 */

                case 2:
                  if (!(
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3615; /* *avx512vl_ucmpv8hi3_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 52:
          if (pattern59 (x1, pnum_clobbers, 
E_V8QImode) != 0)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          if (!register_mmxmem_operand (operands[2], E_V8QImode))
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          operands[4] = x3;
          if (!reg_or_const_vector_operand (operands[4], E_V4SImode)
              || !
#line 23140 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          *pnum_clobbers = 1;
          return 8555; /* *ssse3_pshufbv8qi3 */

        case 132:
          if (pnum_clobbers == NULL
              || pattern251 (x1) != 0
              || !nonimmediate_operand (operands[3], E_V16QImode))
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          operands[4] = x3;
          if (!const_0_to_255_operand (operands[4], E_SImode)
              || !
#line 26061 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          *pnum_clobbers = 2;
          return 8909; /* sse4_2_pcmpistr_cconly */

        default:
          return -1;
        }

    case 5:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 131
          || pattern251 (x1) != 0
          || !register_operand (operands[3], E_SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      operands[4] = x3;
      if (!nonimmediate_operand (operands[4], E_V16QImode))
        return -1;
      x10 = XVECEXP (x2, 0, 3);
      operands[5] = x10;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x11 = XVECEXP (x2, 0, 4);
      operands[6] = x11;
      if (!const_0_to_255_operand (operands[6], E_SImode)
          || !
#line 25936 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
        return -1;
      *pnum_clobbers = 2;
      return 8905; /* sse4_2_pcmpestr_cconly */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (nonimm_ssenomem_operand (operands[0], E_DFmode)
          && nonimmediate_operand (operands[1], E_SFmode)
          && 
#line 5295 "../../gcc/config/i386/i386.md"
(TARGET_80387 || (TARGET_SSE2 && TARGET_SSE_MATH)))
        return 200; /* *extendsfdf2 */
      if (!register_operand (operands[0], E_DFmode)
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 5451 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 202; /* *extendhfdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 5451 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 201; /* *extendhfsf2 */

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode))
        return -1;
      switch (pattern425 (x3, 
E_XFmode))
        {
        case 0:
          if (!
#line 5513 "../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 204; /* *extendsfxf2_i387 */

        case 1:
          if (!
#line 5513 "../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 205; /* *extenddfxf2_i387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (register_operand (operands[0], E_SImode))
        {
          switch (pattern263 ())
            {
            case 0:
              if (
#line 5769 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return 212; /* fix_trunchfsi2 */
              break;

            case 1:
              if (
#line 5945 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 225; /* fix_truncsfsi_sse */
              break;

            case 2:
              if (
#line 5945 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 227; /* fix_truncdfsi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 230; /* fix_truncsi_i387_fisttp */
        }
      if (!
#line 5993 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 233; /* *fix_truncsi_i387_1 */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          switch (pattern263 ())
            {
            case 0:
              if ((
#line 5769 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 214; /* fix_trunchfdi2 */
              break;

            case 1:
              if ((
#line 5945 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 226; /* fix_truncsfdi_sse */
              break;

            case 2:
              if ((
#line 5945 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 228; /* fix_truncdfdi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 231; /* fix_truncdi_i387_fisttp */
        }
      if (!
#line 5993 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 234; /* *fix_truncdi_i387_1 */

    case E_HImode:
      if (pattern262 (x3, pnum_clobbers, 
E_VOIDmode, 
E_HImode) != 0)
        return -1;
      if (
#line 5975 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 229; /* fix_trunchi_i387_fisttp */
        }
      if (!
#line 5993 "../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 232; /* *fix_trunchi_i387_1 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 8922 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4826; /* sse2_cvttpd2pi */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern739 (x2, 
E_HImode) != 0
              || !
#line 13609 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 835; /* *notxorhi_1 */

        case E_QImode:
          if (pattern739 (x2, 
E_QImode) != 0
              || !
#line 13809 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 871; /* *notxorqi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14978 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1031; /* *one_cmplti2_doubleword */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14991 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1032; /* *one_cmplhi2_1 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 15035 "../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1041; /* *one_cmplqi2_1 */

            case E_V4QImode:
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x2) != E_V4QImode
                  || !register_operand (operands[1], E_V4QImode))
                return -1;
              return 2263; /* one_cmplv4qi2 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x2) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode))
                return -1;
              return 2264; /* one_cmplv2qi2 */

            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x2) != E_V2HImode
                  || !register_operand (operands[1], E_V2HImode))
                return -1;
              return 2265; /* one_cmplv2hi2 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 15061 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1042; /* *one_cmplqi_1_slp */

        case 2:
          if (!
#line 15061 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1043; /* *one_cmplhi_1_slp */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      if (!const_0_to_63_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      x10 = XEXP (x3, 2);
      if (!rtx_equal_p (x10, operands[1])
          || !
#line 19060 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
        return -1;
      *pnum_clobbers = 1;
      return 1415; /* *btcq_imm */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      x13 = XVECEXP (x3, 0, 2);
      operands[3] = x13;
      switch (XINT (x3, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern961 (x2))
                {
                case 0:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3379; /* *avx512f_cmpv16si3 */

                case 1:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 310 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3386; /* *avx512vl_cmpv16hf3 */

                case 2:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3388; /* *avx512f_cmpv16sf3 */

                case 3:
                  if (!(
#line 4567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3444; /* *avx512vl_cmpv16qi3 */

                case 4:
                  if (!(
#line 4567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3450; /* *avx512vl_cmpv16hi3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern962 (x2))
                {
                case 0:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3380; /* *avx512vl_cmpv8si3 */

                case 1:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3381; /* *avx512vl_cmpv4si3 */

                case 2:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3382; /* *avx512f_cmpv8di3 */

                case 3:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3383; /* *avx512vl_cmpv4di3 */

                case 4:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3384; /* *avx512vl_cmpv2di3 */

                case 5:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 311 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3387; /* *avx512fp16_cmpv8hf3 */

                case 6:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3389; /* *avx512vl_cmpv8sf3 */

                case 7:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3390; /* *avx512vl_cmpv4sf3 */

                case 8:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3391; /* *avx512f_cmpv8df3 */

                case 9:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3392; /* *avx512vl_cmpv4df3 */

                case 10:
                  if (!(
#line 4472 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3393; /* *avx512vl_cmpv2df3 */

                case 11:
                  if (!(
#line 4567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3452; /* *avx512vl_cmpv8hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern1065 (x2))
                {
                case 0:
                  if (!(
#line 4567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3445; /* *avx512vl_cmpv16qi3 */

                case 1:
                  if (!(
#line 4567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3451; /* *avx512vl_cmpv16hi3 */

                case 2:
                  if (!(
#line 4765 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3598; /* *avx512f_ucmpv16si3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern1066 (x2))
                {
                case 0:
                  if (!(
#line 4567 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3453; /* *avx512vl_cmpv8hi3 */

                case 1:
                  if (!(
#line 4765 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3599; /* *avx512vl_ucmpv8si3 */

                case 2:
                  if (!(
#line 4765 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3600; /* *avx512vl_ucmpv4si3 */

                case 3:
                  if (!(
#line 4765 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3601; /* *avx512f_ucmpv8di3 */

                case 4:
                  if (!(
#line 4765 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3602; /* *avx512vl_ucmpv4di3 */

                case 5:
                  if (!(
#line 4765 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3603; /* *avx512vl_ucmpv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_54 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x2, 1);
          if (pattern597 (x7) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (pattern1250 (x1))
            {
            case 0:
              if (!
#line 8248 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8248 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8248 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 410; /* *subqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 419; /* *subqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 420; /* *subqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *subqi_ext2di_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x11 = XEXP (x1, 0);
      operands[0] = x11;
      switch (pattern291 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1344 (x2, 
E_QImode) != 0
                  || !
#line 9277 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 487; /* subqi3_carry */

            case E_HImode:
              if (pattern1344 (x2, 
E_HImode) != 0
                  || !
#line 9277 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 488; /* subhi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1255 (x2, 
E_QImode) != 0
                  || !
#line 10230 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 570; /* *subqi3_eq */

            case E_HImode:
              if (pattern1255 (x2, 
E_HImode) != 0
                  || !
#line 10230 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *subhi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern91 (x1))
        {
        case 0:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (pattern963 (x2) != 0)
            return -1;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1493 (x2, 
E_SFmode, 
E_V2SFmode) != 0
                  || !
#line 1058 "../../gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && ix86_pre_reload_split ()))
                return -1;
              return 2065; /* *mmx_hsubv2sf3_low */

            case E_DFmode:
              if (pattern1493 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3772 "../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_V2DF_REDUCTION_PREFER_HADDPD))
                return -1;
              return 3152; /* *sse3_hsubv2df3_low */

            default:
              return -1;
            }

        case 1:
          switch (pattern848 (x2))
            {
            case 0:
              if (!
#line 22605 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8522; /* ssse3_phsubwv4hi3 */

            case 1:
              if (!
#line 22692 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8529; /* ssse3_phsubdv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_61 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (pattern275 (x2))
        {
        case 0:
          x6 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x6) == CONST_INT)
            {
              switch (pattern967 (x2))
                {
                case 0:
                  if (
#line 1691 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2085; /* *vec_interleave_lowv2sf */
                  break;

                case 1:
                  if (
#line 4991 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2301; /* mmx_punpckldq */
                  break;

                case 2:
                  if (
#line 1708 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2086; /* *vec_interleave_highv2sf */
                  break;

                case 3:
                  if (
#line 4970 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2300; /* mmx_punpckhdq */
                  break;

                default:
                  break;
                }
            }
          x7 = XVECEXP (x3, 0, 0);
          operands[3] = x7;
          switch (pattern968 (x2))
            {
            case 0:
              if (!
#line 6197 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2366; /* *punpckwd */

            case 1:
              if (!
#line 6197 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2367; /* *punpckwd */

            case 2:
              if (!
#line 6197 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2368; /* *punpckwd */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4850 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2294; /* mmx_punpckhbw */

        case 2:
          if (!
#line 4890 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2296; /* mmx_punpcklbw */

        case 3:
          if (!
#line 4871 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2295; /* mmx_punpckhbw_low */

        case 4:
          if (!
#line 4928 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2298; /* mmx_punpckhwd */

        case 5:
          if (!
#line 4911 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2297; /* mmx_punpcklbw_low */

        case 6:
          if (!
#line 4949 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2299; /* mmx_punpcklwd */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern276 (x2) != 0
          || !
#line 8409 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4714; /* sse_cvtps2pi */

    case FIX:
      if (pattern278 (x2) != 0
          || !
#line 8473 "../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4716; /* sse_cvttps2pi */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3758; /* *fma_fmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3773; /* *fma_fmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3759; /* *fma_fmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3782; /* *fma_fmadd_df */

            case E_HFmode:
              if (pattern858 (x3, 
E_HFmode) != 0
                  || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3772; /* *fma_fmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x6) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6017 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3821; /* *fma_fmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3836; /* *fma_fmsub_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x6) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6017 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3822; /* *fma_fmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3845; /* *fma_fmsub_df */

            case E_HFmode:
              if (pattern859 (x3, 
E_HFmode) != 0
                  || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3835; /* *fma_fmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x5) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6123 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3884; /* *fma_fnmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6155 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3899; /* *fma_fnmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x5) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6123 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3885; /* *fma_fnmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6155 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3908; /* *fma_fnmadd_df */

            case E_HFmode:
              if (pattern860 (x3, 
E_HFmode) != 0
                  || !(
#line 6155 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3898; /* *fma_fnmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern861 (x3, 
E_SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6230 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3941; /* *fma_fnmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6263 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3970; /* *fma_fnmsub_sf */

            case E_DFmode:
              if (pattern861 (x3, 
E_DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6230 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3943; /* *fma_fnmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6263 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3979; /* *fma_fnmsub_df */

            case E_HFmode:
              if (pattern862 (x3, 
E_HFmode) != 0
                  || !(
#line 6263 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3969; /* *fma_fnmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern974 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 5437 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return 2322; /* *mmx_pextrw_zext */
          break;

        case 1:
          if (
#line 6098 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2360; /* *pextrw_zext */
          break;

        case 2:
          if (
#line 21102 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8387; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if (
#line 5474 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2326; /* *mmx_pextrb_zext */
          break;

        case 4:
          if (
#line 6130 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2364; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21102 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 21045 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
            return 8385; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    case E_DImode:
      switch (pattern974 (x2, 
E_DImode))
        {
        case 0:
          if ((
#line 5437 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2323; /* *mmx_pextrw_zext */
          break;

        case 1:
          if ((
#line 6098 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2361; /* *pextrw_zext */
          break;

        case 2:
          if ((
#line 21102 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 8388; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if ((
#line 5474 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2327; /* *mmx_pextrb_zext */
          break;

        case 4:
          if ((
#line 6130 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2365; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21102 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && (
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21045 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))))
            return 8386; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[1] = x6;
  switch (XWINT (x5, 0))
    {
    case 0L:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (register_operand (operands[1], E_V2SImode))
            {
              if (
#line 5749 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE4_1))
                return 2348; /* *vec_extractv2si_0_zext_sse4 */
              if (
#line 5764 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 2349; /* *vec_extractv2si_0_zext */
            }
          break;

        case E_V4SImode:
          if (register_operand (operands[1], E_V4SImode))
            {
              if (
#line 21202 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
                return 8395; /* *vec_extractv4si_0_zext_sse4 */
              if (
#line 21217 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 8396; /* *vec_extractv4si_0_zext */
            }
          break;

        default:
          break;
        }
      break;

    case 1L:
      if (register_operand (operands[1], E_V2SImode)
          && 
#line 5826 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE4_1))
        return 2351; /* *vec_extractv2si_1_zext */
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!memory_operand (operands[1], E_V2SImode)
          || !const_0_to_1_operand (operands[2], E_SImode)
          || !
#line 5842 "../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_64BIT))
        return -1;
      return 2352; /* *vec_extractv2si_zext_mem */

    case E_V4SImode:
      if (!const_0_to_3_operand (operands[2], E_SImode))
        return -1;
      if (register_operand (operands[1], E_V4SImode)
          && 
#line 21278 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
        return 8398; /* *vec_extractv4si_zext */
      if (!memory_operand (operands[1], E_V4SImode)
          || !
#line 21301 "../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
        return -1;
      return 8400; /* *vec_extractv4si_zext_mem */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x6;
              operands[1] = x4;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern600 (x2, 
E_SImode) != 0
                      || !
#line 8039 "../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))))
                    return -1;
                  return 376; /* *leasi_general_4 */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || GET_MODE (x3) != E_DImode)
                    return -1;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && (
#line 8039 "../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 378; /* *leadi_general_4 */
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !(
#line 14139 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return -1;
                  return 929; /* *concatsidi3_5 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              operands[1] = x4;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x5;
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !(
#line 14062 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 893; /* *concatsidi3_1 */

            case SUBREG:
              switch (pattern439 (x2, 
LSHIFTRT))
                {
                case 0:
                  operands[2] = x5;
                  if (pattern1346 (x2) == 0)
                    {
                      if (
#line 15439 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && TARGET_APX_NF))
                        return 1066; /* x86_64_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15439 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                        {
                          *pnum_clobbers = 1;
                          return 1067; /* x86_64_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1347 (x2) != 0)
                    return -1;
                  if (
#line 15461 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1068; /* x86_64_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15461 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1069; /* x86_64_shld_ndd_1 */

                case 1:
                  operands[2] = x5;
                  if (pattern1348 (x2) == 0)
                    {
                      if (
#line 15671 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && TARGET_APX_NF))
                        return 1078; /* x86_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15671 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && true))
                        {
                          *pnum_clobbers = 1;
                          return 1079; /* x86_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1349 (x2) != 0)
                    return -1;
                  if (
#line 15693 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1080; /* x86_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15693 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1081; /* x86_shld_ndd_1 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern442 (x2, pnum_clobbers))
                {
                case 0:
                  if (
#line 15477 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1070; /* *x86_64_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15533 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1071; /* *x86_64_shld_shrd_1_nozext */

                case 1:
                  if (
#line 15709 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1082; /* *x86_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15765 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1083; /* *x86_shld_shrd_1_nozext */

                case 2:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15586 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1072; /* *x86_64_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15607 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1073; /* *x86_64_shld_ndd_2 */

                case 3:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15817 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1084; /* *x86_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15838 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1085; /* *x86_shld_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          switch (pattern290 (x2, 
LSHIFTRT))
            {
            case 0:
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (nonimmediate_operand (operands[0], E_DImode))
                {
                  res = recog_77 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[2] = x11;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15424 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1064; /* x86_64_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15424 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1065; /* x86_64_shld_ndd */

            case 1:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || pattern289 (x2, 
E_SImode, 
E_DImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (rtx_equal_p (x4, operands[0]))
                {
                  x13 = XEXP (x7, 1);
                  x14 = XEXP (x13, 1);
                  x15 = XEXP (x14, 0);
                  if (rtx_equal_p (x15, operands[2]))
                    {
                      if (
#line 15633 "../../gcc/config/i386/i386.md"
(TARGET_APX_NF))
                        return 1074; /* x86_shld_nf */
                      if (pnum_clobbers != NULL)
                        {
                          *pnum_clobbers = 1;
                          return 1075; /* x86_shld */
                        }
                    }
                }
              operands[2] = x11;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15655 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1076; /* x86_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15655 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1077; /* x86_shld_ndd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern260 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14098 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 905; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14171 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 935; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern260 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14098 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 908; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14171 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 938; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case CONST_INT:
      switch (pattern288 (x2, pnum_clobbers))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern748 (x2))
                {
                case 0:
                  if (
#line 18825 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    {
                      *pnum_clobbers = 1;
                      return 1391; /* *btssi */
                    }
                  break;

                case 1:
                  if ((
#line 18825 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1393; /* *btsdi */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern757 (x2))
            {
            case 0:
              if (!
#line 18844 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1395; /* *btssi_mask */

            case 1:
              if (!(
#line 18844 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1397; /* *btsdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18872 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1399; /* *btssi_mask_1 */

        case 2:
          if (!(
#line 18872 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1401; /* *btsdi_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers != NULL)
        {
          x2 = XEXP (x1, 1);
          if (pattern734 (x2, 
E_DImode, 
E_QImode) == 0
              && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 1;
              return 1131; /* ashrdi3_doubleword */
            }
        }
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_DImode)
          && const_int_operand (operands[2], E_QImode))
        {
          if ((
#line 17246 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1168; /* ashrdi3_cvt_nf */
          if (pnum_clobbers != NULL
              && (
#line 17246 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1169; /* ashrdi3_cvt */
            }
        }
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[2], E_DImode)
          && (
#line 17315 "../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1174; /* *bmi2_ashrdi3_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonmemory_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 17325 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1177; /* *ashrdi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 17325 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1178; /* *ashrdi3_1 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern620 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 17325 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 1175; /* *ashrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17325 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 1176; /* *ashrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == SUBREG
      && known_eq (SUBREG_BYTE (x2), 0))
    {
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x1, 1);
          x5 = XEXP (x4, 2);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (x2))
                {
                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 19344 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1434; /* *btsi_setcqi */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 19344 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1435; /* *btdi_setcqi */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND)
    return -1;
  operands[0] = x2;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1438 (x4, 
E_SImode) != 0
          || !
#line 19425 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1442; /* *btsi_setcsi_mask */

    case E_DImode:
      if (pattern1438 (x4, 
E_DImode) != 0
          || !(
#line 19425 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1443; /* *btdi_setcdi_mask */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !ix86_comparison_operator (operands[1], E_SImode))
        return -1;
      if (
#line 19493 "../../gcc/config/i386/i386.md"
(TARGET_APX_ZU))
        return 1445; /* *setcc_si_zu */
      if (pnum_clobbers != NULL
          && 
#line 19517 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
        {
          *pnum_clobbers = 1;
          return 1449; /* *setcc_si_1_and */
        }
      if (!
#line 19534 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))))
        return -1;
      return 1451; /* *setcc_si_1_movzbl */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !ix86_comparison_operator (operands[1], E_DImode))
        return -1;
      if ((
#line 19493 "../../gcc/config/i386/i386.md"
(TARGET_APX_ZU) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1446; /* *setcc_di_zu */
      if (!
#line 19501 "../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && TARGET_64BIT && !TARGET_PARTIAL_REG_STALL))
        return -1;
      return 1447; /* *setcc_di_1 */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 45:
      if (pattern298 (x3) != 0
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 19576 "../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
        return -1;
      return 1454; /* *setcc_si_slp */

    case 98:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern777 (x3, 
E_SImode) != 0
              || !
#line 21754 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1566; /* bmi_bextr_si */

        case E_DImode:
          if (pattern777 (x3, 
E_DImode) != 0
              || !(
#line 21754 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1567; /* bmi_bextr_di */

        default:
          return -1;
        }

    case 99:
      switch (pattern299 (x3))
        {
        case 0:
          if (!
#line 22147 "../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1600; /* bmi2_pdep_si3 */

        case 1:
          if (!(
#line 22147 "../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1601; /* bmi2_pdep_di3 */

        default:
          return -1;
        }

    case 100:
      switch (pattern299 (x3))
        {
        case 0:
          if (!
#line 22158 "../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1602; /* bmi2_pext_si3 */

        case 1:
          if (!(
#line 22158 "../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1603; /* bmi2_pext_di3 */

        default:
          return -1;
        }

    case 93:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_CCZmode
          || !flags_reg_operand (operands[0], E_CCZmode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          *pnum_clobbers = 1;
          return 1881; /* stack_protect_test_1_si */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !memory_operand (operands[2], E_DImode)
              || !
#line 1408 "../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          *pnum_clobbers = 1;
          return 1882; /* stack_protect_test_1_di */

        default:
          return -1;
        }

    case 95:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !
#line 29056 "../../gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1889; /* sse4_2_crc32qi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !
#line 29056 "../../gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1890; /* sse4_2_crc32hi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 29056 "../../gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1891; /* sse4_2_crc32si */

        default:
          return -1;
        }

    case 178:
      x5 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          switch (XVECLEN (x5, 0))
            {
            case 3:
              if (XINT (x5, 1) != 59
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x6 = XVECEXP (x5, 0, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_V32HFmode))
                return -1;
              x7 = XVECEXP (x5, 0, 1);
              operands[2] = x7;
              if (!nonimmediate_operand (operands[2], E_V32HFmode))
                return -1;
              x8 = XVECEXP (x5, 0, 2);
              operands[3] = x8;
              if (!const_0_to_31_operand (operands[3], E_SImode))
                return -1;
              x4 = XVECEXP (x3, 0, 1);
              operands[4] = x4;
              if (!const48_operand (operands[4], E_SImode)
                  || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 309 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3266; /* avx512bw_cmpv32hf3_round */

            case 1:
              x4 = XVECEXP (x3, 0, 1);
              operands[2] = x4;
              switch (XINT (x5, 1))
                {
                case 156:
                  switch (pattern869 (x3))
                    {
                    case 0:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7815 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4473; /* avx512fp16_vcvtsh2usi_round */

                    case 1:
                      if (!
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4833; /* avx512f_vcvtss2usi_round */

                    case 2:
                      if (!
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4845; /* avx512f_vcvtsd2usi_round */

                    case 3:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7815 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4477; /* avx512fp16_vcvtsh2usiq_round */

                    case 4:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4835; /* avx512f_vcvtss2usiq_round */

                    case 5:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4847; /* avx512f_vcvtsd2usiq_round */

                    default:
                      return -1;
                    }

                case 46:
                  switch (pattern869 (x3))
                    {
                    case 0:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7815 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4475; /* avx512fp16_vcvtsh2si_round */

                    case 1:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8542 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                        return -1;
                      return 4722; /* sse_cvtss2si_round */

                    case 2:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9085 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 4857; /* sse2_cvtsd2si_round */

                    case 3:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7815 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4479; /* avx512fp16_vcvtsh2siq_round */

                    case 4:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8542 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4724; /* sse_cvtss2siq_round */

                    case 5:
                      if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9085 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4859; /* sse2_cvtsd2siq_round */

                    default:
                      return -1;
                    }

                case 172:
                  switch (pattern871 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7980 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4625; /* unspec_avx512fp16_fix_truncsi2_round */

                    case 1:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8570 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                        return -1;
                      return 4728; /* unspec_sse_cvttss2si_round */

                    case 2:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9114 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 4863; /* unspec_sse2_cvttsd2si_round */

                    case 3:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7980 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4629; /* unspec_avx512fp16_fix_truncdi2_round */

                    case 4:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8570 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4730; /* unspec_sse_cvttss2siq_round */

                    case 5:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9114 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4865; /* unspec_sse2_cvttsd2siq_round */

                    default:
                      return -1;
                    }

                case 173:
                  switch (pattern871 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7980 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4627; /* unspec_avx512fp16_fixuns_truncsi2_round */

                    case 1:
                      if (!
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4837; /* unspec_avx512f_vcvttss2usi_round */

                    case 2:
                      if (!
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4849; /* unspec_avx512f_vcvttsd2usi_round */

                    case 3:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7980 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4631; /* unspec_avx512fp16_fixuns_truncdi2_round */

                    case 4:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9024 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4839; /* unspec_avx512f_vcvttss2usiq_round */

                    case 5:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9060 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4851; /* unspec_avx512f_vcvttsd2usiq_round */

                    default:
                      return -1;
                    }

                case 275:
                  switch (pattern873 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32605 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10807; /* avx10_2_vcvttsd2sissi_round */

                    case 1:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32618 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10815; /* avx10_2_vcvttss2sissi_round */

                    case 2:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32605 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10811; /* avx10_2_vcvttsd2sisdi_round */

                    case 3:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32618 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10819; /* avx10_2_vcvttss2sisdi_round */

                    default:
                      return -1;
                    }

                case 276:
                  switch (pattern873 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32605 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10809; /* avx10_2_vcvttsd2usissi_round */

                    case 1:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32618 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10817; /* avx10_2_vcvttss2usissi_round */

                    case 2:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32605 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10813; /* avx10_2_vcvttsd2usisdi_round */

                    case 3:
                      if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32618 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10821; /* avx10_2_vcvttss2usisdi_round */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != UNSPEC
              || XVECLEN (x9, 0) != 3
              || XINT (x9, 1) != 59
              || GET_MODE (x9) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          x12 = XVECEXP (x9, 0, 2);
          operands[3] = x12;
          if (!const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x5, 1);
          operands[4] = x13;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 1);
          operands[5] = x4;
          if (!const48_operand (operands[5], E_SImode)
              || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 309 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 3268; /* avx512bw_cmpv32hf3_mask_round */

        case FIX:
          switch (pattern452 (x3))
            {
            case 0:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7992 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4633; /* avx512fp16_fix_truncsi2_round */

            case 1:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8586 "../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 4732; /* sse_cvttss2si_round */

            case 2:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9131 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 4867; /* sse2_cvttsd2si_round */

            case 3:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7992 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4637; /* avx512fp16_fix_truncdi2_round */

            case 4:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8586 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4734; /* sse_cvttss2siq_round */

            case 5:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9131 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4869; /* sse2_cvttsd2siq_round */

            default:
              return -1;
            }

        case UNSIGNED_FIX:
          switch (pattern452 (x3))
            {
            case 0:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7992 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4635; /* avx512fp16_fixuns_truncsi2_round */

            case 1:
              if (!
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 4841; /* avx512f_vcvttss2usi_round */

            case 2:
              if (!
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 4853; /* avx512f_vcvttsd2usi_round */

            case 3:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7992 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4639; /* avx512fp16_fixuns_truncdi2_round */

            case 4:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9036 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4843; /* avx512f_vcvttss2usiq_round */

            case 5:
              if (!(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9072 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4855; /* avx512f_vcvttsd2usiq_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 158:
      switch (pattern301 (x3))
        {
        case 0:
          if (!(
#line 19038 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8034; /* avx512bw_testmv64qi3 */

        case 1:
          if (!(
#line 19038 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8036; /* avx512vl_testmv32qi3 */

        case 2:
          if (!(
#line 19038 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8040; /* avx512bw_testmv32hi3 */

        default:
          return -1;
        }

    case 159:
      switch (pattern301 (x3))
        {
        case 0:
          if (!(
#line 19049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8058; /* avx512bw_testnmv64qi3 */

        case 1:
          if (!(
#line 19049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8060; /* avx512vl_testnmv32qi3 */

        case 2:
          if (!(
#line 19049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8064; /* avx512bw_testnmv32hi3 */

        default:
          return -1;
        }

    case 193:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!vector_operand (operands[1], E_V32HFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode)
          || !(
#line 29844 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V32HFmode)) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 9906; /* avx512dq_fpclassv32hf */

    case 214:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern163 (x3, 
E_DImode, 
E_V64QImode) != 0
              || !(
#line 30927 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10248; /* avx512vl_vpshufbitqmbv64qi */

        case E_SImode:
          if (pattern163 (x3, 
E_SImode, 
E_V32QImode) != 0
              || !(
#line 30927 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10252; /* avx512vl_vpshufbitqmbv32qi */

        default:
          return -1;
        }

    case 262:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode)
          || !
#line 32443 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10642; /* avx10_2_fpclassbf16_v32bf */

    case 288:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !x86_64_nonmemory_operand (operands[1], E_SImode))
            return -1;
          return 10907; /* atomic_storesi_1 */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !x86_64_nonmemory_operand (operands[1], E_DImode)
              || !
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 10908; /* atomic_storedi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 2);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 1L)
            return -1;
          switch (pattern998 (x2))
            {
            case 0:
              if (!
#line 12023 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5204; /* *vec_setv8hi_0_1 */

            case 1:
              if (!
#line 12023 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5205; /* *vec_setv8hf_0_1 */

            case 2:
              if (!
#line 12023 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5206; /* *vec_setv8bf_0_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x7;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1270 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9111; /* avx512f_vec_dupv16si_mask */

            case E_V8SImode:
              if (pattern1270 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9113; /* avx512vl_vec_dupv8si_mask */

            case E_V4SImode:
              if (pattern1271 (x2, 
E_V4SImode, 
E_SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9115; /* avx512vl_vec_dupv4si_mask */

            case E_V8DImode:
              if (pattern1270 (x2, 
E_V8DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9117; /* avx512f_vec_dupv8di_mask */

            case E_V4DImode:
              if (pattern1270 (x2, 
E_V4DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9119; /* avx512vl_vec_dupv4di_mask */

            case E_V2DImode:
              if (pattern1271 (x2, 
E_V2DImode, 
E_DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9121; /* avx512vl_vec_dupv2di_mask */

            case E_V16SFmode:
              if (pattern1270 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9123; /* avx512f_vec_dupv16sf_mask */

            case E_V8SFmode:
              if (pattern1270 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9125; /* avx512vl_vec_dupv8sf_mask */

            case E_V4SFmode:
              if (pattern1271 (x2, 
E_V4SFmode, 
E_SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9127; /* avx512vl_vec_dupv4sf_mask */

            case E_V8DFmode:
              if (pattern1270 (x2, 
E_V8DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9129; /* avx512f_vec_dupv8df_mask */

            case E_V4DFmode:
              if (pattern1270 (x2, 
E_V4DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9131; /* avx512vl_vec_dupv4df_mask */

            case E_V2DFmode:
              if (pattern1271 (x2, 
E_V2DFmode, 
E_DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9133; /* avx512vl_vec_dupv2df_mask */

            case E_V64QImode:
              if (pattern1270 (x2, 
E_V64QImode, 
E_DImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9135; /* avx512bw_vec_dupv64qi_mask */

            case E_V16QImode:
              if (pattern1271 (x2, 
E_V16QImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9137; /* avx512vl_vec_dupv16qi_mask */

            case E_V32QImode:
              if (pattern1270 (x2, 
E_V32QImode, 
E_SImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9139; /* avx512vl_vec_dupv32qi_mask */

            case E_V32HImode:
              if (pattern1270 (x2, 
E_V32HImode, 
E_SImode, 
E_V8HImode, 
E_HImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9141; /* avx512bw_vec_dupv32hi_mask */

            case E_V16HImode:
              if (pattern768 (x2, 
E_HImode, 
E_V16HImode) != 0
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !nonimm_or_0_operand (operands[2], E_V16HImode)
                  || !register_operand (operands[3], E_HImode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9143; /* avx512vl_vec_dupv16hi_mask */

            case E_V8HImode:
              if (pattern1271 (x2, 
E_V8HImode, 
E_HImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9145; /* avx512vl_vec_dupv8hi_mask */

            case E_V32HFmode:
              if (pattern1270 (x2, 
E_V32HFmode, 
E_SImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9147; /* avx512bw_vec_dupv32hf_mask */

            case E_V16HFmode:
              if (pattern1270 (x2, 
E_V16HFmode, 
E_HImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9149; /* avx512vl_vec_dupv16hf_mask */

            case E_V8HFmode:
              if (pattern1271 (x2, 
E_V8HFmode, 
E_HFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9151; /* avx512fp16_vec_dupv8hf_mask */

            case E_V32BFmode:
              if (pattern1270 (x2, 
E_V32BFmode, 
E_SImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9153; /* avx512bw_vec_dupv32bf_mask */

            case E_V16BFmode:
              if (pattern1270 (x2, 
E_V16BFmode, 
E_HImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9155; /* avx512vl_vec_dupv16bf_mask */

            case E_V8BFmode:
              if (pattern1271 (x2, 
E_V8BFmode, 
E_BFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9157; /* avx512vl_vec_dupv8bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x5, 0, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1270 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9245; /* avx512dq_broadcastv16si_mask */

        case E_V8SImode:
          if (pattern1270 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9247; /* avx512dq_broadcastv8si_mask */

        case E_V4SImode:
          if (pattern1271 (x2, 
E_V4SImode, 
E_V2SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9249; /* avx512dq_broadcastv4si_mask */

        case E_V16SFmode:
          if (pattern1270 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9251; /* avx512dq_broadcastv16sf_mask */

        case E_V8SFmode:
          if (pattern1270 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9253; /* avx512dq_broadcastv8sf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_154 (x1, insn, pnum_clobbers);

        case CONST_INT:
          if (XWINT (x4, 0) == 1L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (GET_MODE (x2) == E_V2DImode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DImode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DImode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DImode)
                                  && 
#line 1861 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2554; /* *sse2_movq128_v2di_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DImode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DImode)
                                  && 
#line 14832 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7141; /* sse2_movsd_v2di */
                            }
                        }
                    }
                  break;

                case E_V2DFmode:
                  if (GET_MODE (x2) == E_V2DFmode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DFmode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DFmode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DFmode)
                                  && 
#line 1861 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2555; /* *sse2_movq128_v2df_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DFmode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DFmode)
                                  && 
#line 14832 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7142; /* sse2_movsd_v2df */
                            }
                        }
                    }
                  break;

                case E_V4SImode:
                  if (pattern884 (x2, 
E_V4SImode) == 0
                      && 
#line 11683 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5181; /* sse_movss_v4si */
                  break;

                case E_V4SFmode:
                  if (pattern884 (x2, 
E_V4SFmode) == 0
                      && 
#line 11683 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5182; /* sse_movss_v4sf */
                  break;

                case E_V8HImode:
                  if (pattern884 (x2, 
E_V8HImode) == 0
                      && 
#line 12101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2 && const0_operand (operands[1], V8HImode))))
                    return 5220; /* avx512fp16_movv8hi */
                  break;

                case E_V8HFmode:
                  if (pattern884 (x2, 
E_V8HFmode) == 0
                      && 
#line 12101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2 && const0_operand (operands[1], V8HFmode))))
                    return 5221; /* avx512fp16_movv8hf */
                  break;

                case E_V8BFmode:
                  if (pattern884 (x2, 
E_V8BFmode) == 0
                      && 
#line 12101 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2 && const0_operand (operands[1], V8BFmode))))
                    return 5222; /* avx512fp16_movv8bf */
                  break;

                default:
                  break;
                }
            }
          operands[3] = x4;
          x5 = XEXP (x2, 0);
          operands[2] = x5;
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SFmode:
              if (pattern1105 (x2, 
E_V8SFmode) != 0
                  || !(
#line 23486 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8604; /* avx_blendps256 */

            case E_V4SFmode:
              if (pattern1106 (x2, 
E_V4SFmode) != 0
                  || !
#line 23486 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8605; /* sse4_1_blendps */

            case E_V4DFmode:
              if (pattern1106 (x2, 
E_V4DFmode) != 0
                  || !(
#line 23486 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8606; /* avx_blendpd256 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !vector_operand (operands[2], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !const_0_to_3_operand (operands[3], E_SImode)
                  || !(
#line 23486 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8607; /* sse4_1_blendpd */

            case E_V8HImode:
              if (pattern1105 (x2, 
E_V8HImode) != 0
                  || !
#line 23991 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8669; /* sse4_1_pblendw */

            case E_V8HFmode:
              if (pattern1105 (x2, 
E_V8HFmode) != 0
                  || !
#line 23991 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8670; /* sse4_1_pblendph */

            case E_V8BFmode:
              if (pattern1105 (x2, 
E_V8BFmode) != 0
                  || !
#line 23991 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8671; /* sse4_1_pblendbf */

            case E_V16HImode:
              if (pattern1107 (x2, 
E_V16HImode) != 0
                  || !
#line 24064 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8672; /* *avx2_pblendw */

            case E_V16HFmode:
              if (pattern1107 (x2, 
E_V16HFmode) != 0
                  || !
#line 24064 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8673; /* *avx2_pblendph */

            case E_V16BFmode:
              if (pattern1107 (x2, 
E_V16BFmode) != 0
                  || !
#line 24064 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8674; /* *avx2_pblendbf */

            case E_V8SImode:
              if (pattern1108 (x2, 
E_V8SImode) != 0
                  || !
#line 24082 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8675; /* avx2_pblenddv8si */

            case E_V4SImode:
              if (pattern1108 (x2, 
E_V4SImode) != 0
                  || !
#line 24082 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8676; /* avx2_pblenddv4si */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 3
              || XINT (x4, 1) != 59)
            return -1;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (pattern1001 (x2))
            {
            case 0:
              x6 = XVECEXP (x4, 0, 0);
              operands[3] = x6;
              switch (pattern1450 (x2))
                {
                case 0:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return 3028; /* *minmaxv32hf3_1 */
                  break;

                case 1:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3029; /* *minmaxv16hf3_1 */
                  break;

                case 2:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3030; /* *minmaxv8hf3_1 */
                  break;

                case 3:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3031; /* *minmaxv16sf3_1 */
                  break;

                case 4:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3032; /* *minmaxv8sf3_1 */
                  break;

                case 5:
                  if (
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)))
                    return 3033; /* *minmaxv4sf3_1 */
                  break;

                case 6:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3034; /* *minmaxv8df3_1 */
                  break;

                case 7:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3035; /* *minmaxv4df3_1 */
                  break;

                case 8:
                  if ((
#line 3332 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3036; /* *minmaxv2df3_1 */
                  break;

                case 9:
                  if ((
#line 4217 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3225; /* *avx_cmpv8sf3_lt */
                  break;

                case 10:
                  if (
#line 4217 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3226; /* *avx_cmpv4sf3_lt */
                  break;

                case 11:
                  if ((
#line 4217 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3227; /* *avx_cmpv4df3_lt */
                  break;

                case 12:
                  if ((
#line 4217 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3228; /* *avx_cmpv2df3_lt */
                  break;

                case 13:
                  if (
#line 4246 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3229; /* *avx_cmpv4si3_ltint */
                  break;

                case 14:
                  if (
#line 4246 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3230; /* *avx_cmpv2di3_ltint */
                  break;

                case 15:
                  if ((
#line 4246 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3231; /* *avx_cmpv8si3_ltint */
                  break;

                case 16:
                  if ((
#line 4246 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3232; /* *avx_cmpv4di3_ltint */
                  break;

                case 17:
                  if ((
#line 18013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return 7831; /* *avx2_pcmpv32qi3_3 */
                  break;

                case 18:
                  if (
#line 18013 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))))
                    return 7832; /* *avx2_pcmpv16qi3_3 */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x6) != SUBREG)
                return -1;
              switch (pattern1453 (x2))
                {
                case 0:
                  if (!
#line 4281 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3233; /* *avx_cmpv4si3_ltint_not */

                case 1:
                  if (!
#line 4281 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3234; /* *avx_cmpv2di3_ltint_not */

                case 2:
                  if (!(
#line 4281 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3235; /* *avx_cmpv8si3_ltint_not */

                case 3:
                  if (!(
#line 4281 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3236; /* *avx_cmpv4di3_ltint_not */

                case 4:
                  if (!(
#line 18042 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7833; /* *avx2_pcmpv32qi3_4 */

                case 5:
                  if (!
#line 18042 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                    return -1;
                  return 7834; /* *avx2_pcmpv16qi3_4 */

                default:
                  return -1;
                }

            case 1:
              if (!(
#line 18074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7835; /* *avx2_pcmpv32qi3_5 */

            case 2:
              if (!
#line 18074 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                return -1;
              return 7836; /* *avx2_pcmpv16qi3_5 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1109 (x2, 
E_V2DFmode, 
E_V8DFmode) != 0
              || !(
#line 20025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12379 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8314; /* *avx512dq_vinsertf64x2_1 */

        case E_V8DImode:
          if (pattern1109 (x2, 
E_V2DImode, 
E_V8DImode) != 0
              || !(
#line 20025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12380 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8316; /* *avx512dq_vinserti64x2_1 */

        case E_V16SFmode:
          if (pattern1109 (x2, 
E_V4SFmode, 
E_V16SFmode) != 0
              || !(
#line 20025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12381 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8318; /* *avx512f_vinsertf32x4_1 */

        case E_V16SImode:
          if (pattern1109 (x2, 
E_V4SImode, 
E_V16SImode) != 0
              || !(
#line 20025 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12381 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8320; /* *avx512f_vinserti32x4_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (pattern918 (x4) != 0)
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  switch (XWINT (x7, 0))
    {
    case 8L:
      x8 = XVECEXP (x4, 0, 1);
      if (XWINT (x8, 0) != 9L)
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (XWINT (x9, 0) != 10L)
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (XWINT (x10, 0) != 11L)
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (XWINT (x11, 0) != 12L)
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (XWINT (x12, 0) != 13L)
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (XWINT (x13, 0) != 14L)
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (XWINT (x14, 0) != 15L)
        return -1;
      switch (pattern1804 (x2))
        {
        case 0:
          if (!(
#line 12677 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5254; /* vec_extract_hi_v16sf_mask */

        case 1:
          if (!(
#line 12677 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5255; /* vec_extract_hi_v16si_mask */

        default:
          return -1;
        }

    case 0L:
      x8 = XVECEXP (x4, 0, 1);
      if (XWINT (x8, 0) != 1L
          || pattern1538 (x4) != 0)
        return -1;
      switch (pattern1804 (x2))
        {
        case 0:
          if (!(
#line 12781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5258; /* vec_extract_lo_v16sf_mask */

        case 1:
          if (!(
#line 12781 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5259; /* vec_extract_lo_v16si_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[4] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[5] = x7;
  x8 = XVECEXP (x4, 0, 5);
  operands[7] = x8;
  x9 = XVECEXP (x4, 0, 6);
  operands[8] = x9;
  x10 = XVECEXP (x4, 0, 7);
  operands[9] = x10;
  x11 = XVECEXP (x4, 0, 8);
  operands[10] = x11;
  x12 = XVECEXP (x4, 0, 9);
  operands[11] = x12;
  x13 = XVECEXP (x4, 0, 10);
  operands[12] = x13;
  x14 = XVECEXP (x4, 0, 11);
  operands[13] = x14;
  x15 = XVECEXP (x4, 0, 12);
  operands[14] = x15;
  x16 = XVECEXP (x4, 0, 13);
  operands[15] = x16;
  x17 = XVECEXP (x4, 0, 14);
  operands[16] = x17;
  x18 = XVECEXP (x4, 0, 15);
  operands[17] = x18;
  x19 = XEXP (x2, 1);
  operands[18] = x19;
  x20 = XEXP (x2, 2);
  operands[19] = x20;
  if (!register_operand (operands[19], E_HImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || pattern1835 () != 0
          || !nonimm_or_0_operand (operands[18], E_V16SFmode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20453 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8359; /* *avx512f_shuf_f32x4_1_mask_1 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode
          || GET_MODE (x3) != E_V16SImode
          || !nonimm_or_0_operand (operands[18], E_V16SImode))
        return -1;
      if (register_operand (operands[1], E_V16SImode)
          && pattern1835 () == 0
          && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20453 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 8361; /* *avx512f_shuf_i32x4_1_mask_1 */
      if (!nonimmediate_operand (operands[1], E_V16SImode)
          || pattern1791 () != 0
          || !const_8_to_11_operand (operands[10], E_VOIDmode)
          || !const_8_to_11_operand (operands[11], E_VOIDmode)
          || !const_8_to_11_operand (operands[12], E_VOIDmode)
          || !const_8_to_11_operand (operands[13], E_VOIDmode)
          || !const_12_to_15_operand (operands[14], E_VOIDmode)
          || !const_12_to_15_operand (operands[15], E_VOIDmode)
          || !const_12_to_15_operand (operands[16], E_VOIDmode)
          || !const_12_to_15_operand (operands[17], E_VOIDmode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20535 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
   && INTVAL (operands[2]) + 8 == INTVAL (operands[10])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[11])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[12])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[13])
   && INTVAL (operands[2]) + 12 == INTVAL (operands[14])
   && INTVAL (operands[3]) + 12 == INTVAL (operands[15])
   && INTVAL (operands[4]) + 12 == INTVAL (operands[16])
   && INTVAL (operands[5]) + 12 == INTVAL (operands[17]))))
        return -1;
      return 8363; /* avx512f_pshufd_1_mask */

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      return recog_144 (x1, insn, pnum_clobbers);

    case 2:
      return recog_143 (x1, insn, pnum_clobbers);

    case 3:
      return recog_142 (x1, insn, pnum_clobbers);

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 164:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1440 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 13637 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 5367; /* avx512f_vternlogv16si_maskz_1 */

                case E_V8SImode:
                  if (pattern1440 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5369; /* avx512vl_vternlogv8si_maskz_1 */

                case E_V4SImode:
                  if (pattern1440 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5371; /* avx512vl_vternlogv4si_maskz_1 */

                case E_V8DImode:
                  if (pattern1440 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 5373; /* avx512f_vternlogv8di_maskz_1 */

                case E_V4DImode:
                  if (pattern1440 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5375; /* avx512vl_vternlogv4di_maskz_1 */

                case E_V2DImode:
                  if (pattern1440 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 13637 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5377; /* avx512vl_vternlogv2di_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x2, 2);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1441 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6938; /* *avx512f_vternlogv16si_mask */

                case E_V8SImode:
                  if (pattern1441 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6939; /* *avx512vl_vternlogv8si_mask */

                case E_V4SImode:
                  if (pattern1441 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6940; /* *avx512vl_vternlogv4si_mask */

                case E_V8DImode:
                  if (pattern1441 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6941; /* *avx512f_vternlogv8di_mask */

                case E_V4DImode:
                  if (pattern1441 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6942; /* *avx512vl_vternlogv4di_mask */

                case E_V2DImode:
                  if (pattern1441 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6943; /* *avx512vl_vternlogv2di_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 163:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1442 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7014; /* avx512f_fixupimmv16sf_maskz_1 */

                case E_V8SFmode:
                  if (pattern1442 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7018; /* avx512vl_fixupimmv8sf_maskz_1 */

                case E_V4SFmode:
                  if (pattern1442 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7022; /* avx512vl_fixupimmv4sf_maskz_1 */

                case E_V8DFmode:
                  if (pattern1442 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7026; /* avx512f_fixupimmv8df_maskz_1 */

                case E_V4DFmode:
                  if (pattern1442 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7030; /* avx512vl_fixupimmv4df_maskz_1 */

                case E_V2DFmode:
                  if (pattern1442 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7034; /* avx512vl_fixupimmv2df_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              x9 = XEXP (x2, 2);
              switch (GET_CODE (x9))
                {
                case REG:
                case SUBREG:
                  operands[5] = x9;
                  if (!rtx_equal_p (x8, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16SFmode:
                      if (pattern1497 (x2, 
E_V16SImode, 
E_V16SFmode, 
E_HImode) != 0
                          || !(
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 7036; /* avx512f_fixupimmv16sf_mask */

                    case E_V8SFmode:
                      if (pattern1497 (x2, 
E_V8SImode, 
E_V8SFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7038; /* avx512vl_fixupimmv8sf_mask */

                    case E_V4SFmode:
                      if (pattern1497 (x2, 
E_V4SImode, 
E_V4SFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7040; /* avx512vl_fixupimmv4sf_mask */

                    case E_V8DFmode:
                      if (pattern1497 (x2, 
E_V8DImode, 
E_V8DFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 7042; /* avx512f_fixupimmv8df_mask */

                    case E_V4DFmode:
                      if (pattern1497 (x2, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7044; /* avx512vl_fixupimmv4df_mask */

                    case E_V2DFmode:
                      if (pattern1497 (x2, 
E_V2DImode, 
E_V2DFmode, 
E_QImode) != 0
                          || !(
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7046; /* avx512vl_fixupimmv2df_mask */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x9, 0) != 1L
                      || !rtx_equal_p (x8, operands[2]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern1498 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                          || !
#line 14180 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                        return -1;
                      return 7048; /* avx512f_sfixupimmv4sf */

                    case E_V2DFmode:
                      if (pattern1498 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                          || !(
#line 14180 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 7052; /* avx512f_sfixupimmv2df */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern136 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4646; /* avx512fp16_float_extend_phv8df2_mask */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10207 "../../gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 467 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 5091; /* avx512f_cvtps2pd512_mask */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern135 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16HFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4650; /* avx512fp16_float_extend_phv16sf2_mask */

        case E_V8SFmode:
          if (pattern135 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8HFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4654; /* avx512fp16_float_extend_phv8sf2_mask */

        case E_V4DFmode:
          if (pattern136 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!memory_operand (operands[1], E_V4HFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8061 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4661; /* *avx512fp16_float_extend_phv4df2_load_mask */

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10207 "../../gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL) && 1)))
                return -1;
              return 5094; /* avx_cvtps2pd256_mask */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern150 (x2, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8061 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4663; /* *avx512fp16_float_extend_phv4sf2_load_mask */

        case E_V2DFmode:
          if (pattern136 (x2, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2HFmode:
              if (!memory_operand (operands[1], E_V2HFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8100 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4667; /* *avx512fp16_float_extend_phv2df2_load_mask */

            case E_V2SFmode:
              if (!memory_operand (operands[1], E_V2SFmode)
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10389 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                return -1;
              return 5142; /* sse2_cvtps2pd_mask_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PARALLEL)
        return -1;
      switch (XVECLEN (x7, 0))
        {
        case 4:
          if (pattern636 (x7) != 0
              || GET_MODE (x4) != E_V4HFmode)
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          x6 = XEXP (x2, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DFmode:
              if (pattern137 (x2, 
E_V4DFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8051 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4657; /* avx512fp16_float_extend_phv4df2_mask */

            case E_V4SFmode:
              if (pattern137 (x2, 
E_V4SFmode) != 0
                  || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8051 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4659; /* avx512fp16_float_extend_phv4sf2_mask */

            default:
              return -1;
            }

        case 2:
          x9 = XVECEXP (x7, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x7, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          x6 = XEXP (x2, 2);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[3] = x6;
              if (!register_operand (operands[3], E_QImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!nonimm_or_0_operand (operands[2], E_V2DFmode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2HFmode:
                  if (!register_operand (operands[1], E_V8HFmode)
                      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8090 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 4665; /* avx512fp16_float_extend_phv2df2_mask */

                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10375 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                    return -1;
                  return 5140; /* sse2_cvtps2pd_mask */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x6, 0) != 1L
                  || GET_MODE (x4) != E_V2SFmode)
                return -1;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!nonimmediate_operand (operands[2], E_V4SFmode))
                return -1;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 10034 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 5074; /* sse2_cvtss2sd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern133 (x2))
    {
    case 0:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 2986; /* *sminv32hf3_mask */

    case 1:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2991; /* *sminv16hf3_mask */

    case 2:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2995; /* *sminv8hf3_mask */

    case 3:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 3002; /* *sminv16sf3_mask */

    case 4:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3007; /* *sminv8sf3_mask */

    case 5:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
        return -1;
      return 3011; /* *sminv4sf3_mask */

    case 6:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 3018; /* *sminv8df3_mask */

    case 7:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3023; /* *sminv4df3_mask */

    case 8:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 3027; /* *sminv2df3_mask */

    case 9:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7698; /* *avx512f_sminv16si3_mask */

    case 10:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7706; /* *avx512f_sminv8si3_mask */

    case 11:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7714; /* *avx512f_sminv4si3_mask */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17797 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7798; /* *sse4_1_sminv4si3_mask */

    case 12:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7722; /* *avx512f_sminv8di3_mask */

    case 13:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7730; /* *avx512f_sminv4di3_mask */

    case 14:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7738; /* *avx512f_sminv2di3_mask */

    case 15:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7746; /* *avx512bw_sminv64qi3_mask */

    case 16:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7754; /* *avx512bw_sminv16qi3_mask */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17797 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7794; /* *sse4_1_sminv16qi3_mask */

    case 17:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7762; /* *avx512bw_sminv32qi3_mask */

    case 18:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7770; /* *avx512bw_sminv32hi3_mask */

    case 19:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7778; /* *avx512bw_sminv16hi3_mask */

    case 20:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7786; /* *avx512bw_sminv8hi3_mask */

    case 21:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32108 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10519; /* avx10_2_sminbf16_v32bf_mask */

    case 22:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32108 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10523; /* avx10_2_sminbf16_v16bf_mask */

    case 23:
      if (!(
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32108 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10527; /* avx10_2_sminbf16_v8bf_mask */

    case 24:
      if (!(
#line 3470 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 3099; /* *avx512fp16_vmsminv8hf3 */

    case 25:
      if (!
#line 3470 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3107; /* *sse_vmsminv4sf3 */

    case 26:
      if (!(
#line 3470 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3115; /* *sse2_vmsminv2df3 */

    default:
      return -1;
    }
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern323 (x2))
    {
    case 0:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4334; /* avx512fp16_vcvtph2uw_v32hi */

    case 1:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!vector_operand (operands[1], E_V16HFmode)
              || !(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4342; /* avx512fp16_vcvtph2udq_v16si */

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !(
#line 8697 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4770; /* *avx512f_fixuns_notruncv16sfv16si */

        default:
          return -1;
        }

    case 2:
      switch (pattern769 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4350; /* avx512fp16_vcvtph2uqq_v8di */

        case 1:
          if (!(
#line 8730 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4790; /* *avx512dq_cvtps2uqqv8di */

        case 2:
          if (!(
#line 9708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5016; /* fixuns_notruncv8dfv8di2 */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4358; /* avx512fp16_vcvtph2uw_v16hi */

    case 4:
      switch (pattern769 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4366; /* avx512fp16_vcvtph2udq_v8si */

        case 1:
          if (!(
#line 8697 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4774; /* *avx512vl_fixuns_notruncv8sfv8si */

        case 2:
          if (!(
#line 9489 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4936; /* fixuns_notruncv8dfv8si2 */

        default:
          return -1;
        }

    case 5:
      switch (pattern770 (x2, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4374; /* avx512fp16_vcvtph2uqq_v4di */

        case 1:
          if (!(
#line 8730 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4794; /* *avx512dq_cvtps2uqqv4di */

        case 2:
          if (!(
#line 9708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5020; /* fixuns_notruncv4dfv4di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4382; /* avx512fp16_vcvtph2uw_v8hi */

    case 7:
      switch (pattern770 (x2, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4390; /* avx512fp16_vcvtph2udq_v4si */

        case 1:
          if (!(
#line 8697 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4778; /* *avx512vl_fixuns_notruncv4sfv4si */

        case 2:
          if (!(
#line 9489 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4940; /* fixuns_notruncv4dfv4si2 */

        default:
          return -1;
        }

    case 8:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7634 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4398; /* avx512fp16_vcvtph2uqq_v2di */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 9708 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5022; /* fixuns_notruncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 8743 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4796; /* *avx512dq_cvtps2uqqv2di */

    default:
      return -1;
    }
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      return recog_218 (x1, insn, pnum_clobbers);

    case 3:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      switch (XINT (x4, 1))
        {
        case 192:
          x7 = XEXP (x3, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1393 (x2))
            {
            case 0:
              if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3195; /* reducesv8hf_round */

            case 1:
              if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4044 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode)))))
                return -1;
              return 3199; /* reducesv4sf_round */

            case 2:
              if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3203; /* reducesv2df_round */

            default:
              return -1;
            }

        case 133:
          return recog_217 (x1, insn, pnum_clobbers);

        case 217:
          switch (pattern1119 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7164 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4253; /* fma_fmaddc_v32hf_maskz_1_round */

            case 1:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7302 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4291; /* avx512bw_fmaddc_v32hf_mask_round */

            case 2:
              if (!(
#line 437 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4316; /* avx512fp16_fma_fmaddcsh_v8hf_round */

            default:
              return -1;
            }

        case 219:
          switch (pattern1119 (x2))
            {
            case 0:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7164 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4257; /* fma_fcmaddc_v32hf_maskz_1_round */

            case 1:
              if (!(
#line 221 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7302 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4293; /* avx512bw_fcmaddc_v32hf_mask_round */

            case 2:
              if (!(
#line 437 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4320; /* avx512fp16_fma_fcmaddcsh_v8hf_round */

            default:
              return -1;
            }

        case 194:
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x9, E_SImode))
            return -1;
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              x10 = XEXP (x3, 1);
              operands[4] = x10;
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1630 (x2, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 9885; /* avx512dq_rangepv16sf_mask_round */

                case E_V8DFmode:
                  if (pattern1630 (x2, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 9893; /* avx512dq_rangepv8df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[4] = x9;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1391 (x2, 
E_V4SFmode) != 0
                      || !(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29825 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                    return -1;
                  return 9900; /* avx512dq_rangesv4sf_round */

                case E_V2DFmode:
                  if (pattern1391 (x2, 
E_V2DFmode) != 0
                      || !(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 9904; /* avx512dq_rangesv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 166:
          x7 = XEXP (x3, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1393 (x2))
            {
            case 0:
              if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 9968; /* avx512f_vgetmantv8hf_round */

            case 1:
              if (!
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 9972; /* avx512f_vgetmantv4sf_round */

            case 2:
              if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 9976; /* avx512f_vgetmantv2df_round */

            default:
              return -1;
            }

        case 278:
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x9, E_SImode))
            return -1;
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              x10 = XEXP (x3, 1);
              operands[4] = x10;
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1630 (x2, 
E_V32HFmode, 
E_SImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10831; /* avx10_2_minmaxpv32hf_mask_round */

                case E_V16HFmode:
                  if (pattern1630 (x2, 
E_V16HFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10835; /* avx10_2_minmaxpv16hf_mask_round */

                case E_V8HFmode:
                  if (pattern1630 (x2, 
E_V8HFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10839; /* avx10_2_minmaxpv8hf_mask_round */

                case E_V16SFmode:
                  if (pattern1630 (x2, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10843; /* avx10_2_minmaxpv16sf_mask_round */

                case E_V8SFmode:
                  if (pattern1630 (x2, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10847; /* avx10_2_minmaxpv8sf_mask_round */

                case E_V4SFmode:
                  if (pattern1630 (x2, 
E_V4SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10851; /* avx10_2_minmaxpv4sf_mask_round */

                case E_V8DFmode:
                  if (pattern1630 (x2, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10855; /* avx10_2_minmaxpv8df_mask_round */

                case E_V4DFmode:
                  if (pattern1630 (x2, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10859; /* avx10_2_minmaxpv4df_mask_round */

                case E_V2DFmode:
                  if (pattern1630 (x2, 
E_V2DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10863; /* avx10_2_minmaxpv2df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[4] = x9;
              switch (pattern1392 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 478 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 10866; /* avx10_2_minmaxsv8hf_round */

                case 1:
                  if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32658 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 10870; /* avx10_2_minmaxsv4sf_round */

                case 2:
                  if (!(
#line 463 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 479 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 10874; /* avx10_2_minmaxsv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_219 (x1, insn, pnum_clobbers);

    case 4:
      if (XINT (x4, 1) != 163)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x4, 0, 2);
      operands[3] = x8;
      x11 = XVECEXP (x4, 0, 3);
      operands[4] = x11;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[5] = x10;
          x7 = XEXP (x3, 2);
          operands[6] = x7;
          operands[7] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1654 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
                  || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7015; /* avx512f_fixupimmv16sf_maskz_1_round */

            case E_V8SFmode:
              if (pattern1654 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
                  || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7019; /* avx512vl_fixupimmv8sf_maskz_1_round */

            case E_V4SFmode:
              if (pattern1654 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
                  || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7023; /* avx512vl_fixupimmv4sf_maskz_1_round */

            case E_V8DFmode:
              if (pattern1654 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
                  || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7027; /* avx512f_fixupimmv8df_maskz_1_round */

            case E_V4DFmode:
              if (pattern1654 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
                  || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7031; /* avx512vl_fixupimmv4df_maskz_1_round */

            case E_V2DFmode:
              if (pattern1654 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
                  || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7035; /* avx512vl_fixupimmv2df_maskz_1_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              operands[6] = x9;
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1681 (x2, 
E_V16SImode, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7037; /* avx512f_fixupimmv16sf_mask_round */

                case E_V8SFmode:
                  if (pattern1681 (x2, 
E_V8SImode, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7039; /* avx512vl_fixupimmv8sf_mask_round */

                case E_V4SFmode:
                  if (pattern1681 (x2, 
E_V4SImode, 
E_V4SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7041; /* avx512vl_fixupimmv4sf_mask_round */

                case E_V8DFmode:
                  if (pattern1681 (x2, 
E_V8DImode, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7043; /* avx512f_fixupimmv8df_mask_round */

                case E_V4DFmode:
                  if (pattern1681 (x2, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7045; /* avx512vl_fixupimmv4df_mask_round */

                case E_V2DFmode:
                  if (pattern1681 (x2, 
E_V2DImode, 
E_V2DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7047; /* avx512vl_fixupimmv2df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[5] = x9;
              if (!rtx_equal_p (x10, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1682 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 7049; /* avx512f_sfixupimmv4sf_round */

                case E_V2DFmode:
                  if (pattern1682 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !(
#line 263 "../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14180 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 7053; /* avx512f_sfixupimmv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !vector_operand (operands[1], E_V16QImode)
          || !
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8863; /* *sse4_1_ptestv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !vector_operand (operands[1], E_V8HImode)
          || !
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8864; /* *sse4_1_ptestv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || !
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8865; /* *sse4_1_ptestv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !vector_operand (operands[1], E_V2DImode)
          || !
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8866; /* *sse4_1_ptestv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !vector_operand (operands[1], E_V1TImode)
          || !
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8867; /* *sse4_1_ptestv1ti */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8868; /* *sse4_1_ptestv4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8869; /* *sse4_1_ptestv2df */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !vector_operand (operands[1], E_V32QImode)
          || !(
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 605 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8870; /* *avx_ptestv32qi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !vector_operand (operands[1], E_V16HImode)
          || !(
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 605 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8871; /* *avx_ptestv16hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !vector_operand (operands[1], E_V8SImode)
          || !(
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8872; /* *avx_ptestv8si */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !vector_operand (operands[1], E_V4DImode)
          || !(
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8873; /* *avx_ptestv4di */

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || !vector_operand (operands[1], E_V2TImode)
          || !(
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8874; /* *avx_ptestv2ti */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 607 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8875; /* *avx_ptestv8sf */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 25306 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 607 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8876; /* *avx_ptestv4df */

    default:
      return -1;
    }
}

 int
recog_232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern775 (x3, 
E_V32HFmode) != 0
          || !(
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 7060; /* avx512bw_rndscalev32hf */

    case E_V16HFmode:
      if (pattern775 (x3, 
E_V16HFmode) != 0
          || !(
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 7064; /* avx512vl_rndscalev16hf */

    case E_V8HFmode:
      if (pattern775 (x3, 
E_V8HFmode) != 0
          || !(
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 7068; /* avx512fp16_rndscalev8hf */

    case E_V16SFmode:
      if (pattern775 (x3, 
E_V16SFmode) != 0
          || !(
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7072; /* avx512f_rndscalev16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7076; /* avx512vl_rndscalev8sf */
      if (!vector_operand (operands[1], E_V8SFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25467 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8892; /* avx_roundps256 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7080; /* avx512vl_rndscalev4sf */
      if (!vector_operand (operands[1], E_V4SFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !
#line 25467 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return -1;
      return 8893; /* sse4_1_roundps */

    case E_V8DFmode:
      if (pattern775 (x3, 
E_V8DFmode) != 0
          || !(
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7084; /* avx512f_rndscalev8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7088; /* avx512vl_rndscalev4df */
      if (!vector_operand (operands[1], E_V4DFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25467 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8894; /* avx_roundpd256 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7092; /* avx512vl_rndscalev2df */
      if (!vector_operand (operands[1], E_V2DFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25467 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 8895; /* sse4_1_roundpd */

    default:
      return -1;
    }
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && 
#line 524 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3157; /* *reducepv32hf */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && 
#line 525 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3161; /* *reducepv16hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 526 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3165; /* *reducepv8hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3169; /* *reducepv16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3173; /* *reducepv8sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))) && 
#line 527 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3177; /* *reducepv4sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3181; /* *reducepv8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3185; /* *reducepv4df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vector_operand (operands[1], E_V2DFmode)
          || !(
#line 4028 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 528 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3189; /* *reducepv2df */

    default:
      return -1;
    }
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  switch (pattern1060 (x2, 
E_V16QImode))
    {
    case 0:
      if (!(
#line 22451 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
        return -1;
      return 8504; /* *sse2_maskmovdqu */

    case 1:
      if (!(
#line 22451 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
        return -1;
      return 8505; /* *sse2_maskmovdqu */

    default:
      return -1;
    }
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x4))
        {
        case MEM:
          res = recog_241 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          operands[2] = x4;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 1);
          if (rtx_equal_p (x6, operands[0]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern905 (x2, 
E_HImode, 
E_V16SImode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9426; /* avx512f_storev16si_mask */
                  break;

                case E_V8DImode:
                  if (pattern905 (x2, 
E_QImode, 
E_V8DImode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9429; /* avx512f_storev8di_mask */
                  break;

                case E_V16SFmode:
                  if (pattern905 (x2, 
E_HImode, 
E_V16SFmode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9432; /* avx512f_storev16sf_mask */
                  break;

                case E_V8SFmode:
                  if (pattern905 (x2, 
E_QImode, 
E_V8SFmode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9433; /* avx512vl_storev8sf_mask */
                  break;

                case E_V4SFmode:
                  if (pattern905 (x2, 
E_QImode, 
E_V4SFmode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9434; /* avx512vl_storev4sf_mask */
                  break;

                case E_V8DFmode:
                  if (pattern905 (x2, 
E_QImode, 
E_V8DFmode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9435; /* avx512f_storev8df_mask */
                  break;

                case E_V4DFmode:
                  if (pattern905 (x2, 
E_QImode, 
E_V4DFmode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9436; /* avx512vl_storev4df_mask */
                  break;

                case E_V2DFmode:
                  if (pattern905 (x2, 
E_QImode, 
E_V2DFmode) == 0
                      && (
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9437; /* avx512vl_storev2df_mask */
                  break;

                case E_V64QImode:
                  if (pattern905 (x2, 
E_DImode, 
E_V64QImode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9438; /* avx512bw_storev64qi_mask */
                  break;

                case E_V16QImode:
                  if (pattern905 (x2, 
E_HImode, 
E_V16QImode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9439; /* avx512vl_storev16qi_mask */
                  break;

                case E_V32QImode:
                  if (pattern905 (x2, 
E_SImode, 
E_V32QImode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9440; /* avx512vl_storev32qi_mask */
                  break;

                case E_V32HImode:
                  if (pattern905 (x2, 
E_SImode, 
E_V32HImode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9441; /* avx512bw_storev32hi_mask */
                  break;

                case E_V16HImode:
                  if (pattern905 (x2, 
E_HImode, 
E_V16HImode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9442; /* avx512vl_storev16hi_mask */
                  break;

                case E_V8HImode:
                  if (pattern905 (x2, 
E_QImode, 
E_V8HImode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9443; /* avx512vl_storev8hi_mask */
                  break;

                case E_V32HFmode:
                  if (pattern905 (x2, 
E_SImode, 
E_V32HFmode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9444; /* avx512bw_storev32hf_mask */
                  break;

                case E_V16HFmode:
                  if (pattern905 (x2, 
E_HImode, 
E_V16HFmode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9445; /* avx512vl_storev16hf_mask */
                  break;

                case E_V8HFmode:
                  if (pattern905 (x2, 
E_QImode, 
E_V8HFmode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9446; /* avx512fp16_storev8hf_mask */
                  break;

                case E_V32BFmode:
                  if (pattern905 (x2, 
E_SImode, 
E_V32BFmode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9447; /* avx512bw_storev32bf_mask */
                  break;

                case E_V16BFmode:
                  if (pattern905 (x2, 
E_HImode, 
E_V16BFmode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9448; /* avx512vl_storev16bf_mask */
                  break;

                case E_V8BFmode:
                  if (pattern905 (x2, 
E_QImode, 
E_V8BFmode) == 0
                      && (
#line 28753 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9449; /* avx512vl_storev8bf_mask */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern782 (x2, 
E_V4SFmode, 
E_V4SImode) != 0
              || !
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9418; /* avx_maskstoreps */

        case E_V2DFmode:
          if (pattern782 (x2, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9419; /* avx_maskstorepd */

        case E_V4DImode:
          if (!memory_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_V4DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V4DImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9420; /* avx2_maskstoreq256 */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9430; /* avx512vl_storev4di_mask */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V2DImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9421; /* avx2_maskstoreq */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9431; /* avx512vl_storev2di_mask */

        case E_V8SFmode:
          if (pattern782 (x2, 
E_V8SFmode, 
E_V8SImode) != 0
              || !
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9422; /* avx_maskstoreps256 */

        case E_V4DFmode:
          if (pattern782 (x2, 
E_V4DFmode, 
E_V4DImode) != 0
              || !
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9423; /* avx_maskstorepd256 */

        case E_V8SImode:
          if (!memory_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || !register_operand (operands[1], E_V8SImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V8SImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9424; /* avx2_maskstored256 */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9427; /* avx512vl_storev8si_mask */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (register_operand (operands[2], E_V4SImode)
              && rtx_equal_p (x4, operands[0])
              && 
#line 28633 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9425; /* avx2_maskstored */
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode)
              || !rtx_equal_p (x6, operands[0])
              || !(
#line 28724 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9428; /* avx512vl_storev4si_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[2] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern784 (x2))
        {
        case 0:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9450; /* *avx512bw_storev64qi_mask_1 */

        case 1:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9451; /* *avx512vl_storev32qi_mask_1 */

        case 2:
          if (!
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 9452; /* *avx512vl_storev16qi_mask_1 */

        case 3:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9453; /* *avx512bw_storev32hi_mask_1 */

        case 4:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9454; /* *avx512vl_storev16hi_mask_1 */

        case 5:
          if (!
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 9455; /* *avx512vl_storev8hi_mask_1 */

        case 6:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9456; /* *avx512f_storev16si_mask_1 */

        case 7:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9457; /* *avx512vl_storev8si_mask_1 */

        case 8:
          if (!
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 9458; /* *avx512vl_storev4si_mask_1 */

        case 9:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9459; /* *avx512f_storev8di_mask_1 */

        case 10:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9460; /* *avx512vl_storev4di_mask_1 */

        case 11:
          if (!
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 9461; /* *avx512vl_storev2di_mask_1 */

        case 12:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9462; /* *avx512bw_storev32hf_mask_1 */

        case 13:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9463; /* *avx512vl_storev16hf_mask_1 */

        case 14:
          if (!
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 9464; /* *avx512fp16_storev8hf_mask_1 */

        case 15:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9465; /* *avx512bw_storev32bf_mask_1 */

        case 16:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9466; /* *avx512vl_storev16bf_mask_1 */

        case 17:
          if (!
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 9467; /* *avx512vl_storev8bf_mask_1 */

        case 18:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9468; /* *avx512f_storev16sf_mask_1 */

        case 19:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9469; /* *avx512vl_storev8sf_mask_1 */

        case 20:
          if (!
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()))
            return -1;
          return 9470; /* *avx512vl_storev4sf_mask_1 */

        case 21:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9471; /* *avx512f_storev8df_mask_1 */

        case 22:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9472; /* *avx512vl_storev4df_mask_1 */

        case 23:
          if (!(
#line 28767 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9473; /* *avx512vl_storev2df_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern1127 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 1849 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 2552; /* *sse2_movq128_v2di */

            case E_V2DFmode:
              if (pattern1127 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 1849 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 2553; /* *sse2_movq128_v2df */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!nonimmediate_operand (operands[2], E_DFmode)
              || pattern1128 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 14714 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7139; /* sse2_loadhpd */

        default:
          return -1;
        }

    case 2:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1128 (x2, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !nonimmediate_operand (operands[2], E_V2SFmode)
              || !
#line 11608 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 5178; /* sse_loadhps */

        case E_V4DImode:
          if (pattern1129 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 28447 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9390; /* vec_set_hi_v4di */

        case E_V4DFmode:
          if (pattern1129 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 28447 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 9392; /* vec_set_hi_v4df */

        default:
          return -1;
        }

    case 8:
      if (pattern666 (x4) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1129 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !(
#line 20098 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8326; /* vec_set_hi_v16sf */

        case E_V16SImode:
          if (pattern1129 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !(
#line 20098 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8328; /* vec_set_hi_v16si */

        case E_V16HImode:
          if (pattern1129 (x2, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 28542 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9405; /* vec_set_hi_v16hi */

        case E_V16HFmode:
          if (pattern1129 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
              || !
#line 28542 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9406; /* vec_set_hi_v16hf */

        case E_V16BFmode:
          if (pattern1129 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
              || !
#line 28542 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9407; /* vec_set_hi_v16bf */

        default:
          return -1;
        }

    case 4:
      if (pattern667 (x4, 
3, 
2, 
1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1129 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !(
#line 20128 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8334; /* vec_set_hi_v8df */

        case E_V8DImode:
          if (pattern1129 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 20128 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8336; /* vec_set_hi_v8di */

        case E_V8SImode:
          if (pattern1129 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 28495 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9398; /* vec_set_hi_v8si */

        case E_V8SFmode:
          if (pattern1129 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 28495 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 9400; /* vec_set_hi_v8sf */

        default:
          return -1;
        }

    case 16:
      if (pattern785 (x4, 
6, 
5, 
4) != 0
          || pattern1464 (x4, 
11, 
10, 
9, 
8, 
7) != 0
          || pattern1129 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 28594 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9409; /* vec_set_hi_v32qi */

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 46:
          if (GET_MODE (x3) == E_V4SImode
              && pattern788 (x2, 
E_V4SImode, 
E_V4DFmode, 
E_V8SImode) == 0
              && 
#line 9419 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 4932; /* *avx_cvtpd2dq256_2 */
          if (GET_MODE (x3) != E_V2SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != CONST_VECTOR
              || pattern510 (x5, 
E_V2SImode, 
2) != 0
              || !register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vector_operand (operands[1], E_V2DFmode)
              || !
#line 9432 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4933; /* sse2_cvtpd2dq */

        case 156:
          if (pattern664 (x2) != 0
              || !
#line 9502 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4944; /* fixuns_notruncv2dfv2si2 */

        case 173:
          if (pattern664 (x2) != 0
              || !
#line 9569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4963; /* *unspec_fixuns_truncv2dfv2si2 */

        case 253:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10417; /* *vcvtph2bf8v8hf */

        case 254:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10418; /* *vcvtph2bf8sv8hf */

        case 255:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10419; /* *vcvtph2hf8v8hf */

        case 256:
          if (GET_MODE (x3) != E_V8QImode
              || pattern788 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10420; /* *vcvtph2hf8sv8hf */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_255_operand (operands[2], E_SImode)
              || !const0_operand (operands[3], E_V4HImode)
              || !
#line 29135 "../../gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL) && 1))
            return -1;
          return 9581; /* *vcvtps2ph */

        case 245:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10393; /* *vcvtbiasph2bf8v8hf */

        case 246:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10394; /* *vcvtbiasph2bf8sv8hf */

        case 247:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10395; /* *vcvtbiasph2hf8v8hf */

        case 248:
          if (pattern911 (x2) != 0
              || !
#line 31772 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10396; /* *vcvtbiasph2hf8sv8hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3760; /* *fma_fmadd_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3780; /* *fma_fmadd_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3761; /* *fma_fmadd_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3789; /* *fma_fmadd_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3762; /* *fma_fmadd_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3778; /* *fma_fmadd_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 5918 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3763; /* *fma_fmadd_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3787; /* *fma_fmadd_v4df */

        case E_V32HFmode:
          if (pattern858 (x2, 
E_V32HFmode) != 0
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3764; /* *fma_fmadd_v32hf */

        case E_V16HFmode:
          if (pattern858 (x2, 
E_V16HFmode) != 0
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3768; /* *fma_fmadd_v16hf */

        case E_V8HFmode:
          if (pattern858 (x2, 
E_V8HFmode) != 0
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3770; /* *fma_fmadd_v8hf */

        case E_V16SFmode:
          if (pattern858 (x2, 
E_V16SFmode) != 0
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3774; /* *fma_fmadd_v16sf */

        case E_V8DFmode:
          if (pattern858 (x2, 
E_V8DFmode) != 0
              || !(
#line 5946 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3783; /* *fma_fmadd_v8df */

        case E_V32BFmode:
          if (pattern913 (x2, 
E_V32BFmode) != 0
              || !
#line 32143 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10552; /* avx10_2_fmaddbf16_v32bf */

        case E_V16BFmode:
          if (pattern913 (x2, 
E_V16BFmode) != 0
              || !
#line 32143 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10554; /* avx10_2_fmaddbf16_v16bf */

        case E_V8BFmode:
          if (pattern913 (x2, 
E_V8BFmode) != 0
              || !
#line 32143 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10556; /* avx10_2_fmaddbf16_v8bf */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x4) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6017 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3823; /* *fma_fmsub_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3843; /* *fma_fmsub_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x4) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 6017 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3824; /* *fma_fmsub_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3852; /* *fma_fmsub_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x4) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 6017 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3825; /* *fma_fmsub_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3841; /* *fma_fmsub_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x4) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 6017 "../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3826; /* *fma_fmsub_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3850; /* *fma_fmsub_v4df */

        case E_V32HFmode:
          if (pattern859 (x2, 
E_V32HFmode) != 0
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3827; /* *fma_fmsub_v32hf */

        case E_V16HFmode:
          if (pattern859 (x2, 
E_V16HFmode) != 0
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3831; /* *fma_fmsub_v16hf */

        case E_V8HFmode:
          if (pattern859 (x2, 
E_V8HFmode) != 0
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3833; /* *fma_fmsub_v8hf */

        case E_V16SFmode:
          if (pattern859 (x2, 
E_V16SFmode) != 0
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3837; /* *fma_fmsub_v16sf */

        case E_V8DFmode:
          if (pattern859 (x2, 
E_V8DFmode) != 0
              || !(
#line 6049 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3846; /* *fma_fmsub_v8df */

        case E_V32BFmode:
          if (pattern914 (x2, 
E_V32BFmode) != 0
              || !
#line 32271 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10576; /* avx10_2_fmsubbf16_v32bf */

        case E_V16BFmode:
          if (pattern914 (x2, 
E_V16BFmode) != 0
              || !
#line 32271 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10578; /* avx10_2_fmsubbf16_v16bf */

        case E_V8BFmode:
          if (pattern914 (x2, 
E_V8BFmode) != 0
              || !
#line 32271 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10580; /* avx10_2_fmsubbf16_v8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern668 (x3) != 0)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 0);
  switch (XWINT (x6, 0))
    {
    case 8L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 40L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 9L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 41L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 10L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 42L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 11L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 43L
          || pattern1865 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 24L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 56L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 25L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 57L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 26L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 58L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 27L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 59L
          || pattern1871 (x3) != 0
          || pattern1400 (x2, 
E_V32QImode, 
E_V64QImode) != 0
          || !
#line 19438 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8246; /* avx2_interleave_highv32qi */

    case 0L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 32L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 1L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 33L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 2L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 34L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 3L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 35L)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 16L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 48L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 17L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 49L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 18L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 50L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 19L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 51L)
        return -1;
      x22 = XVECEXP (x3, 0, 8);
      switch (XWINT (x22, 0))
        {
        case 4L:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 36L)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 5L)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 37L)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 6L)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 38L)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 7L)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 39L)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 20L)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 52L)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 21L)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 53L)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 22L)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 54L)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 23L)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 55L
              || pattern1400 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !
#line 19534 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
            return -1;
          return 8252; /* avx2_interleave_lowv32qi */

        case 8L:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 40L)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 9L)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 41L)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 10L)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 42L)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 11L)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 43L)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 24L)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 56L)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 25L)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 57L)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 26L)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 58L)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 27L)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 59L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1400 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 19654 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8274; /* *avx512bw_interleave_lowv32hi */

            case E_V32HFmode:
              if (pattern1400 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 19654 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8276; /* *avx512bw_interleave_lowv32hf */

            case E_V32BFmode:
              if (pattern1400 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 19654 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8278; /* *avx512bw_interleave_lowv32bf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 36L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 5L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 37L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 6L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 38L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 7L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 39L
          || pattern1865 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 20L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 52L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 21L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 53L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 22L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 54L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 23L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 55L
          || pattern1871 (x3) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1400 (x2, 
E_V32HImode, 
E_V64HImode) != 0
              || !(
#line 19586 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8256; /* avx512bw_interleave_highv32hi */

        case E_V32HFmode:
          if (pattern1400 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
              || !(
#line 19586 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8258; /* avx512bw_interleave_highv32hf */

        case E_V32BFmode:
          if (pattern1400 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
              || !(
#line 19586 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8260; /* avx512bw_interleave_highv32bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode))
        {
          if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
              && 
#line 27351 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return 9079; /* *avx_vperm_broadcast_v4sf */
          if (
#line 27488 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4SFmode)))
            return 9086; /* *avx_vpermilpv4sf */
        }
      if (!register_operand (operands[1], E_V4SFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9384; /* *ssse3_palignrv4sf_perm */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27379 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V8SFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 9080; /* *avx_vperm_broadcast_v8sf */
      if (!(
#line 27488 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8SFmode)) && 
#line 374 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 9084; /* *avx_vpermilpv8sf */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27379 "../../gcc/config/i386/sse.md"
(TARGET_AVX
   && (V4DFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 9081; /* *avx_vperm_broadcast_v4df */
      if (!(
#line 27488 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4DFmode)) && 
#line 375 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 9090; /* *avx_vpermilpv4df */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 27488 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V16SFmode)) && 
#line 374 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9082; /* *avx512f_vpermilpv16sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode)
          || !(
#line 27488 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8DFmode)) && 
#line 375 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9088; /* *avx512f_vpermilpv8df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && (
#line 27488 "../../gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V2DFmode)) && 
#line 376 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 9092; /* *avx_vpermilpv2df */
      if (!register_operand (operands[1], E_V2DFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !(
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 342 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 9385; /* *ssse3_palignrv2df_perm */

    case E_V16QImode:
      if (pattern1131 (x2, 
E_V16QImode) != 0
          || !
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9378; /* *ssse3_palignrv16qi_perm */

    case E_V8HImode:
      if (pattern1131 (x2, 
E_V8HImode) != 0
          || !
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9379; /* *ssse3_palignrv8hi_perm */

    case E_V8HFmode:
      if (pattern1131 (x2, 
E_V8HFmode) != 0
          || !
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9380; /* *ssse3_palignrv8hf_perm */

    case E_V8BFmode:
      if (pattern1131 (x2, 
E_V8BFmode) != 0
          || !
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9381; /* *ssse3_palignrv8bf_perm */

    case E_V4SImode:
      if (pattern1131 (x2, 
E_V4SImode) != 0
          || !
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9382; /* *ssse3_palignrv4si_perm */

    case E_V2DImode:
      if (pattern1131 (x2, 
E_V2DImode) != 0
          || !
#line 28340 "../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 9383; /* *ssse3_palignrv2di_perm */

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern529 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5437; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5464; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5491; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5518; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5545; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5572; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5599; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5626; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5653; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5680; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5707; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5734; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5440; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5467; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5494; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5521; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5548; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5575; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5602; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5629; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5656; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5683; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5710; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5737; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5443; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5470; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5497; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5524; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5551; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5578; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5605; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5632; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5659; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5686; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5713; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5740; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6727; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6736; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6745; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6754; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6763; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6772; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6781; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6790; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6799; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6808; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6817; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6826; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6085; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6112; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6139; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6166; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6193; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6220; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6247; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6274; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6301; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6328; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6355; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6382; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6088; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6115; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6142; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6169; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6196; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6223; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6250; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6277; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6304; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6331; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6358; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6385; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6091; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6118; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6145; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6172; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6199; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6226; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6253; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6280; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6307; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6334; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6361; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6388; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_VECTOR
      || XVECLEN (x5, 0) != 32
      || pattern1345 (x5, 
E_V32HImode) != 0)
    return -1;
  x6 = XVECEXP (x5, 0, 8);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 9);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x5, 0, 10);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x5, 0, 11);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x5, 0, 12);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XVECEXP (x5, 0, 13);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x5, 0, 14);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x5, 0, 15);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x5, 0, 16);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x5, 0, 17);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XVECEXP (x5, 0, 18);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XVECEXP (x5, 0, 19);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x18 = XVECEXP (x5, 0, 20);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x19 = XVECEXP (x5, 0, 21);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XVECEXP (x5, 0, 22);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x21 = XVECEXP (x5, 0, 23);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x22 = XVECEXP (x5, 0, 24);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x5, 0, 25);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x24 = XVECEXP (x5, 0, 26);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x25 = XVECEXP (x5, 0, 27);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XVECEXP (x5, 0, 28);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XVECEXP (x5, 0, 29);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x28 = XVECEXP (x5, 0, 30);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x29 = XVECEXP (x5, 0, 31);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x2) != E_V32HImode
      || GET_MODE (x3) != E_V32SImode
      || pattern1494 (x4, 
E_V32SImode) != 0)
    return -1;
  x30 = XEXP (x4, 0);
  x31 = XEXP (x30, 0);
  x32 = XEXP (x31, 1);
  if (GET_MODE (x32) != E_V32SImode)
    return -1;
  x33 = XEXP (x32, 0);
  operands[2] = x33;
  if (!nonimmediate_operand (operands[2], E_V32HImode)
      || !
#line 22817 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
    return -1;
  return 8537; /* avx512bw_umulhrswv32hi3 */
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 177:
          return recog_215 (x1, insn, pnum_clobbers);

        case 118:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 1881 "../../gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          *pnum_clobbers = 1;
          return 2556; /* movdi_to_sse */

        case 119:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32QImode:
              if (!register_operand (operands[0], E_V32QImode)
                  || GET_MODE (x2) != E_V32QImode
                  || !memory_operand (operands[1], E_V32QImode)
                  || !(
#line 1989 "../../gcc/config/i386/sse.md"
(TARGET_SSE3) && 
#line 600 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2557; /* avx_lddqu256 */

            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !memory_operand (operands[1], E_V16QImode)
                  || !
#line 1989 "../../gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2558; /* sse3_lddqu */

            default:
              return -1;
            }

        case 117:
          return recog_211 (x1, insn, pnum_clobbers);

        case 54:
          return recog_213 (x1, insn, pnum_clobbers);

        case 161:
          switch (pattern322 (x2))
            {
            case 0:
              if (!(
#line 3007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2886; /* *rcp14v16sf */

            case 1:
              if (!(
#line 3007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2888; /* *rcp14v8sf */

            case 2:
              if (!(
#line 3007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2890; /* *rcp14v4sf */

            case 3:
              if (!(
#line 3007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2892; /* *rcp14v8df */

            case 4:
              if (!(
#line 3007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2894; /* *rcp14v4df */

            case 5:
              if (!(
#line 3007 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2896; /* *rcp14v2df */

            default:
              return -1;
            }

        case 55:
          return recog_212 (x1, insn, pnum_clobbers);

        case 162:
          switch (pattern322 (x2))
            {
            case 0:
              if (!(
#line 3161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2958; /* *rsqrt14v16sf */

            case 1:
              if (!(
#line 3161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2960; /* *rsqrt14v8sf */

            case 2:
              if (!(
#line 3161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2962; /* *rsqrt14v4sf */

            case 3:
              if (!(
#line 3161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2964; /* *rsqrt14v8df */

            case 4:
              if (!(
#line 3161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2966; /* *rsqrt14v4df */

            case 5:
              if (!(
#line 3161 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2968; /* *rsqrt14v2df */

            default:
              return -1;
            }

        case 156:
          return recog_209 (x1, insn, pnum_clobbers);

        case 46:
          return recog_205 (x1, insn, pnum_clobbers);

        case 172:
          return recog_210 (x1, insn, pnum_clobbers);

        case 173:
          return recog_208 (x1, insn, pnum_clobbers);

        case 165:
          return recog_207 (x1, insn, pnum_clobbers);

        case 127:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DImode:
              if (!register_operand (operands[0], E_V8DImode)
                  || GET_MODE (x2) != E_V8DImode
                  || !memory_operand (operands[1], E_V8DImode)
                  || !(
#line 23769 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 8642; /* avx512f_movntdqa */

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x2) != E_V4DImode
                  || !memory_operand (operands[1], E_V4DImode)
                  || !(
#line 23769 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 8643; /* avx2_movntdqa */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !memory_operand (operands[1], E_V2DImode)
                  || !
#line 23769 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8644; /* sse4_1_movntdqa */

            default:
              return -1;
            }

        case 129:
          if (GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V8HImode)
              || !
#line 24095 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8677; /* sse4_1_phminposuw */

        case 136:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 26982 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8980; /* xop_frczv4sf2 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 26982 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8981; /* xop_frczv2df2 */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8SFmode)
                  || !
#line 26982 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8982; /* xop_frczv8sf2 */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x2) != E_V4DFmode
                  || !nonimmediate_operand (operands[1], E_V4DFmode)
                  || !
#line 26982 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8983; /* xop_frczv4df2 */

            default:
              return -1;
            }

        case 134:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              operands[1] = x4;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              x6 = XEXP (x4, 1);
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1006 (x2, 
E_V16QImode) != 0
                      || !
#line 27045 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8994; /* xop_maskcmp_uns2v16qi3 */

                case E_V8HImode:
                  if (pattern1006 (x2, 
E_V8HImode) != 0
                      || !
#line 27045 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8995; /* xop_maskcmp_uns2v8hi3 */

                case E_V4SImode:
                  if (pattern1006 (x2, 
E_V4SImode) != 0
                      || !
#line 27045 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8996; /* xop_maskcmp_uns2v4si3 */

                case E_V2DImode:
                  if (pattern1006 (x2, 
E_V2DImode) != 0
                      || !
#line 27045 "../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8997; /* xop_maskcmp_uns2v2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 141:
          if (GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[0], E_V2DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V2DImode)
              || !
#line 27159 "../../gcc/config/i386/sse.md"
(TARGET_AES))
            return -1;
          return 9010; /* aesimc */

        case 149:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !memory_operand (operands[1], E_V4HImode)
                  || !
#line 29077 "../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
                return -1;
              return 9573; /* *vcvtph2ps_load */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 29087 "../../gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
                return -1;
              return 9575; /* vcvtph2ps256 */

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x2) != E_V16SFmode
                  || !vector_operand (operands[1], E_V16HImode)
                  || !
#line 29099 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 9577; /* *avx512f_vcvtph2ps512 */

            default:
              return -1;
            }

        case 168:
          return recog_214 (x1, insn, pnum_clobbers);

        case 253:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10425; /* vcvtph2bf8v16hf */

            case 1:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10433; /* vcvtph2bf8v32hf */

            default:
              return -1;
            }

        case 254:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10427; /* vcvtph2bf8sv16hf */

            case 1:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10435; /* vcvtph2bf8sv32hf */

            default:
              return -1;
            }

        case 255:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10429; /* vcvtph2hf8v16hf */

            case 1:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10437; /* vcvtph2hf8v32hf */

            default:
              return -1;
            }

        case 256:
          switch (pattern324 (x2))
            {
            case 0:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10431; /* vcvtph2hf8sv16hf */

            case 1:
              if (!
#line 31909 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10439; /* vcvtph2hf8sv32hf */

            default:
              return -1;
            }

        case 257:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x2) != E_V32HFmode
                  || !nonimmediate_operand (operands[1], E_V32QImode)
                  || !
#line 31918 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10441; /* vcvthf82phv32hf */

            case E_V16HFmode:
              if (!register_operand (operands[0], E_V16HFmode)
                  || GET_MODE (x2) != E_V16HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31918 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10443; /* vcvthf82phv16hf */

            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31918 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10445; /* vcvthf82phv8hf */

            default:
              return -1;
            }

        case 263:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10654; /* avx10_2_cvtbf162ibsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10662; /* avx10_2_cvtbf162ibsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10670; /* avx10_2_cvtbf162ibsv8bf */

            default:
              return -1;
            }

        case 264:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10656; /* avx10_2_cvtbf162iubsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10664; /* avx10_2_cvtbf162iubsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10672; /* avx10_2_cvtbf162iubsv8bf */

            default:
              return -1;
            }

        case 269:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10658; /* avx10_2_cvttbf162ibsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10666; /* avx10_2_cvttbf162ibsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10674; /* avx10_2_cvttbf162ibsv8bf */

            default:
              return -1;
            }

        case 270:
          switch (pattern325 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10660; /* avx10_2_cvttbf162iubsv32bf */

            case 1:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10668; /* avx10_2_cvttbf162iubsv16bf */

            case 2:
              if (!
#line 32491 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10676; /* avx10_2_cvttbf162iubsv8bf */

            default:
              return -1;
            }

        case 265:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32506 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10678; /* avx10_2_cvtph2ibsv32hf */

            case 1:
              if (!
#line 32506 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10686; /* avx10_2_cvtph2ibsv16hf */

            case 2:
              if (!
#line 32506 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10690; /* avx10_2_cvtph2ibsv8hf */

            default:
              return -1;
            }

        case 266:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32506 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10682; /* avx10_2_cvtph2iubsv32hf */

            case 1:
              if (!
#line 32506 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10688; /* avx10_2_cvtph2iubsv16hf */

            case 2:
              if (!
#line 32506 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10692; /* avx10_2_cvtph2iubsv8hf */

            default:
              return -1;
            }

        case 271:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32521 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10694; /* avx10_2_cvttph2ibsv32hf */

            case 1:
              if (!
#line 32521 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10702; /* avx10_2_cvttph2ibsv16hf */

            case 2:
              if (!
#line 32521 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10706; /* avx10_2_cvttph2ibsv8hf */

            default:
              return -1;
            }

        case 272:
          switch (pattern325 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32521 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10698; /* avx10_2_cvttph2iubsv32hf */

            case 1:
              if (!
#line 32521 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10704; /* avx10_2_cvttph2iubsv16hf */

            case 2:
              if (!
#line 32521 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10708; /* avx10_2_cvttph2iubsv8hf */

            default:
              return -1;
            }

        case 267:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32536 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10710; /* avx10_2_cvtps2ibsv16sf */

            case 1:
              if (!
#line 32536 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10718; /* avx10_2_cvtps2ibsv8sf */

            case 2:
              if (!
#line 32536 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10722; /* avx10_2_cvtps2ibsv4sf */

            default:
              return -1;
            }

        case 268:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32536 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10714; /* avx10_2_cvtps2iubsv16sf */

            case 1:
              if (!
#line 32536 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10720; /* avx10_2_cvtps2iubsv8sf */

            case 2:
              if (!
#line 32536 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10724; /* avx10_2_cvtps2iubsv4sf */

            default:
              return -1;
            }

        case 273:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32551 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10726; /* avx10_2_cvttps2ibsv16sf */

            case 1:
              if (!
#line 32551 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10734; /* avx10_2_cvttps2ibsv8sf */

            case 2:
              if (!
#line 32551 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10738; /* avx10_2_cvttps2ibsv4sf */

            default:
              return -1;
            }

        case 274:
          switch (pattern326 (x2))
            {
            case 0:
              if (!(
#line 32551 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10730; /* avx10_2_cvttps2iubsv16sf */

            case 1:
              if (!
#line 32551 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10736; /* avx10_2_cvttps2iubsv8sf */

            case 2:
              if (!
#line 32551 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10740; /* avx10_2_cvttps2iubsv4sf */

            default:
              return -1;
            }

        case 275:
          switch (pattern327 (x2))
            {
            case 0:
              if (!(
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 385 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10742; /* avx10_2_vcvttps2dqsv16sf */

            case 1:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10750; /* avx10_2_vcvttps2dqsv8sf */

            case 2:
              if (!(
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 386 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10758; /* avx10_2_vcvttpd2dqsv8df */

            case 3:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10754; /* avx10_2_vcvttps2dqsv4sf */

            case 4:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10766; /* avx10_2_vcvttpd2dqsv4df */

            case 5:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10770; /* avx10_2_vcvttpd2dqsv2df */

            case 6:
              if (!(
#line 32581 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 450 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10774; /* avx10_2_vcvttpd2qqsv8df */

            case 7:
              if (!(
#line 32592 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 617 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10790; /* avx10_2_vcvttps2qqsv8di */

            case 8:
              if (!
#line 32581 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10782; /* avx10_2_vcvttpd2qqsv4df */

            case 9:
              if (!
#line 32592 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10798; /* avx10_2_vcvttps2qqsv4di */

            case 10:
              if (!
#line 32581 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10786; /* avx10_2_vcvttpd2qqsv2df */

            case 11:
              if (!
#line 32592 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10802; /* avx10_2_vcvttps2qqsv2di */

            default:
              return -1;
            }

        case 276:
          switch (pattern327 (x2))
            {
            case 0:
              if (!(
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 385 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10746; /* avx10_2_vcvttps2udqsv16sf */

            case 1:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10752; /* avx10_2_vcvttps2udqsv8sf */

            case 2:
              if (!(
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 386 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10762; /* avx10_2_vcvttpd2udqsv8df */

            case 3:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10756; /* avx10_2_vcvttps2udqsv4sf */

            case 4:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10768; /* avx10_2_vcvttpd2udqsv4df */

            case 5:
              if (!
#line 32570 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10772; /* avx10_2_vcvttpd2udqsv2df */

            case 6:
              if (!(
#line 32581 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 450 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10778; /* avx10_2_vcvttpd2uqqsv8df */

            case 7:
              if (!(
#line 32592 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 617 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10794; /* avx10_2_vcvttps2uqqsv8di */

            case 8:
              if (!
#line 32581 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10784; /* avx10_2_vcvttpd2uqqsv4df */

            case 9:
              if (!
#line 32592 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10800; /* avx10_2_vcvttps2uqqsv4di */

            case 10:
              if (!
#line 32581 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10788; /* avx10_2_vcvttpd2uqqsv2df */

            case 11:
              if (!
#line 32592 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10804; /* avx10_2_vcvttps2uqqsv2di */

            default:
              return -1;
            }

        case 279:
          return recog_206 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 2:
      return recog_263 (x1, insn, pnum_clobbers);

    case 3:
      return recog_262 (x1, insn, pnum_clobbers);

    case 4:
      return recog_261 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_296 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !nonimmediate_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 14872 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7143; /* vec_dupv2df */
          if (!(
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9212; /* *avx512vl_vec_dup_gprv2df */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27733 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9158; /* *avx512f_broadcastv16sf */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9202; /* *avx512f_vec_dup_gprv16sf */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 28053 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9258; /* *avx512dq_broadcastv16sf_1 */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 27733 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9160; /* *avx512f_broadcastv16si */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9190; /* *avx512f_vec_dup_gprv16si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 28053 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9260; /* *avx512dq_broadcastv16si_1 */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 27745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9162; /* *avx512f_broadcastv8df */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9208; /* *avx512f_vec_dup_gprv8df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28071 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9264; /* *avx512dq_broadcastv8df_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 27745 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9164; /* *avx512f_broadcastv8di */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9196; /* *avx512f_vec_dup_gprv8di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28071 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9262; /* *avx512dq_broadcastv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x3) != E_V64QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !(
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9166; /* *avx512bw_vec_dup_gprv64qi */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9168; /* *avx512vl_vec_dup_gprv16qi */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9223; /* *vec_dupv16qi */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9170; /* *avx512vl_vec_dup_gprv32qi */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9222; /* *vec_dupv32qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x3) != E_V32HImode
              || !nonimmediate_operand (operands[1], E_HImode)
              || !(
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9172; /* *avx512bw_vec_dup_gprv32hi */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9174; /* *avx512vl_vec_dup_gprv16hi */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9224; /* *vec_dupv16hi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9176; /* *avx512vl_vec_dup_gprv8hi */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9225; /* *vec_dupv8hi */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x3) != E_V32HFmode
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !(
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9178; /* *avx512bw_vec_dup_gprv32hf */

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x3) != E_V16HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9180; /* *avx512vl_vec_dup_gprv16hf */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9228; /* *vec_dupv16hf */

        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9182; /* *avx512fp16_vec_dup_gprv8hf */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9229; /* *vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x3) != E_V32BFmode
              || !nonimmediate_operand (operands[1], E_BFmode)
              || !(
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9184; /* *avx512bw_vec_dup_gprv32bf */

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x3) != E_V16BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9186; /* *avx512vl_vec_dup_gprv16bf */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9230; /* *vec_dupv16bf */

        case E_V8BFmode:
          if (!register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27757 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9188; /* *avx512vl_vec_dup_gprv8bf */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9231; /* *vec_dupv8bf */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9192; /* *avx512vl_vec_dup_gprv8si */
              if (
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 9226; /* *vec_dupv8si */
              if (!
#line 27939 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9232; /* vec_dupv8si */

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !
#line 28040 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 9254; /* *avx512vl_broadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9194; /* *avx512vl_vec_dup_gprv4si */
          if (
#line 27816 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 9215; /* *vec_dupv4si */
          if (!
#line 27919 "../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 9227; /* *vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9198; /* *avx512vl_vec_dup_gprv4di */
              if (!
#line 27939 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9234; /* vec_dupv4di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28071 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9266; /* *avx512dq_broadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9200; /* *avx512vl_vec_dup_gprv2di */
          if (!
#line 27844 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 9216; /* *vec_dupv2di */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if ((
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9204; /* *avx512vl_vec_dup_gprv8sf */
              if (!
#line 27939 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9233; /* vec_dupv8sf */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 28040 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 9256; /* *avx512vl_broadcastv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if ((
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 9206; /* *avx512vl_vec_dup_gprv4sf */
          if (!
#line 27784 "../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 9214; /* vec_dupv4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode))
                return -1;
              if ((
#line 27769 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9210; /* *avx512vl_vec_dup_gprv4df */
              if (!
#line 27939 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 9235; /* vec_dupv4df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28071 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9268; /* *avx512dq_broadcastv4df_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          switch (pattern671 (x3, 
E_V8SFmode))
            {
            case 0:
              if (!(
#line 31630 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 10349; /* vbcstnebf162ps_v8sf */

            case 1:
              if (!(
#line 31641 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 10351; /* vbcstnesh2ps_v8sf */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern671 (x3, 
E_V4SFmode))
            {
            case 0:
              if (!
#line 31630 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 10350; /* vbcstnebf162ps_v4sf */

            case 1:
              if (!
#line 31641 "../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 10352; /* vbcstnesh2ps_v4sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7533; /* *ashrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17094 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 743 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7543; /* ashrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28903 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9491; /* avx512vl_ashrvv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7535; /* *ashrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17094 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7544; /* ashrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28903 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9489; /* avx512vl_ashrvv8hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7537; /* *ashrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17094 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 744 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7545; /* ashrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28892 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9479; /* avx2_ashrvv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7539; /* *ashrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17094 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7546; /* ashrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28892 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9477; /* avx2_ashrvv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17080 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7541; /* *ashrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 26970 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !TARGET_AVX512VL && ix86_pre_reload_split ()))
        return 8977; /* *ashrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 28892 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9483; /* avx2_ashrvv2di */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 788 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7551; /* *ashrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28903 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9493; /* avx512bw_ashrvv32hi */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7553; /* *ashrv4di3 */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 28892 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9485; /* avx2_ashrvv4di */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7555; /* *ashrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28892 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 680 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9481; /* avx512f_ashrvv16si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17124 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7557; /* *ashrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28892 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 682 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9487; /* avx512f_ashrvv8di */

    case E_V1TImode:
      if (pattern30 (x3) != 0
          || !
#line 17498 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return -1;
      return 7622; /* *ashrv1ti3_internal */

    default:
      return -1;
    }
}

 int
recog_329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern182 (x3, 
E_V32HFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && 1 && 1) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2783; /* *mulv32hf3 */

        case E_V16HFmode:
          if (pattern182 (x3, 
E_V16HFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && 1 && 1) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2787; /* *mulv16hf3 */

        case E_V8HFmode:
          if (pattern182 (x3, 
E_V8HFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && 1 && 1) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2791; /* *mulv8hf3 */

        case E_V16SFmode:
          if (pattern182 (x3, 
E_V16SFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && 1 && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2795; /* *mulv16sf3 */

        case E_V8SFmode:
          if (pattern182 (x3, 
E_V8SFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && 1 && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2799; /* *mulv8sf3 */

        case E_V4SFmode:
          if (pattern182 (x3, 
E_V4SFmode) != 0
              || !
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2803; /* *mulv4sf3 */

        case E_V8DFmode:
          if (pattern182 (x3, 
E_V8DFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2807; /* *mulv8df3 */

        case E_V4DFmode:
          if (pattern182 (x3, 
E_V4DFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2811; /* *mulv4df3 */

        case E_V2DFmode:
          if (pattern182 (x3, 
E_V2DFmode) != 0
              || !(
#line 2753 "../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && 1 && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2815; /* *mulv2df3 */

        case E_V32HImode:
          if (pattern25 (x3, 
E_V32HImode) != 0
              || !(
#line 16371 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7483; /* *mulv32hi3 */

        case E_V16HImode:
          if (pattern25 (x3, 
E_V16HImode) != 0
              || !(
#line 16371 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7485; /* *mulv16hi3 */

        case E_V8HImode:
          if (pattern25 (x3, 
E_V8HImode) != 0
              || !
#line 16371 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
            return -1;
          return 7487; /* *mulv8hi3 */

        case E_V8DImode:
          if (pattern182 (x3, 
E_V8DImode) != 0
              || !(
#line 16825 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V8DImode, operands)) && 
#line 623 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7521; /* *avx512dq_mulv8di3 */

        case E_V4DImode:
          if (pattern182 (x3, 
E_V4DImode) != 0
              || !(
#line 16825 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V4DImode, operands)) && 
#line 623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7523; /* *avx512dq_mulv4di3 */

        case E_V2DImode:
          if (pattern182 (x3, 
E_V2DImode) != 0
              || !(
#line 16825 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V2DImode, operands)) && 
#line 623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7525; /* *avx512dq_mulv2di3 */

        case E_V16SImode:
          if (pattern182 (x3, 
E_V16SImode) != 0
              || !(
#line 16884 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V16SImode, operands)
  && 1) && 
#line 671 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7527; /* *avx512f_mulv16si3 */

        case E_V8SImode:
          if (pattern182 (x3, 
E_V8SImode) != 0
              || !(
#line 16884 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V8SImode, operands)
  && 1) && 
#line 671 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7529; /* *avx2_mulv8si3 */

        case E_V4SImode:
          if (pattern182 (x3, 
E_V4SImode) != 0
              || !
#line 16884 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V4SImode, operands)
  && 1))
            return -1;
          return 7531; /* *sse4_1_mulv4si3 */

        case E_V32BFmode:
          if (pattern14 (x3, 
E_V32BFmode) != 0
              || !
#line 32118 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10532; /* avx10_2_mulbf16_v32bf */

        case E_V16BFmode:
          if (pattern14 (x3, 
E_V16BFmode) != 0
              || !
#line 32118 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10540; /* avx10_2_mulbf16_v16bf */

        case E_V8BFmode:
          if (pattern14 (x3, 
E_V8BFmode) != 0
              || !
#line 32118 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10548; /* avx10_2_mulbf16_v8bf */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern194 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 16454 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7501; /* *vec_widen_umult_even_v16si */

        case 1:
          if (!
#line 16490 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7503; /* *vec_widen_umult_even_v8si */

        case 2:
          if (!
#line 16522 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7505; /* *vec_widen_umult_even_v4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern194 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 16570 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7507; /* *vec_widen_smult_even_v16si */

        case 1:
          if (!
#line 16606 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7509; /* *vec_widen_smult_even_v8si */

        case 2:
          if (!
#line 16638 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7511; /* *sse4_1_mulv2siv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern26 (x1))
    {
    case 0:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 389 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2984; /* *sminv32hf3 */

    case 1:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2990; /* *sminv16hf3 */

    case 2:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2994; /* *sminv8hf3 */

    case 3:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3000; /* *sminv16sf3 */

    case 4:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3006; /* *sminv8sf3 */

    case 5:
      if (!
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 3010; /* *sminv4sf3 */

    case 6:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3016; /* *sminv8df3 */

    case 7:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3022; /* *sminv4df3 */

    case 8:
      if (!(
#line 3309 "../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3026; /* *sminv2df3 */

    case 9:
      if (
#line 17653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7684; /* *avx2_sminv32qi3 */
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7761; /* *avx512bw_sminv32qi3 */

    case 10:
      if (
#line 17653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7688; /* *avx2_sminv16hi3 */
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7777; /* *avx512bw_sminv16hi3 */

    case 11:
      if (
#line 17653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7692; /* *avx2_sminv8si3 */
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7705; /* *avx512f_sminv8si3 */

    case 12:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7697; /* *avx512f_sminv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7713; /* *avx512f_sminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17797 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7797; /* *sse4_1_sminv4si3 */

    case 14:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7721; /* *avx512f_sminv8di3 */

    case 15:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7729; /* *avx512f_sminv4di3 */

    case 16:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7737; /* *avx512f_sminv2di3 */

    case 17:
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7745; /* *avx512bw_sminv64qi3 */

    case 18:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7753; /* *avx512bw_sminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17797 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7793; /* *sse4_1_sminv16qi3 */

    case 19:
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7769; /* *avx512bw_sminv32hi3 */

    case 20:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7785; /* *avx512bw_sminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17816 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7800; /* *sminv8hi3 */

    case 21:
      if (!
#line 32108 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10518; /* avx10_2_sminbf16_v32bf */

    case 22:
      if (!
#line 32108 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10522; /* avx10_2_sminbf16_v16bf */

    case 23:
      if (!
#line 32108 "../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10526; /* avx10_2_sminbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (
#line 17653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7686; /* *avx2_uminv32qi3 */
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7765; /* *avx512bw_uminv32qi3 */

    case 1:
      if (
#line 17653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7690; /* *avx2_uminv16hi3 */
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7781; /* *avx512bw_uminv16hi3 */

    case 2:
      if (
#line 17653 "../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7694; /* *avx2_uminv8si3 */
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7709; /* *avx512f_uminv8si3 */

    case 3:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7701; /* *avx512f_uminv16si3 */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7717; /* *avx512f_uminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17881 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7807; /* *sse4_1_uminv4si3 */

    case 5:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7725; /* *avx512f_uminv8di3 */

    case 6:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7733; /* *avx512f_uminv4di3 */

    case 7:
      if (!(
#line 17694 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7741; /* *avx512f_uminv2di3 */

    case 8:
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7749; /* *avx512bw_uminv64qi3 */

    case 9:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7757; /* *avx512bw_uminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17900 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7810; /* *uminv16qi3 */

    case 10:
      if (!(
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7773; /* *avx512bw_uminv32hi3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7789; /* *avx512bw_uminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17881 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7803; /* *sse4_1_uminv8hi3 */

    default:
      return -1;
    }
}

 int
recog_351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || !register_operand (operands[1], E_XFmode)
          || !
#line 23726 "../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1706; /* sqrtxf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 23787 "../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 1709; /* sqrthf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_SFmode)
          || !
#line 23800 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
        return -1;
      return 1710; /* *sqrtsf2_sse */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nonimmediate_operand (operands[1], E_DFmode)
          || !
#line 23800 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
        return -1;
      return 1711; /* *sqrtdf2_sse */

    default:
      return -1;
    }
}

 int
recog_355 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_353 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x4 = XVECEXP (x1, 0, 1);
      if (pattern231 (x4, 
E_CCmode, 
17) == 0)
        {
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && const0_operand (operands[1], E_QImode)
                  && 
#line 3450 "../../gcc/config/i386/i386.md"
(reload_completed))
                return 113; /* *movstrictqi_xor */
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && const0_operand (operands[1], E_HImode)
                  && 
#line 3450 "../../gcc/config/i386/i386.md"
(reload_completed))
                return 114; /* *movstricthi_xor */
              break;

            default:
              break;
            }
        }
      break;

    case PC:
      res = recog_354 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x6), 0))
        return -1;
      switch (pattern1030 (x2))
        {
        case 0:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1028 (x2))
                {
                case 0:
                  return 333; /* *addqi_exthi_1 */

                case 1:
                  return 334; /* *addqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 335; /* *addqi_extdi_1 */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1805 (x2))
            {
            case 0:
              return 336; /* *addqi_exthi_2 */

            case 1:
              return 338; /* *addqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 340; /* *addqi_extdi_2 */

            default:
              return -1;
            }

        case 1:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) == SUBREG)
            {
              switch (pattern1805 (x2))
                {
                case 0:
                  return 337; /* *subqi_exthi_2 */

                case 1:
                  return 339; /* *subqi_extsi_2 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 341; /* *subqi_extdi_2 */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x9;
          if (!general_operand (operands[2], E_QImode))
            return -1;
          switch (pattern1028 (x2))
            {
            case 0:
              return 422; /* *subqi_exthi_1 */

            case 1:
              return 423; /* *subqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 424; /* *subqi_extdi_1 */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1028 (x2))
                {
                case 0:
                  return 773; /* *andqi_exthi_1 */

                case 1:
                  return 776; /* *andqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 779; /* *andqi_extdi_1 */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1805 (x2))
            {
            case 0:
              return 791; /* *andqi_exthi_2 */

            case 1:
              return 794; /* *andqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 797; /* *andqi_extdi_2 */

            default:
              return -1;
            }

        case 3:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1028 (x2))
                {
                case 0:
                  return 774; /* *iorqi_exthi_1 */

                case 1:
                  return 777; /* *iorqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 780; /* *iorqi_extdi_1 */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1805 (x2))
            {
            case 0:
              return 792; /* *iorqi_exthi_2 */

            case 1:
              return 795; /* *iorqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 798; /* *iorqi_extdi_2 */

            default:
              return -1;
            }

        case 4:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1028 (x2))
                {
                case 0:
                  return 775; /* *xorqi_exthi_1 */

                case 1:
                  return 778; /* *xorqi_extsi_1 */

                case 2:
                  if (
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return 781; /* *xorqi_extdi_1 */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1805 (x2))
            {
            case 0:
              return 793; /* *xorqi_exthi_2 */

            case 1:
              return 796; /* *xorqi_extsi_2 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 799; /* *xorqi_extdi_2 */

            default:
              return -1;
            }

        case 5:
          return 988; /* *negqi_exthi_1 */

        case 6:
          return 989; /* *negqi_extsi_1 */

        case 7:
          if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 990; /* *negqi_extdi_1 */

        case 8:
          return 1119; /* *ashlqi_exthi_1 */

        case 9:
          return 1120; /* *ashlqi_extsi_1 */

        case 10:
          if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1121; /* *ashlqi_extdi_1 */

        case 11:
          operands[0] = x3;
          switch (pattern1216 (x6))
            {
            case 0:
              if ((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 1138; /* lshrdi3_doubleword_lowpart */
              break;

            case 1:
              if ((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1140; /* lshrti3_doubleword_lowpart */
              break;

            default:
              break;
            }
          x8 = XEXP (x6, 0);
          if (GET_MODE (x8) != E_QImode)
            return -1;
          switch (pattern1029 (x2))
            {
            case 0:
              return 1238; /* *lshrqi_exthi_1 */

            case 1:
              return 1240; /* *lshrqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 1242; /* *lshrqi_extdi_1 */

            default:
              return -1;
            }

        case 12:
          operands[0] = x3;
          switch (pattern1216 (x6))
            {
            case 0:
              if ((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 1139; /* ashrdi3_doubleword_lowpart */
              break;

            case 1:
              if ((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1141; /* ashrti3_doubleword_lowpart */
              break;

            default:
              break;
            }
          x8 = XEXP (x6, 0);
          if (GET_MODE (x8) != E_QImode)
            return -1;
          switch (pattern1029 (x2))
            {
            case 0:
              return 1239; /* *ashrqi_exthi_1 */

            case 1:
              return 1241; /* *ashrqi_extsi_1 */

            case 2:
              if (!
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 1243; /* *ashrqi_extdi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (GET_CODE (x3) != ZERO_EXTRACT)
        return -1;
      x10 = XEXP (x3, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x11 = XEXP (x3, 2);
      operands[1] = x11;
      switch (XWINT (x6, 0))
        {
        case 0L:
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_QImode)
                  || GET_MODE (x3) != E_HImode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (!nonimmediate_operand (operands[0], E_QImode)
                      || !
#line 18983 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    return -1;
                  return 1411; /* *btrqi_2 */

                case E_HImode:
                  if (!nonimmediate_operand (operands[0], E_HImode)
                      || !
#line 18983 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    return -1;
                  return 1412; /* *btrhi_2 */

                default:
                  return -1;
                }

            case CONST_INT:
              if (!const_0_to_63_operand (operands[1], E_QImode)
                  || GET_MODE (x3) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || !
#line 19047 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
                return -1;
              return 1414; /* *btrq_imm */

            default:
              return -1;
            }

        case 1L:
          if (GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[0], E_DImode)
              || !const_0_to_63_operand (operands[1], E_QImode)
              || !
#line 19034 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
            return -1;
          return 1413; /* *btsq_imm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pattern340 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (pattern344 (x3))
            {
            case 0:
              if (!
#line 8144 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 393; /* *subqi_1_zexthi */

            case 1:
              if (!
#line 8144 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 395; /* *subqi_1_zextsi */

            case 2:
              if (!
#line 8158 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 399; /* *subhi_1_zextsi */

            case 3:
              if (!
#line 8144 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 397; /* *subqi_1_zextdi */

            case 4:
              if (!
#line 8158 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 401; /* *subhi_1_zextdi */

            case 5:
              if (!
#line 8173 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 402; /* *subsi_1_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          switch (pattern1407 (x3))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_operator (operands[2], E_QImode)
                  || !
#line 9440 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 505; /* *subqi3_carry_zexthi_0 */

            case 1:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_operator (operands[2], E_QImode)
                  || !
#line 9440 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 506; /* *subqi3_carry_zextsi_0 */

            case 2:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_operator (operands[2], E_HImode)
                  || !
#line 9455 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 508; /* *subhi3_carry_zextsi_0 */

            case 3:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_operator (operands[2], E_QImode)
                  || !
#line 9440 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 507; /* *subqi3_carry_zextdi_0 */

            case 4:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_operator (operands[2], E_HImode)
                  || !
#line 9455 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 509; /* *subhi3_carry_zextdi_0 */

            case 5:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !ix86_carry_flag_operator (operands[2], E_SImode)
                  || !
#line 9470 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 510; /* *subsi3_carry_zext_0 */

            default:
              return -1;
            }

        case GE:
        case GEU:
          switch (pattern1407 (x3))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_QImode)
                  || !
#line 9488 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 511; /* *subqi3_carry_zexthi_0r */

            case 1:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_QImode)
                  || !
#line 9488 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 512; /* *subqi3_carry_zextsi_0r */

            case 2:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_HImode)
                  || !
#line 9503 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 514; /* *subhi3_carry_zextsi_0r */

            case 3:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_QImode)
                  || !
#line 9488 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 513; /* *subqi3_carry_zextdi_0r */

            case 4:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_HImode)
                  || !
#line 9503 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              return 515; /* *subhi3_carry_zextdi_0r */

            case 5:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_SImode)
                  || !
#line 9518 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 516; /* *subsi3_carry_zext_0r */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case LTU:
        case UNLT:
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (pattern1139 (x3))
            {
            case 0:
              if (pattern1734 (x5, 
E_QImode) != 0
                  || !
#line 9380 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 499; /* *subqi3_carry_zexthi */

            case 1:
              if (pattern1734 (x5, 
E_QImode) != 0
                  || !
#line 9380 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 500; /* *subqi3_carry_zextsi */

            case 2:
              if (pattern1734 (x5, 
E_HImode) != 0
                  || !
#line 9400 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 502; /* *subhi3_carry_zextsi */

            case 3:
              if (pattern1734 (x5, 
E_QImode) != 0
                  || !
#line 9380 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 501; /* *subqi3_carry_zextdi */

            case 4:
              if (pattern1734 (x5, 
E_HImode) != 0
                  || !
#line 9400 "../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 503; /* *subhi3_carry_zextdi */

            case 5:
              if (pattern1734 (x5, 
E_SImode) != 0
                  || !
#line 9420 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 504; /* *subsi3_carry_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 63L:
          if (GET_CODE (x6) != SUBREG
              || maybe_ne (SUBREG_BYTE (x6), 0))
            return -1;
          x11 = XEXP (x6, 0);
          if (GET_CODE (x11) != CLZ
              || GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 21270 "../../gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT))
            return -1;
          return 1526; /* bsr_rex64_1_zext */

        case 31L:
          if (GET_CODE (x6) != CLZ)
            return -1;
          x11 = XEXP (x6, 0);
          operands[1] = x11;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21310 "../../gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT))
            return -1;
          return 1529; /* bsr_zext_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_MODE (x5) != E_CCCmode
      || GET_MODE (x3) != E_CCCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      switch (pattern939 (x8))
        {
        case 0:
          if (!
#line 9931 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 534; /* *addqi3_cconly_overflow_1 */

        case 1:
          if (!
#line 9931 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 535; /* *addhi3_cconly_overflow_1 */

        case 2:
          if (!
#line 9931 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 536; /* *addsi3_cconly_overflow_1 */

        case 3:
          if (!(
#line 9931 "../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 537; /* *adddi3_cconly_overflow_1 */

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x9 = XEXP (x6, 1);
      switch (GET_CODE (x9))
        {
        case PLUS:
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x9, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_MODE (x8))
            {
            case E_QImode:
              if (pattern1409 (x9, 
E_QImode) != 0
                  || !
#line 9949 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 538; /* addqi3_cc_overflow_1 */

            case E_HImode:
              if (pattern1409 (x9, 
E_HImode) != 0
                  || !
#line 9949 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 539; /* addhi3_cc_overflow_1 */

            case E_SImode:
              if (pattern1410 (x9, 
E_SImode) != 0
                  || !
#line 9949 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 540; /* addsi3_cc_overflow_1 */

            case E_DImode:
              if (pattern1410 (x9, 
E_DImode) != 0
                  || !(
#line 9949 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 541; /* adddi3_cc_overflow_1 */

            case E_TImode:
              if (pattern1646 (x9, 
E_TImode) != 0
                  || !(
#line 10081 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 553; /* *addti3_doubleword_cc_overflow_1 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1412 (x1, 
PLUS) != 0
              || !
#line 10007 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 542; /* *addsi3_zext_cc_overflow_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pattern578 (x1, 
PLUS, 
E_CCZmode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCZmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  operands[1] = x9;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (pattern1735 (x8, 
E_QImode) != 0
          || !
#line 778 "../../gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])))
        return -1;
      return 10924; /* *atomic_fetch_add_cmpqi */

    case E_HImode:
      if (pattern1735 (x8, 
E_HImode) != 0
          || !
#line 778 "../../gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])))
        return -1;
      return 10925; /* *atomic_fetch_add_cmphi */

    case E_SImode:
      if (pattern1735 (x8, 
E_SImode) != 0
          || !
#line 778 "../../gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])))
        return -1;
      return 10926; /* *atomic_fetch_add_cmpsi */

    case E_DImode:
      if (pattern1735 (x8, 
E_DImode) != 0
          || !(
#line 778 "../../gcc/config/i386/sync.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[1])
   == -(unsigned HOST_WIDE_INT) INTVAL (operands[2])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 10927; /* *atomic_fetch_add_cmpdi */

    default:
      return -1;
    }
}

 int
recog_382 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      res = recog_378 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x6) != SUBREG)
        return -1;
      switch (pattern810 (x1))
        {
        case 0:
          if (!
#line 13139 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
            return -1;
          return 782; /* *andqi_exthi_1_cc */

        case 1:
          if (!
#line 13139 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
            return -1;
          return 785; /* *andqi_extsi_1_cc */

        case 2:
          if (!(
#line 13139 "../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 788; /* *andqi_extdi_1_cc */

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (x5))
        {
        case E_SImode:
          if (pattern1413 (x6, 
E_SImode) != 0
              || !
#line 13388 "../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)))
            return -1;
          return 817; /* *andn_si_ccno */

        case E_DImode:
          if (pattern1413 (x6, 
E_DImode) != 0
              || !(
#line 13388 "../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 818; /* *andn_di_ccno */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != AND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != NEG)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (pattern1476 (x1))
            {
            case 0:
              if (!
#line 21810 "../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)))
                return -1;
              return 1572; /* *bmi_blsi_si_cmp */

            case 1:
              if (!(
#line 21810 "../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1573; /* *bmi_blsi_di_cmp */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern1220 (x1))
            {
            case 0:
              if (!
#line 21869 "../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)))
                return -1;
              return 1576; /* *bmi_blsi_si_ccno */

            case 1:
              if (!(
#line 21869 "../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_match_ccmode (insn, CCNOmode)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1577; /* *bmi_blsi_di_ccno */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x14 = XEXP (x6, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
          || pattern809 (x2, 
E_CCZmode) != 0)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != AND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != PLUS)
            return -1;
          x15 = XEXP (x13, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (pattern1476 (x1))
            {
            case 0:
              if (!
#line 21962 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              return 1584; /* *bmi_blsr_si_cmp */

            case 1:
              if (!(
#line 21962 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1585; /* *bmi_blsr_di_cmp */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern1220 (x1))
            {
            case 0:
              if (!
#line 22019 "../../gcc/config/i386/i386.md"
(TARGET_BMI))
                return -1;
              return 1588; /* *bmi_blsr_si_ccz */

            case 1:
              if (!(
#line 22019 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1589; /* *bmi_blsr_di_ccz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (pattern365 (x1, 
AND))
        {
        case 0:
          return 10977; /* atomic_and_fetch_cmp_0qi_1 */

        case 1:
          return 10980; /* atomic_and_fetch_cmp_0hi_1 */

        case 2:
          return 10983; /* atomic_and_fetch_cmp_0si_1 */

        case 3:
          if (!
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 10986; /* atomic_and_fetch_cmp_0di_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x4))
        {
        case CLOBBER:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 17
              || GET_MODE (x5) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode))
                return -1;
              x6 = XEXP (x2, 1);
              if (GET_MODE (x6) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if (x86_64_hilo_general_operand (operands[2], E_DImode)
                  && (
#line 8069 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 380; /* *subdi3_doubleword */
              if (!x86_64_general_operand (operands[2], E_DImode)
                  || !(
#line 8125 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 391; /* *subdi_1 */

            case E_TImode:
              x6 = XEXP (x2, 1);
              if (pattern560 (x6, 
E_TImode) != 0
                  || !(
#line 8069 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 381; /* *subti3_doubleword */

            case E_QImode:
              x6 = XEXP (x2, 1);
              if (pattern561 (x6, 
E_QImode) != 0
                  || !
#line 8125 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
  && true))
                return -1;
              return 385; /* *subqi_1 */

            case E_HImode:
              x6 = XEXP (x2, 1);
              if (pattern561 (x6, 
E_HImode) != 0
                  || !
#line 8125 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
  && true))
                return -1;
              return 387; /* *subhi_1 */

            case E_SImode:
              x6 = XEXP (x2, 1);
              if (pattern562 (x6) != 0
                  || !
#line 8125 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
  && true))
                return -1;
              return 389; /* *subsi_1 */

            case E_V2QImode:
              x6 = XEXP (x2, 1);
              if (pattern564 (x6, 
E_V2QImode) != 0
                  || !
#line 3241 "../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
                return -1;
              return 2135; /* subv2qi3 */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern213 (x1) != 0
              || !
#line 773 "../../gcc/config/i386/mmx.md"
(TARGET_3DNOW && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 2051; /* *mmx_subv2sf3 */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      x4 = XVECEXP (x1, 0, 1);
      if (pattern231 (x4, 
E_CCmode, 
17) != 0)
        return -1;
      switch (pattern1311 (x2))
        {
        case 0:
          if (!
#line 8189 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 403; /* *subqi_1_slp */

        case 1:
          if (!
#line 8189 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 404; /* *subhi_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      if (bt_comparison_operator (x4, E_VOIDmode))
        {
          res = recog_389 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x4) != NE)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ZERO_EXTRACT)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UMIN
              || GET_MODE (x8) != E_QImode)
            return -1;
          x9 = XEXP (x7, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x3, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern340 (x1) != 0
              || GET_MODE (x4) != E_QImode)
            return -1;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          x12 = XEXP (x8, 1);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_QImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1415 (x3, 
E_SImode) != 0
                  || !
#line 22056 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
                return -1;
              return 1590; /* *bmi2_bzhi_si3 */

            case E_DImode:
              if (pattern1415 (x3, 
E_DImode) != 0
                  || !(
#line 22056 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1591; /* *bmi2_bzhi_di3 */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 35)
            return -1;
          x14 = XVECEXP (x6, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x10 = XEXP (x3, 2);
          if (GET_CODE (x10) != PC)
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_CODE (x15) != PC)
            return -1;
          x16 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x16) != SET)
            return -1;
          x17 = XEXP (x16, 1);
          if (pattern807 (x17, 
E_SImode, 
46, 
1, 
UNSPEC_VOLATILE) != 0)
            return -1;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          x18 = XEXP (x16, 0);
          operands[0] = x18;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x19 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x19, operands[0])
              || !
#line 29644 "../../gcc/config/i386/i386.md"
(TARGET_RTM))
            return -1;
          return 1967; /* xbegin_1 */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      operands[1] = x4;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x10 = XEXP (x3, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern340 (x1) != 0)
        return -1;
      switch (pattern1549 (x3))
        {
        case 0:
          return 1793; /* *x86_movsicc_0_m1 */

        case 1:
          if (!
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1794; /* *x86_movdicc_0_m1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (pattern814 (x5))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern1418 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 13314 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 809; /* *andndi3_doubleword_bmi */
          if ((
#line 13332 "../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 811; /* *andndi3_doubleword */
          if (!(
#line 13348 "../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 814; /* *andndi_1 */

        case E_TImode:
          if (pattern1418 (x3, 
E_TImode) != 0)
            return -1;
          if ((
#line 13314 "../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 810; /* *andnti3_doubleword_bmi */
          if (!(
#line 13332 "../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 812; /* *andnti3_doubleword */

        case E_SImode:
          if (pattern1418 (x3, 
E_SImode) != 0
              || !
#line 13348 "../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            return -1;
          return 813; /* *andnsi_1 */

        case E_QImode:
          if (pattern1419 (x3, 
E_QImode) != 0
              || !
#line 13364 "../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            return -1;
          return 815; /* *andnqi_1 */

        case E_HImode:
          if (pattern1419 (x3, 
E_HImode) != 0
              || !
#line 13364 "../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            return -1;
          return 816; /* *andnhi_1 */

        case E_V4QImode:
          if (pattern1419 (x3, 
E_V4QImode) != 0)
            return -1;
          return 2269; /* *andnotv4qi3 */

        case E_V2QImode:
          if (pattern1419 (x3, 
E_V2QImode) != 0)
            return -1;
          return 2270; /* *andnotv2qi3 */

        case E_V2HImode:
          if (pattern1419 (x3, 
E_V2HImode) != 0)
            return -1;
          return 2271; /* *andnotv2hi3 */

        default:
          return -1;
        }

    case 1:
      if (pattern1419 (x3, 
E_QImode) != 0
          || !
#line 2143 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
        return -1;
      return 2582; /* kandnqi */

    case 2:
      if (pattern1419 (x3, 
E_HImode) != 0
          || !
#line 2143 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
        return -1;
      return 2583; /* kandnhi */

    case 3:
      if (pattern1419 (x3, 
E_SImode) != 0
          || !(
#line 2143 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return -1;
      return 2584; /* kandnsi */

    case 4:
      if (pattern1419 (x3, 
E_DImode) != 0
          || !(
#line 2143 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return -1;
      return 2585; /* kandndi */

    default:
      return -1;
    }
}

 int
recog_398 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (pattern814 (x8))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern1316 (x3, 
E_HImode) != 0
                  || !
#line 13609 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 835; /* *notxorhi_1 */

            case E_SImode:
              if (pattern1317 (x3, 
E_SImode) != 0
                  || !
#line 13609 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 836; /* *notxorsi_1 */

            case E_DImode:
              if (pattern1317 (x3, 
E_DImode) != 0
                  || !(
#line 13609 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 837; /* *notxordi_1 */

            case E_QImode:
              if (pattern1316 (x3, 
E_QImode) != 0
                  || !
#line 13809 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 871; /* *notxorqi_1 */

            default:
              return -1;
            }

        case 1:
          if (pattern1318 (x3, 
E_QImode) != 0
              || !
#line 2181 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2586; /* kxnorqi */

        case 2:
          if (pattern1318 (x3, 
E_HImode) != 0
              || !
#line 2181 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2587; /* kxnorhi */

        case 3:
          if (pattern1318 (x3, 
E_SImode) != 0
              || !(
#line 2181 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2588; /* kxnorsi */

        case 4:
          if (pattern1318 (x3, 
E_DImode) != 0
              || !(
#line 2181 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2589; /* kxnordi */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pattern375 (x1) != 0
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      x9 = XEXP (x4, 2);
      if (!rtx_equal_p (x9, operands[1])
          || !
#line 19060 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
        return -1;
      return 1415; /* *btcq_imm */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 174)
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      switch (pattern696 (x3))
        {
        case 0:
          if (!
#line 2202 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2590; /* knotqi */

        case 1:
          if (!
#line 2202 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 2591; /* knothi */

        case 2:
          if (!(
#line 2202 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2592; /* knotsi */

        case 3:
          if (!(
#line 2202 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2593; /* knotdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern697 (x1))
        {
        case 0:
          if ((
#line 16584 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 1122; /* *lshrdi3_doubleword_mask */
          break;

        case 1:
          if ((
#line 16584 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1124; /* *lshrti3_doubleword_mask */
          break;

        case 2:
          if ((
#line 2271 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return 2600; /* klshiftrtqi */
          break;

        case 3:
          if (
#line 2271 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2602; /* klshiftrthi */
          break;

        case 4:
          if ((
#line 2271 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2604; /* klshiftrtsi */
          break;

        case 5:
          if ((
#line 2271 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2606; /* klshiftrtdi */
          break;

        default:
          break;
        }
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern698 (x1))
        {
        case 0:
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x4) == E_DImode
                  && register_operand (operands[1], E_DImode)
                  && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return 1130; /* lshrdi3_doubleword */
              break;

            case E_TImode:
              if (register_operand (operands[0], E_TImode)
                  && GET_MODE (x4) == E_TImode
                  && register_operand (operands[1], E_TImode)
                  && 
#line 1196 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 1132; /* lshrti3_doubleword */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 17387 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
                return 1181; /* *lshrsi3_1 */
              break;

            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && GET_MODE (x4) == E_QImode
                  && nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 17563 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
                return 1213; /* *lshrqi3_1 */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 17601 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
                return 1215; /* *lshrhi3_1 */
              break;

            case E_V2QImode:
              if (register_operand (operands[0], E_V2QImode)
                  && GET_MODE (x4) == E_V2QImode
                  && register_operand (operands[1], E_V2QImode)
                  && 
#line 4007 "../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return 2213; /* lshrv2qi3 */
              break;

            default:
              break;
            }
          break;

        case 1:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          switch (pattern376 (x4))
            {
            case 0:
              if (
#line 17640 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 1216; /* *lshrqi3_1_slp */
              break;

            case 1:
              if (
#line 17640 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 1218; /* *lshrhi3_1_slp */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern1151 (x2) == 0
              && GET_MODE (x4) == E_DImode
              && nonimmediate_operand (operands[1], E_DImode)
              && 
#line 17363 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return 1179; /* *highpartdisi2 */
          break;

        case SUBREG:
          switch (pattern1154 (x2, 
E_SImode))
            {
            case 0:
              if (
#line 17842 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return 1245; /* *lshrsi3_mask */
              break;

            case 1:
              if (
#line 17890 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1257; /* *lshrsi3_add */
              break;

            case 2:
              if (
#line 17936 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1269; /* *lshrsi3_sub */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x5;
      if (nonmemory_operand (operands[2], E_QImode)
          && (
#line 17387 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1183; /* *lshrdi3_1 */
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_QImode)
        return -1;
      x9 = XEXP (x5, 0);
      switch (pattern1152 (x9))
        {
        case 0:
          if (!(
#line 17842 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1248; /* *lshrdi3_mask */

        case 1:
          if (!(
#line 17890 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1260; /* *lshrdi3_add */

        case 2:
          if (!(
#line 17936 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1272; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 16645 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 1126; /* *lshrdi3_doubleword_mask_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !(
#line 17867 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1254; /* *lshrdi3_mask_1 */

    case 2:
      if (!(
#line 16645 "../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1128; /* *lshrti3_doubleword_mask_1 */

    case 3:
      if (!
#line 17867 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
        return -1;
      return 1251; /* *lshrsi3_mask_1 */

    case 4:
      if (!
#line 17914 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1263; /* *lshrsi3_add_1 */

    case 5:
      if (!(
#line 17914 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1266; /* *lshrdi3_add_1 */

    case 6:
      if (!
#line 17966 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1275; /* *lshrsi3_sub_1 */

    case 7:
      if (!(
#line 17966 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1278; /* *lshrdi3_sub_1 */

    default:
      return -1;
    }
}

 int
recog_412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (pattern383 (x5, 
174, 
0) != 0)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8DImode:
      if (pattern1230 (x3, 
E_V8DImode, 
E_QImode, 
E_DImode) != 0
          || !(
#line 28088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 623 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9270; /* avx512cd_maskb_vec_dupv8di */

    case E_V4DImode:
      if (pattern1230 (x3, 
E_V4DImode, 
E_QImode, 
E_DImode) != 0
          || !(
#line 28088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9271; /* avx512cd_maskb_vec_dupv4di */

    case E_V2DImode:
      if (pattern1230 (x3, 
E_V2DImode, 
E_QImode, 
E_DImode) != 0
          || !(
#line 28088 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 623 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9272; /* avx512cd_maskb_vec_dupv2di */

    case E_V16SImode:
      if (pattern1230 (x3, 
E_V16SImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 28100 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 674 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9273; /* avx512cd_maskw_vec_dupv16si */

    case E_V8SImode:
      if (pattern1230 (x3, 
E_V8SImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 28100 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9274; /* avx512cd_maskw_vec_dupv8si */

    case E_V4SImode:
      if (pattern1230 (x3, 
E_V4SImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 28100 "../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 674 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9275; /* avx512cd_maskw_vec_dupv4si */

    default:
      return -1;
    }
}

 int
recog_419 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XVECLEN (x5, 0))
    {
    case 1:
      if (XINT (x5, 1) != 10
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 1);
      if (pattern807 (x7, 
E_DImode, 
10, 
1, 
UNSPEC_VOLATILE) != 0
          || pattern1160 (x1, 
E_SImode, 
10) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 29140 "../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 1898; /* rdtscp_rex64 */

    case 5:
      if (XINT (x5, 1) != 109)
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != UNSPEC_VOLATILE
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 109
          || pattern1160 (x1, 
E_CCZmode, 
109) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCZmode)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 2);
      operands[3] = x12;
      x13 = XVECEXP (x5, 0, 3);
      operands[4] = x13;
      x14 = XVECEXP (x5, 0, 4);
      operands[5] = x14;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern1818 (x1, 
E_DImode, 
E_SImode) != 0
              || !(
#line 486 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG8B) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 10914; /* atomic_compare_and_swapdi_doubleword */

        case E_TImode:
          if (pattern1818 (x1, 
E_TImode, 
E_DImode) != 0
              || !(
#line 486 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG16B) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10915; /* atomic_compare_and_swapti_doubleword */

        default:
          return -1;
        }

    case 4:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != UNSPEC_VOLATILE
          || XVECLEN (x7, 0) != 1)
        return -1;
      x15 = XVECEXP (x7, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 2);
      operands[3] = x12;
      x13 = XVECEXP (x5, 0, 3);
      operands[4] = x13;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 109:
          if (XINT (x7, 1) != 109)
            return -1;
          x16 = XEXP (x9, 1);
          if (pattern1159 (x16, 
E_CCZmode, 
109) != 0
              || !const_int_operand (operands[4], E_SImode)
              || GET_MODE (x10) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1808 (x1, 
E_QImode) != 0
                  || !
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 10916; /* atomic_compare_and_swapqi_1 */

            case E_HImode:
              if (pattern1808 (x1, 
E_HImode) != 0
                  || !
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 10917; /* atomic_compare_and_swaphi_1 */

            case E_SImode:
              if (pattern1808 (x1, 
E_SImode) != 0
                  || !
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG))
                return -1;
              return 10918; /* atomic_compare_and_swapsi_1 */

            case E_DImode:
              if (pattern1808 (x1, 
E_DImode) != 0
                  || !(
#line 501 "../../gcc/config/i386/sync.md"
(TARGET_CMPXCHG) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 10919; /* atomic_compare_and_swapdi_1 */

            default:
              return -1;
            }

        case 112:
          if (XINT (x7, 1) != 112)
            return -1;
          x16 = XEXP (x9, 1);
          if (GET_CODE (x16) != COMPARE
              || GET_MODE (x16) != E_CCmode
              || !const_0_to_15_operand (operands[4], E_SImode)
              || GET_MODE (x10) != E_CCmode)
            return -1;
          x17 = XEXP (x16, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XEXP (x16, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1808 (x1, 
E_SImode) != 0
                  || !
#line 1119 "../../gcc/config/i386/sync.md"
(TARGET_CMPCCXADD && TARGET_64BIT))
                return -1;
              return 10989; /* cmpccxadd_si */

            case E_DImode:
              if (pattern1808 (x1, 
E_DImode) != 0
                  || !
#line 1119 "../../gcc/config/i386/sync.md"
(TARGET_CMPCCXADD && TARGET_64BIT))
                return -1;
              return 10990; /* cmpccxadd_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x5, 1) != 110)
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (pattern942 (x9, 
E_CCmode, 
17) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[1] = x6;
      x11 = XVECEXP (x5, 0, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x7, 1);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      if (!rtx_equal_p (x20, operands[1]))
        return -1;
      x8 = XEXP (x2, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1551 (x1, 
E_QImode) != 0
              || !
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 10920; /* atomic_fetch_addqi */

        case E_HImode:
          if (pattern1551 (x1, 
E_HImode) != 0
              || !
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 10921; /* atomic_fetch_addhi */

        case E_SImode:
          if (pattern1551 (x1, 
E_SImode) != 0
              || !
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD))
            return -1;
          return 10922; /* atomic_fetch_addsi */

        case E_DImode:
          if (pattern1551 (x1, 
E_DImode) != 0
              || !(
#line 703 "../../gcc/config/i386/sync.md"
(TARGET_XADD) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 10923; /* atomic_fetch_adddi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 97)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x1;
      if (!vzeroall_operation (operands[0], E_VOIDmode)
          || !
#line 27222 "../../gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 9013; /* *avx_vzeroall */

    case USE:
      operands[0] = x1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (save_multiple (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (symbol_operand (operands[1], E_SImode)
                  && (
#line 30283 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return 10069; /* *save_multiplesi */
              break;

            case E_DImode:
              if (symbol_operand (operands[1], E_DImode)
                  && (
#line 30283 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return 10070; /* *save_multipledi */
              break;

            default:
              break;
            }
        }
      if (!restore_multiple (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!symbol_operand (operands[1], E_SImode)
              || !(
#line 30290 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 10071; /* *restore_multiplesi */

        case E_DImode:
          if (!symbol_operand (operands[1], E_DImode)
              || !(
#line 30290 "../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_64BIT) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 10072; /* *restore_multipledi */

        default:
          return -1;
        }

    case SET:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE)
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          if (pattern396 (x5, 
107) != 0)
            return -1;
          operands[2] = x1;
          if (!encodekey128_operation (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 31275 "../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 10285; /* *encodekey128u32 */

        case 3:
          if (pattern396 (x5, 
108) != 0)
            return -1;
          x7 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_V2DImode)
            return -1;
          operands[2] = x1;
          if (!encodekey256_operation (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 31333 "../../gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 10286; /* *encodekey256u32 */

        case 1:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 17
              || GET_MODE (x4) != E_CCZmode)
            return -1;
          operands[1] = x1;
          if (!aeswidekl_operation (operands[1], E_VOIDmode)
              || GET_MODE (x5) != E_CCZmode)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[0] = x6;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          switch (XINT (x5, 1))
            {
            case 103:
              if (!
#line 31417 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10291; /* *aesdecwide128klu8 */

            case 105:
              if (!
#line 31417 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10292; /* *aesdecwide256klu8 */

            case 104:
              if (!
#line 31417 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10293; /* *aesencwide128klu8 */

            case 106:
              if (!
#line 31417 "../../gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                return -1;
              return 10294; /* *aesencwide256klu8 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!push_operand (operands[0], E_DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DFmode
          || !fp_register_operand (operands[1], E_SFmode))
        return NULL;
      if ((
#line 5258 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
        return gen_split_64 (insn, operands);
      if (!(
#line 5258 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_65 (insn, operands);

    case E_XFmode:
      if (!push_operand (operands[0], E_XFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_XFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!fp_register_operand (operands[1], E_SFmode))
            return NULL;
          if ((
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_66 (insn, operands);
          if (!(
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_67 (insn, operands);

        case E_DFmode:
          if (!fp_register_operand (operands[1], E_DFmode))
            return NULL;
          if ((
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_68 (insn, operands);
          if (!(
#line 5265 "../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_69 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return NULL;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 2);
  operands[2] = x9;
  if (!register_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x2, 1);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      switch (pattern1510 (x2, 
E_HImode))
        {
        case 0:
          if (!
#line 19320 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_830 (insn, operands);

        case 1:
          if (!(
#line 19320 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_831 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern1510 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 19320 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_832 (insn, operands);

        case 1:
          if (!(
#line 19320 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_833 (insn, operands);

        default:
          return NULL;
        }

    case E_DImode:
      switch (pattern1510 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 19320 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_834 (insn, operands);

        case 1:
          if (!(
#line 19320 "../../gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_835 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern70 (x3))
        {
        case 0:
          if (!(
#line 3704 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == -1
   && CONST_WIDE_INT_ELT (operands[3], 1) == 0) && 
#line 3710 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_24 (insn, operands);

        case 1:
          if (!(
#line 3726 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == 0
   && CONST_WIDE_INT_ELT (operands[3], 1) == -1) && 
#line 3732 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_27 (insn, operands);

        case 2:
          if (!(
#line 3748 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_30 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern600 (x3, 
E_QImode) != 0
                      || !(
#line 8015 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case E_HImode:
                  if (pattern600 (x3, 
E_HImode) != 0
                      || !(
#line 8015 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case E_SImode:
                  if (pattern600 (x3, 
E_SImode) != 0
                      || !(
#line 8039 "../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 8042 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case E_DImode:
                  if (GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && ((
#line 8039 "../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 8042 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_167 (insn, operands);
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !((
#line 14139 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14153 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_468 (insn, operands);

                case E_TImode:
                  if (pattern601 (x3, 
E_TImode) != 0
                      || !((
#line 14139 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14153 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_471 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              switch (pattern944 (x3))
                {
                case 0:
                  if (!((
#line 14062 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14064 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_432 (insn, operands);

                case 1:
                  if (!((
#line 14062 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14064 "../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_435 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_444 (insn, operands);

            case 1:
              if (!((
#line 14098 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14100 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_450 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_474 (insn, operands);

            case 3:
              if (!((
#line 14171 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_480 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_447 (insn, operands);

            case 1:
              if (!((
#line 14098 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14100 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_453 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_477 (insn, operands);

            case 3:
              if (!((
#line 14171 "../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_483 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern404 (x3))
        {
        case 0:
          if (!((
#line 14079 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14081 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_438 (insn, operands);

        case 1:
          if (!((
#line 14079 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14081 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_441 (insn, operands);

        case 2:
          if (!((
#line 14123 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_456 (insn, operands);

        case 3:
          if (!((
#line 14123 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14125 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_462 (insn, operands);

        case 4:
          if (!((
#line 14123 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_459 (insn, operands);

        case 5:
          if (!((
#line 14123 "../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14125 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_465 (insn, operands);

        case 6:
          if (!((
#line 14200 "../../gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14211 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_486 (insn, operands);

        case 7:
          if (!((
#line 14200 "../../gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14211 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_489 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (rtx_equal_p (x5, operands[0]))
    {
      x6 = XEXP (x4, 1);
      switch (XWINT (x6, 0))
        {
        case -65536L:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x4) == E_SImode
              && 
#line 12862 "../../gcc/config/i386/i386.md"
((TARGET_FAST_PREFIX && !TARGET_PARTIAL_REG_STALL)
    || optimize_function_for_size_p (cfun)))
            return gen_split_314 (insn, operands);
          break;

        case -256L:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (any_QIreg_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && 
#line 12872 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_316 (insn, operands);
              break;

            case E_SImode:
              if (any_QIreg_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && 
#line 12872 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_317 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case -65281L:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (QIreg_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && 
#line 12882 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_319 (insn, operands);
              break;

            case E_SImode:
              if (QIreg_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && 
#line 12882 "../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_320 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (GET_MODE (x4) != E_HImode
          || !const_int_operand (operands[2], E_HImode))
        return NULL;
      if (QIreg_operand (operands[0], E_HImode)
          && register_operand (operands[1], E_HImode)
          && 
#line 13263 "../../gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
        return gen_split_367 (insn, operands);
      if (!any_QIreg_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 13292 "../../gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_370 (insn, operands);

    case E_SImode:
      if (GET_MODE (x4) != E_SImode
          || !const_int_operand (operands[2], E_SImode))
        return NULL;
      if (QIreg_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_SImode)
          && 
#line 13263 "../../gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
        return gen_split_368 (insn, operands);
      if (!any_QIreg_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 13292 "../../gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_371 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (pattern231 (x4, 
E_CCmode, 
17) != 0)
    return NULL;
  switch (pattern1030 (x2))
    {
    case 0:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 7549 "../../gcc/config/i386/i386.md"
(reload_completed
   && !rtx_equal_p (operands[0], operands[1])))
                return gen_split_137 (insn, operands);
              break;

            case 1:
              if (
#line 7549 "../../gcc/config/i386/i386.md"
(reload_completed
   && !rtx_equal_p (operands[0], operands[1])))
                return gen_split_138 (insn, operands);
              break;

            case 2:
              if ((
#line 7549 "../../gcc/config/i386/i386.md"
(reload_completed
   && !rtx_equal_p (operands[0], operands[1])) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_139 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 7596 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (PLUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_140 (insn, operands);

        case 1:
          if (!
#line 7596 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (PLUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
            return NULL;
          return gen_split_142 (insn, operands);

        case 2:
          if (!(
#line 7596 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (PLUS == PLUS && rtx_equal_p (operands[0], operands[2])))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_144 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) == SUBREG)
        {
          switch (pattern1805 (x2))
            {
            case 0:
              if (
#line 7596 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (MINUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
                return gen_split_141 (insn, operands);
              break;

            case 1:
              if (
#line 7596 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (MINUS == PLUS && rtx_equal_p (operands[0], operands[2])))))
                return gen_split_143 (insn, operands);
              break;

            case 2:
              if ((
#line 7596 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| (MINUS == PLUS && rtx_equal_p (operands[0], operands[2])))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_145 (insn, operands);
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      if (!general_operand (operands[2], E_QImode))
        return NULL;
      switch (pattern1028 (x2))
        {
        case 0:
          if (!
#line 8375 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_183 (insn, operands);

        case 1:
          if (!
#line 8375 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_184 (insn, operands);

        case 2:
          if (!(
#line 8375 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_185 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_331 (insn, operands);
              break;

            case 1:
              if (
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_334 (insn, operands);
              break;

            case 2:
              if ((
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_337 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_349 (insn, operands);

        case 1:
          if (!
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_352 (insn, operands);

        case 2:
          if (!(
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_355 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_332 (insn, operands);
              break;

            case 1:
              if (
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_335 (insn, operands);
              break;

            case 2:
              if ((
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_338 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_350 (insn, operands);

        case 1:
          if (!
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_353 (insn, operands);

        case 2:
          if (!(
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_356 (insn, operands);

        default:
          return NULL;
        }

    case 4:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (general_operand (operands[2], E_QImode))
        {
          switch (pattern1028 (x2))
            {
            case 0:
              if (
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_333 (insn, operands);
              break;

            case 1:
              if (
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                return gen_split_336 (insn, operands);
              break;

            case 2:
              if ((
#line 13096 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_339 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x6) != SUBREG)
        return NULL;
      switch (pattern1805 (x2))
        {
        case 0:
          if (!
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_351 (insn, operands);

        case 1:
          if (!
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))))
            return NULL;
          return gen_split_354 (insn, operands);

        case 2:
          if (!(
#line 13194 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_357 (insn, operands);

        default:
          return NULL;
        }

    case 5:
      if (!
#line 14500 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_494 (insn, operands);

    case 6:
      if (!
#line 14500 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_495 (insn, operands);

    case 7:
      if (!(
#line 14500 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_496 (insn, operands);

    case 8:
      if (!
#line 16529 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_586 (insn, operands);

    case 9:
      if (!
#line 16529 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_587 (insn, operands);

    case 10:
      if (!(
#line 16529 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_588 (insn, operands);

    case 11:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      switch (pattern1216 (x3))
        {
        case 0:
          if (((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16761 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_605 (insn, operands);
          break;

        case 1:
          if (((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16761 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_607 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_QImode)
        return NULL;
      switch (pattern1029 (x2))
        {
        case 0:
          if (!
#line 17805 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_632 (insn, operands);

        case 1:
          if (!
#line 17805 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_634 (insn, operands);

        case 2:
          if (!(
#line 17805 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_636 (insn, operands);

        default:
          return NULL;
        }

    case 12:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      switch (pattern1216 (x3))
        {
        case 0:
          if (((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16761 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_606 (insn, operands);
          break;

        case 1:
          if (((
#line 16759 "../../gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16761 "../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_608 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_QImode)
        return NULL;
      switch (pattern1029 (x2))
        {
        case 0:
          if (!
#line 17805 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_633 (insn, operands);

        case 1:
          if (!
#line 17805 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_635 (insn, operands);

        case 2:
          if (!(
#line 17805 "../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern406 (x1))
    {
    case 0:
      if (!(
#line 18192 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_695 (insn, operands);

    case 1:
      if (!(
#line 18192 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_697 (insn, operands);

    case 2:
      if (!(
#line 18192 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_699 (insn, operands);

    case 3:
      if (!((
#line 18192 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18197 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_701 (insn, operands);

    case 4:
      if (!(
#line 18273 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_727 (insn, operands);

    case 5:
      if (!(
#line 18273 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_729 (insn, operands);

    case 6:
      if (!(
#line 18273 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_731 (insn, operands);

    case 7:
      if (!((
#line 18273 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18277 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_733 (insn, operands);

    case 8:
      if (!(
#line 18342 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_759 (insn, operands);

    case 9:
      if (!(
#line 18342 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_761 (insn, operands);

    case 10:
      if (!(
#line 18342 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_763 (insn, operands);

    case 11:
      if (!((
#line 18342 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18346 "../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_765 (insn, operands);

    case 12:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (pattern1167 (x4))
        {
        case 0:
          if ((
#line 18144 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_679 (insn, operands);
          break;

        case 1:
          if ((
#line 18144 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_681 (insn, operands);
          break;

        case 2:
          if ((
#line 18144 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_683 (insn, operands);
          break;

        case 3:
          if (((
#line 18144 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18149 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_685 (insn, operands);
          break;

        case 4:
          if ((
#line 18237 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_711 (insn, operands);
          break;

        case 5:
          if ((
#line 18237 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_713 (insn, operands);
          break;

        case 6:
          if ((
#line 18237 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_715 (insn, operands);
          break;

        case 7:
          if (((
#line 18237 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18241 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_717 (insn, operands);
          break;

        case 8:
          if ((
#line 18306 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_743 (insn, operands);
          break;

        case 9:
          if ((
#line 18306 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_745 (insn, operands);
          break;

        case 10:
          if ((
#line 18306 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_747 (insn, operands);
          break;

        case 11:
          if (((
#line 18306 "../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18310 "../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_749 (insn, operands);
          break;

        case 12:
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          switch (pattern1324 (x4))
            {
            case 0:
              if (
#line 18571 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)))
                return gen_split_786 (insn, operands);
              break;

            case 1:
              if ((
#line 18571 "../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_787 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) == 8L
              && QIreg_operand (operands[0], E_HImode)
              && GET_MODE (x4) == E_HImode)
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 18743 "../../gcc/config/i386/i386.md"
(reload_completed
  && (TARGET_USE_XCHGB || optimize_function_for_size_p (cfun))))
                return gen_split_795 (insn, operands);
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern1168 (x2))
        {
        case 0:
          if (!(
#line 18710 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_791 (insn, operands);

        case 1:
          if (!(
#line 18710 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_793 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_42 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 51:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x6))
            {
            case LT:
              switch (pattern731 (x2))
                {
                case 0:
                  if ((
#line 26806 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()) && 
#line 26811 "../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_955 (insn, operands);
                  if (!(
#line 26827 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()) && 
#line 26832 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_957 (insn, operands);

                case 1:
                  if ((
#line 26806 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()) && 
#line 26811 "../../gcc/config/i386/i386.md"
( 1)))
                    return gen_split_956 (insn, operands);
                  if (!(
#line 26827 "../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()) && 
#line 26832 "../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_958 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              switch (pattern733 (x2))
                {
                case 0:
                  if (!(
#line 4338 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 4340 "../../gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1062 (insn, operands);

                case 1:
                  if (!(
#line 4414 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1065 (insn, operands);

                case 2:
                  if (!(
#line 4414 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1066 (insn, operands);

                case 3:
                  if (!(
#line 4414 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1067 (insn, operands);

                default:
                  return NULL;
                }

            case SUBREG:
              switch (pattern842 (x2))
                {
                case 0:
                  if (!(
#line 4366 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 4368 "../../gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1063 (insn, operands);

                case 1:
                  if (!(
#line 4366 "../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 4368 "../../gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1064 (insn, operands);

                case 2:
                  if (!(
#line 4442 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4444 "../../gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_1068 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 59:
          switch (pattern587 (x2))
            {
            case 0:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1476 (insn, operands);

            case 1:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1478 (insn, operands);

            case 2:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1484 (insn, operands);

            case 3:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1480 (insn, operands);

            case 4:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1482 (insn, operands);

            case 5:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1486 (insn, operands);

            default:
              return NULL;
            }

        case 157:
          switch (pattern587 (x2))
            {
            case 0:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1477 (insn, operands);

            case 1:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1479 (insn, operands);

            case 2:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1485 (insn, operands);

            case 3:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1481 (insn, operands);

            case 4:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1483 (insn, operands);

            case 5:
              if (!((
#line 4792 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1487 (insn, operands);

            default:
              return NULL;
            }

        case 121:
          if (pattern303 (x2) != 0
              || !
#line 23274 "../../gcc/config/i386/sse.md"
((TARGET_SSSE3 && reload_completed
    && SSE_REGNO_P (REGNO (operands[0])))
   || operands[3] == const0_rtx
   || INTVAL (operands[3]) == 64))
            return NULL;
          return gen_split_3472 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 57:
          switch (pattern65 (x1))
            {
            case 0:
              if (!(
#line 4792 "../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4797 "../../gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
                return NULL;
              return gen_split_1103 (insn, operands);

            case 1:
              if (!(
#line 4831 "../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE) && 
#line 4833 "../../gcc/config/i386/mmx.md"
( reload_completed)))
                return NULL;
              return gen_split_1105 (insn, operands);

            default:
              return NULL;
            }

        case 130:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 17)
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case AND:
              switch (pattern599 (x1))
                {
                case 0:
                  if (!(
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3578 (insn, operands);

                case 1:
                  if (!(
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3579 (insn, operands);

                case 2:
                  if (!(
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3580 (insn, operands);

                case 3:
                  if (!(
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3581 (insn, operands);

                case 4:
                  if (!(
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3582 (insn, operands);

                case 5:
                  if (!(
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3583 (insn, operands);

                case 6:
                  if (!(
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3584 (insn, operands);

                case 7:
                  if (!((
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 605 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3585 (insn, operands);

                case 8:
                  if (!((
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 605 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3586 (insn, operands);

                case 9:
                  if (!((
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3587 (insn, operands);

                case 10:
                  if (!((
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3588 (insn, operands);

                case 11:
                  if (!((
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3589 (insn, operands);

                case 12:
                  if (!((
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 607 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3590 (insn, operands);

                case 13:
                  if (!((
#line 25364 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 607 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3591 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[0] = x4;
              if (GET_MODE (x3) != E_CCCmode
                  || GET_MODE (x2) != E_CCCmode)
                return NULL;
              x5 = XVECEXP (x2, 0, 1);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[0], E_V16QImode)
                      || !register_operand (operands[1], E_V16QImode)
                      || !
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3592 (insn, operands);

                case E_V8HImode:
                  if (!register_operand (operands[0], E_V8HImode)
                      || !register_operand (operands[1], E_V8HImode)
                      || !
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3593 (insn, operands);

                case E_V4SImode:
                  if (!register_operand (operands[0], E_V4SImode)
                      || !register_operand (operands[1], E_V4SImode)
                      || !
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3594 (insn, operands);

                case E_V2DImode:
                  if (!register_operand (operands[0], E_V2DImode)
                      || !register_operand (operands[1], E_V2DImode)
                      || !
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3595 (insn, operands);

                case E_V1TImode:
                  if (!register_operand (operands[0], E_V1TImode)
                      || !register_operand (operands[1], E_V1TImode)
                      || !
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3596 (insn, operands);

                case E_V4SFmode:
                  if (!register_operand (operands[0], E_V4SFmode)
                      || !register_operand (operands[1], E_V4SFmode)
                      || !
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3597 (insn, operands);

                case E_V2DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || !register_operand (operands[1], E_V2DFmode)
                      || !
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3598 (insn, operands);

                case E_V32QImode:
                  if (!register_operand (operands[0], E_V32QImode)
                      || !register_operand (operands[1], E_V32QImode)
                      || !(
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 605 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3599 (insn, operands);

                case E_V16HImode:
                  if (!register_operand (operands[0], E_V16HImode)
                      || !register_operand (operands[1], E_V16HImode)
                      || !(
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 605 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3600 (insn, operands);

                case E_V8SImode:
                  if (!register_operand (operands[0], E_V8SImode)
                      || !register_operand (operands[1], E_V8SImode)
                      || !(
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3601 (insn, operands);

                case E_V4DImode:
                  if (!register_operand (operands[0], E_V4DImode)
                      || !register_operand (operands[1], E_V4DImode)
                      || !(
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3602 (insn, operands);

                case E_V2TImode:
                  if (!register_operand (operands[0], E_V2TImode)
                      || !register_operand (operands[1], E_V2TImode)
                      || !(
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3603 (insn, operands);

                case E_V8SFmode:
                  if (!register_operand (operands[0], E_V8SFmode)
                      || !register_operand (operands[1], E_V8SFmode)
                      || !(
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 607 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3604 (insn, operands);

                case E_V4DFmode:
                  if (!register_operand (operands[0], E_V4DFmode)
                      || !register_operand (operands[1], E_V4DFmode)
                      || !(
#line 25377 "../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 607 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3605 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 49:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (register_operand (operands[1], E_V8QImode)
                  && 
#line 6829 "../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed
   && SSE_REGNO_P (REGNO (operands[1]))))
                return gen_split_1128 (insn, operands);
              if (GET_CODE (x4) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x4), 0))
                return NULL;
              x7 = XEXP (x4, 0);
              switch (GET_CODE (x7))
                {
                case VEC_MERGE:
                  switch (pattern1085 (x4))
                    {
                    case 0:
                      if (!((
#line 21972 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21974 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3408 (insn, operands);

                    case 1:
                      if (!(
#line 21972 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 21974 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3409 (insn, operands);

                    case 2:
                      if (!((
#line 21972 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21974 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3410 (insn, operands);

                    case 3:
                      if (!((
#line 21972 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 21974 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3411 (insn, operands);

                    default:
                      return NULL;
                    }

                case ASHIFTRT:
                  switch (pattern1086 (x4))
                    {
                    case 0:
                      if (!((
#line 22035 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22037 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3428 (insn, operands);

                    case 1:
                      if (!(
#line 22035 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 22037 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3429 (insn, operands);

                    case 2:
                      if (!((
#line 22035 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22037 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3430 (insn, operands);

                    case 3:
                      if (!((
#line 22035 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22037 "../../gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3431 (insn, operands);

                    default:
                      return NULL;
                    }

                case NOT:
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_VOIDmode))
                    return NULL;
                  switch (GET_MODE (x4))
                    {
                    case E_V32QImode:
                      if (!(
#line 22174 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) == 32) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                        return NULL;
                      return gen_split_3444 (insn, operands);

                    case E_V16QImode:
                      if (!
#line 22174 "../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) == 16))
                        return NULL;
                      return gen_split_3445 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case LT:
              switch (pattern759 (x4))
                {
                case 0:
                  if (!((
#line 21948 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21950 "../../gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3404 (insn, operands);

                case 1:
                  if (!(
#line 21948 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 21950 "../../gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3405 (insn, operands);

                case 2:
                  if (!((
#line 21948 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21950 "../../gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3406 (insn, operands);

                case 3:
                  if (!((
#line 21948 "../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 21950 "../../gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3407 (insn, operands);

                case 4:
                  if (!((
#line 22200 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22202 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3446 (insn, operands);

                case 5:
                  if (!(
#line 22200 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 22202 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3447 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              switch (GET_MODE (x4))
                {
                case E_V32QImode:
                  if (!register_operand (operands[1], E_V32QImode)
                      || !(
#line 22152 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return NULL;
                  return gen_split_3442 (insn, operands);

                case E_V16QImode:
                  if (!register_operand (operands[1], E_V16QImode)
                      || !
#line 22152 "../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return NULL;
                  return gen_split_3443 (insn, operands);

                default:
                  return NULL;
                }

            case VEC_MERGE:
              switch (pattern761 (x4))
                {
                case 0:
                  if (!((
#line 22228 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22230 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3448 (insn, operands);

                case 1:
                  if (!(
#line 22228 "../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 22230 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3449 (insn, operands);

                case 2:
                  if (!(
#line 22356 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 22358 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3457 (insn, operands);

                case 3:
                  if (!(
#line 22370 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 22372 "../../gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3458 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 172:
          if (GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[0], E_V2SImode))
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 8445 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed
   && SSE_REG_P (operands[0])))
            return NULL;
          return gen_split_1520 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern529 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1670 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1697 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1724 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1751 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1778 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1805 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1832 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1886 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1913 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1940 (insn, operands);

        case 11:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1967 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1673 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1700 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1727 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1754 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1781 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1808 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1835 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1889 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1916 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1943 (insn, operands);

        case 23:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1970 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1676 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1703 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1730 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1757 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1784 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1811 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1838 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1865 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1892 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1919 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1946 (insn, operands);

        case 35:
          if (!(
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1973 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2960 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2969 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2978 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2987 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2996 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3005 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3014 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3023 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3032 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3041 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3050 (insn, operands);

        case 47:
          if (!(
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3059 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2318 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2345 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2372 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2399 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2426 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2453 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2480 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2507 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2534 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2561 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2588 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2615 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2321 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2348 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2375 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2402 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2429 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2456 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2483 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2510 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2537 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2564 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2591 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2618 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2324 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2351 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2378 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2405 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2432 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2459 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2486 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2513 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2540 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2567 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2594 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2621 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_77 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      if (GET_MODE (x3) != E_DFmode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return NULL;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !memory_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_DFmode))
        return NULL;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0])
          || !
#line 14822 "../../gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
        return NULL;
      return gen_split_3176 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 147)
        return NULL;
      x7 = XVECEXP (x3, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern1024 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !(
#line 28802 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 28804 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3766 (insn, operands);

        case E_V8SFmode:
          if (pattern1024 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !(
#line 28802 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 28804 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3767 (insn, operands);

        case E_V4DFmode:
          if (pattern1024 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !(
#line 28802 "../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 28804 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3768 (insn, operands);

        case E_V16SImode:
          if (pattern1024 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !((
#line 30145 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30147 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3814 (insn, operands);

        case E_V16SFmode:
          if (pattern1024 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !((
#line 30145 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30147 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3815 (insn, operands);

        case E_V8DFmode:
          if (pattern1024 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !((
#line 30145 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30147 "../../gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3816 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_80 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = split_66 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
      res = split_73 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          res = split_68 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
          res = split_69 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case XOR:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
            case NOT:
              switch (pattern529 (x2))
                {
                case 0:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1679 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1706 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1733 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1760 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1787 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1814 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1841 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1868 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1895 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1922 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1949 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1976 (insn, operands);
                  break;

                case 12:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1682 (insn, operands);
                  break;

                case 13:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1709 (insn, operands);
                  break;

                case 14:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1736 (insn, operands);
                  break;

                case 15:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1763 (insn, operands);
                  break;

                case 16:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1790 (insn, operands);
                  break;

                case 17:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1817 (insn, operands);
                  break;

                case 18:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1844 (insn, operands);
                  break;

                case 19:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1871 (insn, operands);
                  break;

                case 20:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1898 (insn, operands);
                  break;

                case 21:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1925 (insn, operands);
                  break;

                case 22:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1952 (insn, operands);
                  break;

                case 23:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1979 (insn, operands);
                  break;

                case 24:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1685 (insn, operands);
                  break;

                case 25:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1712 (insn, operands);
                  break;

                case 26:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1739 (insn, operands);
                  break;

                case 27:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1766 (insn, operands);
                  break;

                case 28:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1793 (insn, operands);
                  break;

                case 29:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1820 (insn, operands);
                  break;

                case 30:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1847 (insn, operands);
                  break;

                case 31:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1874 (insn, operands);
                  break;

                case 32:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1901 (insn, operands);
                  break;

                case 33:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1928 (insn, operands);
                  break;

                case 34:
                  if (((
#line 13763 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1955 (insn, operands);
                  break;

                case 35:
                  if ((
#line 13763 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1982 (insn, operands);
                  break;

                case 36:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2963 (insn, operands);
                  break;

                case 37:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2972 (insn, operands);
                  break;

                case 38:
                  if ((
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2981 (insn, operands);
                  break;

                case 39:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2990 (insn, operands);
                  break;

                case 40:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2999 (insn, operands);
                  break;

                case 41:
                  if ((
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3008 (insn, operands);
                  break;

                case 42:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3017 (insn, operands);
                  break;

                case 43:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3026 (insn, operands);
                  break;

                case 44:
                  if ((
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3035 (insn, operands);
                  break;

                case 45:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3044 (insn, operands);
                  break;

                case 46:
                  if (((
#line 13932 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3053 (insn, operands);
                  break;

                case 47:
                  if ((
#line 13932 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3062 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              switch (pattern531 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2327 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2354 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2381 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2408 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2435 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2462 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2489 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2516 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2543 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2570 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2597 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2624 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IOR:
              switch (pattern531 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2330 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2357 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2384 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2411 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2438 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2465 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2492 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2519 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2546 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2573 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2600 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2627 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern531 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2333 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2360 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2387 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2414 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2441 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2468 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2495 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2522 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2549 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2576 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2603 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2630 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[1] = x3;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern924 (x2, 
E_V16SImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3328 (insn, operands);
              break;

            case E_V8DImode:
              if (pattern924 (x2, 
E_V8DImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3329 (insn, operands);
              break;

            case E_V64QImode:
              if (pattern924 (x2, 
E_V64QImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3330 (insn, operands);
              break;

            case E_V32QImode:
              if (pattern924 (x2, 
E_V32QImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3331 (insn, operands);
              break;

            case E_V16QImode:
              if (pattern924 (x2, 
E_V16QImode) == 0
                  && (
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3332 (insn, operands);
              break;

            case E_V32HImode:
              if (pattern924 (x2, 
E_V32HImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3333 (insn, operands);
              break;

            case E_V16HImode:
              if (pattern924 (x2, 
E_V16HImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3334 (insn, operands);
              break;

            case E_V8HImode:
              if (pattern924 (x2, 
E_V8HImode) == 0
                  && (
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3335 (insn, operands);
              break;

            case E_V8SImode:
              if (pattern924 (x2, 
E_V8SImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3336 (insn, operands);
              break;

            case E_V4SImode:
              if (pattern924 (x2, 
E_V4SImode) == 0
                  && (
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3337 (insn, operands);
              break;

            case E_V4DImode:
              if (pattern924 (x2, 
E_V4DImode) == 0
                  && ((
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3338 (insn, operands);
              break;

            case E_V2DImode:
              if (pattern924 (x2, 
E_V2DImode) == 0
                  && (
#line 18344 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 18355 "../../gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3339 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x3) == VEC_DUPLICATE)
            {
              switch (pattern592 (x2))
                {
                case 0:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3372 (insn, operands);
                  break;

                case 1:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3373 (insn, operands);
                  break;

                case 2:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3374 (insn, operands);
                  break;

                case 3:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3375 (insn, operands);
                  break;

                case 4:
                  if (
#line 18649 "../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3376 (insn, operands);
                  break;

                case 5:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3377 (insn, operands);
                  break;

                case 6:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3378 (insn, operands);
                  break;

                case 7:
                  if (
#line 18649 "../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3379 (insn, operands);
                  break;

                case 8:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3380 (insn, operands);
                  break;

                case 9:
                  if (
#line 18649 "../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3381 (insn, operands);
                  break;

                case 10:
                  if ((
#line 18649 "../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3382 (insn, operands);
                  break;

                case 11:
                  if (
#line 18649 "../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3383 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  switch (pattern195 ())
    {
    case 0:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1647 (insn, operands);
      break;

    case 1:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1648 (insn, operands);
      break;

    case 2:
      if ((
#line 13733 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1649 (insn, operands);
      break;

    case 3:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1650 (insn, operands);
      break;

    case 4:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1651 (insn, operands);
      break;

    case 5:
      if ((
#line 13733 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1652 (insn, operands);
      break;

    case 6:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1653 (insn, operands);
      break;

    case 7:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1654 (insn, operands);
      break;

    case 8:
      if ((
#line 13733 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1655 (insn, operands);
      break;

    case 9:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1656 (insn, operands);
      break;

    case 10:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1657 (insn, operands);
      break;

    case 11:
      if (((
#line 13733 "../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13737 "../../gcc/config/i386/sse.md"
( 1)))
        return gen_split_1658 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case AND:
      return split_76 (x1, insn);

    case IOR:
      return split_75 (x1, insn);

    case XOR:
      return split_74 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!memory_operand (x2, E_SImode))
        return NULL;
      operands[1] = x2;
      res = peephole2_30 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      operands[0] = x2;
      if (!
#line 27822 "../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((SImode == HImode
       && TARGET_LCP_STALL)
       || (!TARGET_USE_MOV0
          && TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_258 (insn, operands);

    case E_DImode:
      operands[1] = x2;
      if (!memory_operand (operands[1], E_DImode))
        return NULL;
      if (peep2_current_count >= 2)
        {
          x3 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x3) == SET)
            {
              x4 = XEXP (x3, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x5 = XEXP (x3, 0);
                  operands[2] = x5;
                  if (memory_operand (operands[2], E_DImode))
                    {
                      if (peep2_current_count >= 3)
                        {
                          x6 = PATTERN (peep2_next_insn (2));
                          if (pattern1242 (x6, 
E_DImode) == 0
                              && (
#line 27047 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            {
                              *pmatch_len_ = 3;
                              res = gen_peephole2_218 (insn, operands);
                              if (res != NULL_RTX)
                                return res;
                            }
                        }
                      if ((
#line 27063 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_220 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
      if (!(
#line 27076 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_222 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return NULL;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!general_reg_operand (operands[0], E_QImode)
          || !general_reg_operand (operands[1], E_QImode))
        return NULL;
      if (
#line 3395 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_19 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 3407 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_23 (insn, operands);

    case E_HImode:
      if (!general_reg_operand (operands[0], E_HImode)
          || !general_reg_operand (operands[1], E_HImode))
        return NULL;
      if (
#line 3395 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_20 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 3407 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_24 (insn, operands);

    case E_SImode:
      if (!general_reg_operand (operands[0], E_SImode)
          || !general_reg_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 3395 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_21 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 3407 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_25 (insn, operands);

    case E_DImode:
      if (!general_reg_operand (operands[0], E_DImode)
          || !general_reg_operand (operands[1], E_DImode))
        return NULL;
      if ((
#line 3395 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[0])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_22 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!(
#line 3407 "../../gcc/config/i386/i386.md"
(((REGNO (operands[0]) != AX_REG
     && REGNO (operands[1]) != AX_REG)
    || optimize_size < 2
    || !optimize_insn_for_size_p ())
   && peep2_reg_dead_p (1, operands[1])) && 
#line 1161 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_26 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (pattern231 (x4, 
E_CCmode, 
17) != 0)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return NULL;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!nonimmediate_operand (operands[2], E_HImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = XEXP (x7, 1);
  switch (GET_CODE (x9))
    {
    case ZERO_EXTEND:
      if (peep2_current_count < 4)
        return NULL;
      x10 = XEXP (x7, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_VOIDmode))
        return NULL;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1])
          || pattern1736 (x8) != 0)
        return NULL;
      x12 = XEXP (x8, 1);
      x13 = XEXP (x12, 0);
      x14 = XEXP (x13, 0);
      operands[4] = x14;
      if (!register_operand (operands[4], E_QImode))
        return NULL;
      x15 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x15) != SET)
        return NULL;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != IF_THEN_ELSE)
        return NULL;
      x17 = XEXP (x16, 0);
      if (!bt_comparison_operator (x17, E_VOIDmode))
        return NULL;
      operands[5] = x17;
      if (pattern1850 (x15) != 0)
        return NULL;
      x18 = XEXP (x16, 1);
      x19 = XEXP (x18, 0);
      operands[6] = x19;
      if (!
#line 22886 "../../gcc/config/i386/i386.md"
(REGNO (operands[3]) == REGNO (operands[4])
   && peep2_reg_dead_p (3, operands[1])
   && peep2_reg_dead_p (3, operands[3])
   && peep2_regno_dead_p (4, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_195 (insn, operands);

    case COMPARE:
      if (GET_MODE (x9) != E_CCZmode)
        return NULL;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != AND
          || GET_MODE (x11) != E_QImode)
        return NULL;
      x20 = XEXP (x11, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x21 = XEXP (x9, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x10 = XEXP (x7, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || GET_MODE (x10) != E_CCZmode)
        return NULL;
      x22 = XEXP (x11, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_QImode))
        return NULL;
      x12 = XEXP (x8, 1);
      if (GET_CODE (x12) != IF_THEN_ELSE)
        return NULL;
      x13 = XEXP (x12, 0);
      if (!bt_comparison_operator (x13, E_VOIDmode))
        return NULL;
      operands[4] = x13;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 17
          || GET_MODE (x14) != E_CCZmode)
        return NULL;
      x23 = XEXP (x13, 1);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x24 = XEXP (x12, 1);
      if (GET_CODE (x24) != LABEL_REF)
        return NULL;
      x25 = XEXP (x12, 2);
      if (GET_CODE (x25) != PC)
        return NULL;
      x26 = XEXP (x8, 0);
      if (GET_CODE (x26) != PC)
        return NULL;
      x27 = XEXP (x24, 0);
      operands[5] = x27;
      if (!
#line 22919 "../../gcc/config/i386/i386.md"
(REGNO (operands[1]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (2, operands[3])
   && peep2_regno_dead_p (3, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_196 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
      res = peephole2_38 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case CONST_INT:
      res = peephole2_40 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case PLUS:
      res = peephole2_41 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case COMPARE:
      res = peephole2_43 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case MULT:
      res = peephole2_44 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case ASHIFT:
      if (pattern244 (x1) == 0)
        {
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (nonmemory_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && GET_MODE (x3) == E_DImode
                      && nonmemory_operand (operands[1], E_DImode)
                      && (
#line 15349 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_159 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case E_TImode:
                  if (register_operand (operands[0], E_TImode)
                      && GET_MODE (x3) == E_TImode
                      && nonmemory_operand (operands[1], E_TImode)
                      && (
#line 15349 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_160 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case LSHIFTRT:
      switch (pattern246 (x1))
        {
        case 0:
          if ((
#line 16721 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_161 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if ((
#line 16721 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_163 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      break;

    case ASHIFTRT:
      switch (pattern246 (x1))
        {
        case 0:
          if ((
#line 16721 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1235 "../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_162 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if ((
#line 16721 "../../gcc/config/i386/i386.md"
(TARGET_CMOVE) && 
#line 1236 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_164 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      break;

    case NOT:
      if (GET_MODE (x3) == E_DImode)
        {
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) == ZERO_EXTRACT
              && pattern375 (x1) == 0)
            {
              x6 = XEXP (x5, 0);
              if (rtx_equal_p (x6, operands[0]))
                {
                  x7 = XEXP (x5, 2);
                  if (rtx_equal_p (x7, operands[1])
                      && 
#line 19126 "../../gcc/config/i386/i386.md"
(TARGET_64BIT && !TARGET_USE_BT))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_167 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
      break;

    case POPCOUNT:
      res = peephole2_45 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (peep2_current_count >= 2)
    {
      res = peephole2_46 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return NULL;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode)
    return NULL;
  switch (GET_CODE (x3))
    {
    case COMPARE:
    case PLUS:
    case MINUS:
    case MULT:
    case DIV:
    case MOD:
    case UDIV:
    case UMOD:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      operands[3] = x3;
      res = peephole2_47 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x3))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          if (peep2_current_count >= 2)
            {
              res = peephole2_48 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          if (GET_CODE (x3) != PLUS
              || pattern416 (x2) != 0)
            return NULL;
          switch (pattern1432 (x2))
            {
            case 0:
              if ((
#line 28654 "../../gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_355 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28654 "../../gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_356 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_359 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_360 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_375 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_376 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_379 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_380 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28744 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_383 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!(
#line 28744 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_384 (insn, operands);

            case 1:
              if ((
#line 28654 "../../gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_357 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28654 "../../gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_358 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_361 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28666 "../../gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_362 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_377 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28722 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_378 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_381 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28734 "../../gcc/config/i386/i386.md"
(INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_382 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 28744 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_385 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!(
#line 28744 "../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_386 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return NULL;
              if (const359_operand (operands[2], E_SImode))
                {
                  if (register_operand (operands[1], E_SImode))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_388 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 28787 "../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && (!TARGET_PARTIAL_REG_STALL || SImode == SImode)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_390 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (memory_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 28803 "../../gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM32_MEM && optimize_insn_for_speed_p ()
   && !satisfies_constraint_K (operands[2])))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_392 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode)
                  || !
#line 28835 "../../gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM8 && optimize_insn_for_speed_p ()
   && satisfies_constraint_K (operands[2])))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_396 (insn, operands);

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              if (const359_operand (operands[2], E_DImode))
                {
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 28773 "../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   || DImode == SImode
   || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_389 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (nonimmediate_operand (operands[1], E_DImode)
                      && (
#line 28787 "../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && (!TARGET_PARTIAL_REG_STALL || DImode == SImode)) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_391 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (memory_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && (
#line 28803 "../../gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM32_MEM && optimize_insn_for_speed_p ()
   && !satisfies_constraint_K (operands[2])) && 
#line 1167 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_393 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_DImode)
                  || !(
#line 28835 "../../gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM8 && optimize_insn_for_speed_p ()
   && satisfies_constraint_K (operands[2])) && 
#line 1164 "../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_397 (insn, operands);

            case E_HImode:
              if (pattern1337 (x3, 
E_HImode) != 0
                  || !
#line 28835 "../../gcc/config/i386/i386.md"
(TARGET_SLOW_IMUL_IMM8 && optimize_insn_for_speed_p ()
   && satisfies_constraint_K (operands[2])))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_395 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          if (peep2_current_count < 2)
            return NULL;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          x11 = PATTERN (peep2_next_insn (1));
          if (pattern415 (x11, 
PLUS, 
2) != 0)
            return NULL;
          x12 = XVECEXP (x11, 0, 1);
          if (GET_CODE (x12) != CLOBBER)
            return NULL;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 17
              || GET_MODE (x13) != E_CCmode)
            return NULL;
          x14 = XVECEXP (x11, 0, 0);
          x15 = XEXP (x14, 0);
          operands[3] = x15;
          if (!register_operand (operands[3], E_VOIDmode))
            return NULL;
          x16 = XEXP (x14, 1);
          x17 = XEXP (x16, 1);
          operands[4] = x17;
          if (!x86_64_general_operand (operands[4], E_VOIDmode))
            return NULL;
          x18 = XEXP (x16, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return NULL;
          if ((
#line 28867 "../../gcc/config/i386/i386.md"
(IN_RANGE (INTVAL (operands[2]), 1, 3)
   /* Validate MODE for lea.  */
   && ((!TARGET_PARTIAL_REG_STALL
	&& (GET_MODE (operands[0]) == QImode
	    || GET_MODE (operands[0]) == HImode))
       || GET_MODE (operands[0]) == SImode
       || (TARGET_64BIT && GET_MODE (operands[0]) == DImode))
   && (rtx_equal_p (operands[0], operands[3])
       || peep2_reg_dead_p (2, operands[0]))
   /* We reorder load and the shift.  */
   && !reg_overlap_mentioned_p (operands[0], operands[4])) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_398 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 28867 "../../gcc/config/i386/i386.md"
(IN_RANGE (INTVAL (operands[2]), 1, 3)
   /* Validate MODE for lea.  */
   && ((!TARGET_PARTIAL_REG_STALL
	&& (GET_MODE (operands[0]) == QImode
	    || GET_MODE (operands[0]) == HImode))
       || GET_MODE (operands[0]) == SImode
       || (TARGET_64BIT && GET_MODE (operands[0]) == DImode))
   && (rtx_equal_p (operands[0], operands[3])
       || peep2_reg_dead_p (2, operands[0]))
   /* We reorder load and the shift.  */
   && !reg_overlap_mentioned_p (operands[0], operands[4])) && 
#line 1403 "../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_399 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_SImode)
        return NULL;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return NULL;
      x19 = XEXP (x5, 1);
      operands[2] = x19;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 28816 "../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_SLOW_IMUL_IMM32_MEM && optimize_insn_for_speed_p ()
   && !satisfies_constraint_K (operands[2])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_394 (insn, operands);

    default:
      return NULL;
    }
}
